/*
 * consultas.c
 * This file is part of gconta
 *
 * Copyright (C) 2004 Bruno Orcha Garcia
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, 
 * Boston, MA 02111-1307, USA. 
 */

#include "consultas.h"


GtkWidget *
consultas_barra (gpointer window)
{
	GtkWidget *toolbar1;
	gint tmp_toolbar_icon_size;
	GtkWidget *toolbutton1;
	GtkWidget *separatortoolitem1;
	GtkWidget *toolbuttoncerrar;
	
	toolbar1 = gtk_toolbar_new ();
	gtk_widget_show (toolbar1);
	gtk_toolbar_set_style (GTK_TOOLBAR (toolbar1), GTK_TOOLBAR_BOTH_HORIZ);
	tmp_toolbar_icon_size = gtk_toolbar_get_icon_size (GTK_TOOLBAR (toolbar1));
	
	toolbutton1 = (GtkWidget*) gtk_tool_button_new_from_stock ("gtk-find");
	gtk_widget_show (toolbutton1);
	gtk_container_add (GTK_CONTAINER (toolbar1), toolbutton1);
	
	separatortoolitem1 = (GtkWidget*) gtk_separator_tool_item_new ();
	gtk_widget_show (separatortoolitem1);
	gtk_tool_item_set_expand (GTK_TOOL_ITEM (separatortoolitem1), TRUE);
	gtk_container_add (GTK_CONTAINER (toolbar1), separatortoolitem1);
	
	toolbuttoncerrar = (GtkWidget*) gtk_tool_button_new_from_stock ("gtk-close");
	gtk_widget_show (toolbuttoncerrar);
	gtk_container_add (GTK_CONTAINER (toolbar1), toolbuttoncerrar);

	g_signal_connect ((gpointer) toolbutton1, "clicked",
			G_CALLBACK (consultas_barra_buscar), window);

	g_signal_connect ((gpointer) toolbuttoncerrar, "clicked",
			  G_CALLBACK (consultas_barra_cerrar), window);
	
	return toolbar1;
}

GtkWidget *
consultas_child (gpointer window)
{
	GtkWidget *scrolledwindow1;
	GtkWidget *textview1;
	
	scrolledwindow1 = gtk_scrolled_window_new (NULL, NULL);
	gtk_widget_show (scrolledwindow1);
	gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow1), GTK_POLICY_NEVER, GTK_POLICY_ALWAYS);

	textview1 = gtk_text_view_new();	
	gtk_widget_show(textview1);
	gtk_text_view_set_editable(GTK_TEXT_VIEW(textview1), FALSE);
	gtk_text_view_set_wrap_mode(GTK_TEXT_VIEW(textview1), GTK_WRAP_WORD_CHAR);
	gtk_text_view_set_left_margin(GTK_TEXT_VIEW(textview1), 20);
	gtk_text_view_set_right_margin(GTK_TEXT_VIEW(textview1), 20);
	gtk_text_view_set_indent(GTK_TEXT_VIEW(textview1), 10);
	gtk_container_add(GTK_CONTAINER(scrolledwindow1), textview1);

	g_object_set_data(G_OBJECT(scrolledwindow1), "textview1", textview1);

	return scrolledwindow1;
}

void
consultas_barra_cerrar (GtkToolButton * b, gpointer window)
{
	gconta_barra_cerrar(window);
}


void
consultas_barra_buscar	(GtkToolButton *b,
						gpointer window)
{
	gconta_busca_cuenta(window);
}

void
consultas_ver(gchar *cuenta, gpointer window)
{
	GtkWidget *child;
	GtkWidget *textview1;
	GtkTextBuffer *textbuffer;
	GtkTextIter iter;
	GtkTextTag *tag;
	gchar buffer[MAX_BUFFER];
	gchar *nombre;
	gchar *descripcion;
	
	xml_consultas_cuenta(cuenta, &nombre, &descripcion);
	
	if (nombre == NULL || descripcion == NULL) return;
	
	child = gconta_get_child(window);
	textview1 = g_object_get_data(G_OBJECT(child), "textview1");
	textbuffer = gtk_text_view_get_buffer(GTK_TEXT_VIEW(textview1));
		
	g_snprintf(buffer, MAX_BUFFER, "%s. %s\n\n", cuenta, nombre);
	gtk_text_buffer_set_text (textbuffer, "", 0);
	tag = gtk_text_buffer_create_tag (textbuffer, NULL,
			"weight", PANGO_WEIGHT_BOLD, "size", 15 * PANGO_SCALE, NULL);
	gtk_text_buffer_get_iter_at_offset (textbuffer, &iter, 0);	
	gtk_text_buffer_insert_with_tags (textbuffer, &iter, buffer, -1, tag, NULL);
	gtk_text_buffer_insert (textbuffer, &iter, descripcion, -1);
}
