/*
 * diario.c
 * This file is part of gconta
 *
 * Copyright (C) 2004 Bruno Orcha Garcia
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, 
 * Boston, MA 02111-1307, USA. 
 */

#include "diario.h"


GtkWidget *
diario_barra (gpointer window)
{
	GtkWidget *toolbar1;
	gint tmp_toolbar_icon_size;
	GtkWidget *toolbutton1;
	GtkWidget *toolbutton2;
	GtkWidget *toolbutton3;
	GtkWidget *separatortoolitem1;
	GtkWidget *toolbutton4;
	GtkWidget *toolbutton5;
	GtkWidget *separatortoolitem3;
	GtkWidget *toolbutton6;
	GtkWidget *toolitem1;
	GtkWidget *label5;
	GtkWidget *toolitem2;
	GtkWidget *combobox1;
	GtkWidget *toolbutton7;
	GtkWidget *separatortoolitem2;
	GtkWidget *toolbuttoncerrar;
	GtkCellRenderer *renderer;
	GtkListStore *store;

	toolbar1 = gtk_toolbar_new ();
	gtk_widget_show (toolbar1);
	gtk_toolbar_set_style (GTK_TOOLBAR (toolbar1), GTK_TOOLBAR_ICONS);
	tmp_toolbar_icon_size =
		gtk_toolbar_get_icon_size (GTK_TOOLBAR (toolbar1));

	toolbutton1 =
		(GtkWidget *) gtk_tool_button_new_from_stock ("gtk-add");
	gtk_widget_show (toolbutton1);
	gtk_container_add (GTK_CONTAINER (toolbar1), toolbutton1);

	toolbutton2 =
		(GtkWidget *) gtk_tool_button_new_from_stock ("gtk-remove");
	gtk_widget_show (toolbutton2);
	gtk_container_add (GTK_CONTAINER (toolbar1), toolbutton2);

	toolbutton3 =
		(GtkWidget *) gtk_tool_button_new_from_stock ("gtk-clear");
	gtk_widget_show (toolbutton3);
	gtk_container_add (GTK_CONTAINER (toolbar1), toolbutton3);

	toolbutton5 =
		(GtkWidget *) gtk_tool_button_new_from_stock ("gtk-find");
	gtk_widget_show (toolbutton5);
	gtk_container_add (GTK_CONTAINER (toolbar1), toolbutton5);


	separatortoolitem1 = (GtkWidget *) gtk_separator_tool_item_new ();
	gtk_widget_show (separatortoolitem1);
	gtk_container_add (GTK_CONTAINER (toolbar1), separatortoolitem1);

	toolbutton4 =
		(GtkWidget *) gtk_tool_button_new_from_stock ("gtk-save");
	gtk_widget_show (toolbutton4);
	gtk_container_add (GTK_CONTAINER (toolbar1), toolbutton4);

	separatortoolitem3 = (GtkWidget *) gtk_separator_tool_item_new ();
	gtk_widget_show (separatortoolitem3);
	gtk_container_add (GTK_CONTAINER (toolbar1), separatortoolitem3);

	toolbutton6 =
		(GtkWidget *) gtk_tool_button_new_from_stock ("gtk-delete");
	gtk_widget_show (toolbutton6);
	gtk_container_add (GTK_CONTAINER (toolbar1), toolbutton6);



	toolitem1 = (GtkWidget *) gtk_tool_item_new ();
	gtk_widget_show (toolitem1);
	gtk_container_add (GTK_CONTAINER (toolbar1), toolitem1);

	label5 = gtk_label_new (_("Asientos predefinidos"));
	gtk_widget_show (label5);
	gtk_container_add (GTK_CONTAINER (toolitem1), label5);
	gtk_misc_set_padding (GTK_MISC (label5), 6, 0);

	toolitem2 = (GtkWidget *) gtk_tool_item_new ();
	gtk_widget_show (toolitem2);
	gtk_container_add (GTK_CONTAINER (toolbar1), toolitem2);

	store = gtk_list_store_new(1, G_TYPE_STRING);
	xml_diario_predefinidos(store);
	
	combobox1 = gtk_combo_box_new_with_model(GTK_TREE_MODEL(store));
	gtk_widget_show (combobox1);
	gtk_container_add(GTK_CONTAINER(toolitem2), combobox1);

	renderer = gtk_cell_renderer_text_new ();
	gtk_cell_layout_pack_start (GTK_CELL_LAYOUT (combobox1), renderer, TRUE);
	gtk_cell_layout_set_attributes (GTK_CELL_LAYOUT (combobox1), renderer,
									"text", 0,
									NULL);

	toolbutton7 = (GtkWidget *) gtk_tool_button_new_from_stock ("gtk-preferences");
	gtk_widget_show (toolbutton7);
	gtk_container_add (GTK_CONTAINER (toolbar1), toolbutton7);

	separatortoolitem2 = (GtkWidget *) gtk_separator_tool_item_new ();
	gtk_widget_show (separatortoolitem2);
	gtk_tool_item_set_expand (GTK_TOOL_ITEM (separatortoolitem2), TRUE);
	gtk_container_add (GTK_CONTAINER (toolbar1), separatortoolitem2);

	toolbuttoncerrar =
		(GtkWidget *) gtk_tool_button_new_from_stock ("gtk-close");
	gtk_widget_show (toolbuttoncerrar);
	gtk_container_add (GTK_CONTAINER (toolbar1), toolbuttoncerrar);

	g_object_set_data (G_OBJECT (toolbar1), "combobox1", combobox1);

	g_signal_connect ((gpointer) toolbutton1, "clicked",
			  G_CALLBACK (diario_barra_add), window);
	g_signal_connect ((gpointer) toolbutton2, "clicked",
			  G_CALLBACK (diario_barra_remove), window);
	g_signal_connect ((gpointer) toolbutton3, "clicked",
			  G_CALLBACK (diario_barra_limpiar), window);
	g_signal_connect ((gpointer) toolbutton4, "clicked",
			  G_CALLBACK (diario_barra_guardar), window);
	g_signal_connect ((gpointer) toolbutton5, "clicked",
			  G_CALLBACK (diario_barra_buscar), window);
	g_signal_connect ((gpointer) toolbutton6, "clicked",
			  G_CALLBACK (diario_barra_eliminar_cuenta), window);
	g_signal_connect ((gpointer) toolbutton7, "clicked",
			  G_CALLBACK (diario_predefinidos_editar), window);
	g_signal_connect ((gpointer) toolbuttoncerrar, "clicked",
			  G_CALLBACK (diario_barra_cerrar), window);
	g_signal_connect((gpointer) combobox1, "changed",
						G_CALLBACK(diario_barra_combo_changed), window);
			  
	return toolbar1;
}


GtkWidget *
diario_child (gpointer window)
{
	GtkWidget *vpaned1;
	GtkWidget *vbox3;
	GtkWidget *hbox1;
	GtkWidget *label3;
	GtkObject *spinbutton1_adj;
	GtkWidget *spinbutton1;
	GtkWidget *label4;
	GtkWidget *button2;
	GtkWidget *tmp_image;
	GtkWidget *button1;
	GtkWidget *entry1;
	GtkWidget *scrolledwindow2;
	GtkWidget *treeview1;
	GtkWidget *vbox2;
	GtkWidget *label2;
	GtkWidget *scrolledwindow1;
	GtkWidget *textview1;
	GtkCellRenderer *rend;
	GtkTreeViewColumn *col;
	GtkTreeIter iter;
	GtkListStore *store;
	GDate *date1;


	vpaned1 = gtk_vpaned_new ();
	gtk_widget_show (vpaned1);
	gtk_container_set_border_width (GTK_CONTAINER (vpaned1), 6);
	gtk_paned_set_position (GTK_PANED (vpaned1), 280);

	vbox3 = gtk_vbox_new (FALSE, 12);
	gtk_widget_show (vbox3);
	gtk_paned_pack1 (GTK_PANED (vpaned1), vbox3, FALSE, TRUE);

	hbox1 = gtk_hbox_new (FALSE, 12);
	gtk_widget_show (hbox1);
	gtk_box_pack_start (GTK_BOX (vbox3), hbox1, FALSE, TRUE, 0);

	label3 = gtk_label_new (_("<b>Asiento</b>"));
	gtk_widget_show (label3);
	gtk_box_pack_start (GTK_BOX (hbox1), label3, FALSE, FALSE, 0);
	gtk_label_set_use_markup (GTK_LABEL (label3), TRUE);

	spinbutton1_adj = gtk_adjustment_new (1, 1, 10000, 1, 10, 10);
	spinbutton1 = gtk_spin_button_new (GTK_ADJUSTMENT (spinbutton1_adj), 1, 0);
	diario_actualizar_ultimo_asiento(GTK_SPIN_BUTTON(spinbutton1));
	gtk_widget_show (spinbutton1);
	gtk_box_pack_start (GTK_BOX (hbox1), spinbutton1, FALSE, FALSE, 0);

	button2 = gtk_button_new ();
	tmp_image =
		gtk_image_new_from_stock ("gtk-refresh",
					  GTK_ICON_SIZE_BUTTON);
	gtk_widget_show (tmp_image);
	gtk_container_add (GTK_CONTAINER (button2), tmp_image);
	gtk_widget_show (button2);
	gtk_box_pack_start (GTK_BOX (hbox1), button2, FALSE, FALSE, 0);

	label4 = gtk_label_new (_("<b>Fecha</b>"));
	gtk_widget_show (label4);
	gtk_box_pack_start (GTK_BOX (hbox1), label4, FALSE, FALSE, 0);
	gtk_label_set_use_markup (GTK_LABEL (label4), TRUE);

	entry1 = gtk_entry_new_with_max_length (8);
	gtk_entry_set_text (GTK_ENTRY (entry1), "fecha");
	gtk_widget_show (entry1);
	gtk_box_pack_start (GTK_BOX (hbox1), entry1, FALSE, FALSE, 0);

	button1 = gtk_button_new ();
	tmp_image =
		gtk_image_new_from_stock ("gtk-jump-to",
					  GTK_ICON_SIZE_BUTTON);
	gtk_widget_show (tmp_image);
	gtk_container_add (GTK_CONTAINER (button1), tmp_image);
	gtk_widget_show (button1);
	gtk_box_pack_start (GTK_BOX (hbox1), button1, FALSE, FALSE, 0);

	scrolledwindow2 = gtk_scrolled_window_new (NULL, NULL);
	gtk_widget_show (scrolledwindow2);
	gtk_box_pack_start (GTK_BOX (vbox3), scrolledwindow2, TRUE, TRUE, 0);
	gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow2),
					GTK_POLICY_AUTOMATIC,
					GTK_POLICY_AUTOMATIC);

	store = gtk_list_store_new (5, G_TYPE_STRING, G_TYPE_STRING,
				    G_TYPE_STRING, G_TYPE_STRING,
				    G_TYPE_STRING);

	treeview1 = gtk_tree_view_new_with_model (GTK_TREE_MODEL (store));
	gtk_tree_view_set_rules_hint (GTK_TREE_VIEW (treeview1), TRUE);
	gtk_tree_view_set_reorderable (GTK_TREE_VIEW (treeview1), TRUE);
	g_object_unref (G_OBJECT (store));
	gtk_widget_show (treeview1);

	rend = gtk_cell_renderer_text_new ();
	g_object_set (G_OBJECT (rend), "editable", TRUE, NULL);
	col = gtk_tree_view_column_new_with_attributes ("Cuenta", rend,
							"text", 0, NULL);
	gtk_tree_view_column_set_resizable (col, TRUE);
	gtk_tree_view_append_column (GTK_TREE_VIEW (treeview1), col);
	g_signal_connect (rend, "edited", G_CALLBACK (diario_editar_cuenta),
			  treeview1);

	rend = gtk_cell_renderer_text_new ();
	col = gtk_tree_view_column_new_with_attributes ("Nombre", rend,
							"text", 1, NULL);
	gtk_tree_view_column_set_resizable (col, TRUE);
	gtk_tree_view_append_column (GTK_TREE_VIEW (treeview1), col);

	rend = gtk_cell_renderer_text_new ();
	g_object_set_data (G_OBJECT (rend), "col", GINT_TO_POINTER (2));
	g_object_set (G_OBJECT (rend), "xalign", 1.0, "editable", TRUE, NULL);
	col = gtk_tree_view_column_new_with_attributes ("Debe", rend, "text",
							2, NULL);
	gtk_tree_view_append_column (GTK_TREE_VIEW (treeview1), col);
	g_signal_connect (rend, "edited", G_CALLBACK (diario_editar_cuantia),
			  window);


	rend = gtk_cell_renderer_text_new ();
	g_object_set_data (G_OBJECT (rend), "col", GINT_TO_POINTER (3));
	g_object_set (G_OBJECT (rend), "xalign", 1.0, "editable", TRUE, NULL);
	col = gtk_tree_view_column_new_with_attributes ("Haber", rend, "text",
							3, NULL);
	gtk_tree_view_append_column (GTK_TREE_VIEW (treeview1), col);
	g_signal_connect (rend, "edited", G_CALLBACK (diario_editar_cuantia),
			  window);

	rend = gtk_cell_renderer_text_new ();
	col = gtk_tree_view_column_new_with_attributes ("", rend, "text", 4,
							NULL);
	gtk_tree_view_append_column (GTK_TREE_VIEW (treeview1), col);

	gtk_list_store_append (store, &iter);
	gtk_list_store_set (store, &iter, 0, "", 1, "- XXX -", 2, "", 3, "",
			    -1);

	gtk_container_add (GTK_CONTAINER (scrolledwindow2), treeview1);

	vbox2 = gtk_vbox_new (FALSE, 12);
	gtk_widget_show (vbox2);
	gtk_paned_pack2 (GTK_PANED (vpaned1), vbox2, TRUE, TRUE);

	label2 = gtk_label_new (_
				("Introduzca una descripcion del asiento si lo desea:"));
	gtk_widget_show (label2);
	gtk_box_pack_start (GTK_BOX (vbox2), label2, FALSE, TRUE, 0);
	gtk_misc_set_alignment (GTK_MISC (label2), 0, 0.5);

	scrolledwindow1 = gtk_scrolled_window_new (NULL, NULL);
	gtk_widget_show (scrolledwindow1);
	gtk_box_pack_start (GTK_BOX (vbox2), scrolledwindow1, TRUE, TRUE, 0);
	gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow1),
					GTK_POLICY_AUTOMATIC,
					GTK_POLICY_AUTOMATIC);

	textview1 = gtk_text_view_new ();
	gtk_widget_show (textview1);
	gtk_container_add (GTK_CONTAINER (scrolledwindow1), textview1);

	date1 = gconta_date_today(entry1);

	g_object_set_data_full(G_OBJECT (entry1), "fecha", date1, (GDestroyNotify) g_date_free);
	g_object_set_data (G_OBJECT (vpaned1), "treeview", treeview1);
	g_object_set_data (G_OBJECT (vpaned1), "entry1", entry1);
	g_object_set_data (G_OBJECT (vpaned1), "spin", spinbutton1);
	g_object_set_data (G_OBJECT (vpaned1), "textview1", textview1);

	g_signal_connect (button1, "clicked", G_CALLBACK (gconta_seleccionar_fecha), entry1);
	g_signal_connect (button2, "clicked", G_CALLBACK (diario_actualizar), window);
	
	g_signal_connect((gpointer) treeview1, "button-press-event",
						G_CALLBACK(diario_tree_popup), window);

	

	return vpaned1;
}



void
diario_barra_cerrar (GtkToolButton * b, gpointer window)
{
	gconta_barra_cerrar(window);
}

void
diario_barra_limpiar (GtkToolButton * b, gpointer window)
{
	GtkWidget *child;
	GtkTreeView *treeview;
	GtkListStore *store;
	GtkWidget *dialog = NULL;

	if (b != NULL) dialog = create_dialog ("¿Eliminar todas las partidas?", FALSE);
	if (b == NULL || gtk_dialog_run (GTK_DIALOG (dialog)) == GTK_RESPONSE_ACCEPT)
	{
		child = gconta_get_child(window);
		treeview = g_object_get_data (G_OBJECT (child), "treeview");
		store = (GtkListStore *) gtk_tree_view_get_model (treeview);
		gtk_list_store_clear (store);
	}
	if (b != NULL) gtk_widget_destroy (dialog);
}

void
diario_barra_add (GtkToolButton * b, gpointer window)
{
	GtkWidget *child;
	GtkListStore *store;
	GtkTreeView *treeview;
	GtkTreeIter iter;
	GtkTreePath *path;
	GtkTreeViewColumn *col;

	child = gconta_get_child(window);
	
	treeview = g_object_get_data (G_OBJECT (child), "treeview");
	store = (GtkListStore *) gtk_tree_view_get_model (treeview);

	gtk_list_store_append (store, &iter);
	gtk_list_store_set (store, &iter, 0, "", 1, "- XXX -", 2, "", 3, "",
			    -1);
	path = gtk_tree_model_get_path (GTK_TREE_MODEL (store), &iter);
	col = gtk_tree_view_get_column (treeview, 0);
	gtk_tree_view_set_cursor (treeview, path, col, FALSE);
	gtk_widget_grab_focus (GTK_WIDGET (treeview));
}

void
diario_barra_remove (GtkToolButton * b, gpointer window)
{
	GtkWidget *child;
	GtkListStore *store;
	GtkTreeView *treeview;
	GtkTreeIter iter;
	GtkTreePath *path;

	child = gconta_get_child(window);
	treeview = g_object_get_data (G_OBJECT (child), "treeview");
	store = (GtkListStore *) gtk_tree_view_get_model (treeview);

	gtk_tree_view_get_cursor (treeview, &path, NULL);
	if (path != NULL
	    && gtk_tree_model_get_iter (GTK_TREE_MODEL (store), &iter, path))
	{
		gtk_list_store_remove (store, &iter);
		gtk_tree_path_prev (path);
		gtk_tree_view_set_cursor (treeview, path, NULL, FALSE);
		gtk_widget_grab_focus (GTK_WIDGET (treeview));
	}
}


void
diario_editar_cuenta (GtkCellRendererText * cellrenderertext,
		      gchar * path, gchar * text, gpointer treeview)
{
	GtkTreeViewColumn *col;
	GtkTreeModel *store;
	GtkTreeIter iter;
	GtkTreePath *path1;
	gchar buffer[MAX_BUFFER];
	gchar *nombre;
	GdaCommand *cmd;
	GdaDataModel *data;
	GdaValue *v;
	gint i;

	g_assert (GTK_IS_TREE_VIEW (treeview));
	i = (gint) g_ascii_strtod (text, NULL);
	if (i >= 100 && gconta_conectado ())
	{
		g_snprintf (buffer, MAX_BUFFER, "SELECT nombre FROM PGC%d WHERE cuenta = %s",
			   gconta_main.year, text);
		cmd = gda_command_new (buffer, GDA_COMMAND_TYPE_SQL,
				       GDA_COMMAND_OPTION_STOP_ON_ERRORS);
		data = gda_connection_execute_single_command (gconta_main.
							      conn, cmd,
							      NULL);
		gda_command_free (cmd);
		if (data == NULL)
		{
			gconta_errores ();
			return;
		}

		g_snprintf (buffer, MAX_BUFFER, "%d", i);
		if (gda_data_model_get_n_rows (data) == 1)
		{
			v = (GdaValue *) gda_data_model_get_value_at (data, 0,
								      0);
			nombre = gda_value_stringify (v);
			store = gtk_tree_view_get_model (GTK_TREE_VIEW
							 (treeview));
			gtk_tree_model_get_iter_from_string (GTK_TREE_MODEL
							     (store), &iter,
							     path);
			gtk_list_store_set (GTK_LIST_STORE (store), &iter, 0,
					    buffer, 1, nombre, -1);
			g_free (nombre);
			col = gtk_tree_view_get_column (GTK_TREE_VIEW
							(treeview), 2);
			path1 = gtk_tree_path_new_from_string (path);
			gtk_tree_view_set_cursor (GTK_TREE_VIEW (treeview),
						  path1, col, FALSE);
		}
		g_object_unref (G_OBJECT (data));
	}
}

gdouble
diario_sumar (GtkTreeModel * store)
{
	GtkTreeIter iter;
	gchar *s1, *s2;
	gfloat d1, d2;

	d1 = 0;
	d2 = 0;
	if (gtk_tree_model_get_iter_first (store, &iter))
		do
		{
			gtk_tree_model_get (store, &iter, 2, &s1, 3, &s2, -1);
			d1 += g_ascii_strtod (s1, NULL);
			d2 += g_ascii_strtod (s2, NULL);
			g_free (s1);
			g_free (s2);
		}
		while (gtk_tree_model_iter_next (store, &iter));
	else d1 = -1; // Si falla al obtener la primera linea, el asiento es invalido
	
	
	return d1 - d2;
}

void
diario_editar_cuantia (GtkCellRendererText * cellrenderertext,
		       gchar * path, gchar * text, gpointer window)
{
	GtkWidget *child;
	GtkTreeView *treeview;
	GtkTreeModel *store;
	GtkTreeIter iter;
	gchar *s1;
	gchar buffer[MAX_BUFFER];
	gint n, m;
	gdouble valor;


	child = gconta_get_child(window);
	treeview = g_object_get_data (G_OBJECT (child), "treeview");

	/* Solo permito hasta cuatro decimales :S */
	valor = g_ascii_strtod (text, NULL);
	g_snprintf (buffer, MAX_BUFFER, "%.4f", valor);
	valor = g_ascii_strtod (buffer, NULL);

	n = GPOINTER_TO_INT (g_object_get_data
			     (G_OBJECT (cellrenderertext), "col"));
	m = (n == 2) ? 3 : 2;

	store = gtk_tree_view_get_model (GTK_TREE_VIEW (treeview));
	gtk_tree_model_get_iter_from_string (GTK_TREE_MODEL (store), &iter,
					     path);

	if (valor > 0) {
		gtk_list_store_set (GTK_LIST_STORE (store), &iter, n, buffer,
				    m, "", -1);
		
		diario_barra_add(NULL, window);
		return;
	}
	else if (strlen (text) == 0)
	{
		// Poner cuantia automaticamente para cuadrar
		gtk_list_store_set (GTK_LIST_STORE (store), &iter, n, "", -1);
		if (n == 3 && (valor = diario_sumar (store)) != 0)
		{
			gtk_tree_model_get (store, &iter, 2, &s1, -1);
			if (strlen (s1) == 0)
			{
				if (valor < 0)
				{
					valor = ABS (valor);
					n = 2;
					m = 3;
				}
				g_snprintf (buffer, MAX_BUFFER, "%.4f", valor);
				gtk_list_store_set (GTK_LIST_STORE (store),
						    &iter, n, buffer, m, "",
						    -1);
			}
			g_free (s1);
		}
	}

	/* Poner el cursor en la siguiente column de cuantia */
	gtk_tree_view_set_cursor (GTK_TREE_VIEW (treeview),
				  gtk_tree_path_new_from_string (path),
				  gtk_tree_view_get_column (GTK_TREE_VIEW
							    (treeview), m),
				  FALSE);

}

gboolean
diario_barra_guardar_comprobar (GtkTreeModel * model,
				GtkTreePath * path,
				GtkTreeIter * iterm, gpointer val)
{
	gchar *s0;
	gchar *s1;
	GtkTreeIter *iter;
	gboolean esta;

	gtk_tree_model_get (model, iterm, 0, &s0, -1);

	/* Cuenta vacia? */
	if (strlen (s0) == 0)
	{
		g_free (s0);
		*((gint *) val) = 1;
		return TRUE;
	}

	/* Buscar si existen cuentas repetidas */
	iter = gtk_tree_iter_copy (iterm);
	esta = FALSE;
	while (!esta && gtk_tree_model_iter_next (model, iter))
	{
		gtk_tree_model_get (model, iter, 0, &s1, -1);
		if (strcmp (s0, s1) == 0)
			esta = TRUE;
		g_free (s1);
	}
	gtk_tree_iter_free (iter);
	g_free (s0);
	/* Cuenta repetida */
	if (esta)
	{
		*((gint *) val) = 2;
		return TRUE;
	}

	/* Solo una cuantía introducida */
	gtk_tree_model_get (model, iterm, 2, &s0, 3, &s1, -1);
	if (strlen (s0) == 0 && strlen (s1) == 0)
	{
		g_free (s0);
		g_free (s1);
		*((gint *) val) = 3;
		return TRUE;
	}

	/* Abortar si estan escritas las dos */
	if (strlen (s0) != 0 && strlen (s1) != 0)
		g_error ("Dos cuantias");

	return FALSE;
}

gint
diario_ultimo_asiento ()
{
	GdaCommand *cmd;
	GdaDataModel *data;
	GdaValue *v;
	gchar *buf;
	gchar buffer[MAX_BUFFER];
	gint val;

	val = 0;
	if (gconta_conectado ())
	{
		g_snprintf(buffer, MAX_BUFFER, "SELECT MAX(asiento) FROM DIARIO%d", gconta_main.year);
		cmd = gda_command_new (buffer, GDA_COMMAND_TYPE_SQL,
				       GDA_COMMAND_OPTION_STOP_ON_ERRORS);
		data = gda_connection_execute_single_command (gconta_main.conn, cmd,
							      NULL);
		gda_command_free (cmd);
		if (data == NULL)
		{
			gconta_errores ();
			return -1;
		}
		v = (GdaValue *) gda_data_model_get_value_at (data, 0, 0);
		if (gda_value_is_null (v))
			val = 0;
		else
		{
			buf = gda_value_stringify (v);
			val = (gint) g_ascii_strtod (buf, NULL);
			g_free (buf);
		}
		g_object_unref (G_OBJECT (data));
	}
	else
		val = -1;

	return val;
}

void
cambiar_coma(gchar *cuantia)
{
	gint i;
	
	i = strlen(cuantia);
	for(i = 0; i < strlen(cuantia); i++)
		if (cuantia[i] == ',') {
			cuantia[i] = '.';
			break;
		}
}

void
diario_barra_guardar (GtkToolButton * b, gpointer window)
{
	GtkWidget *child;
	GtkWidget *entry;
	GtkTreeView *treeview;
	GtkListStore *store;
	GtkTreeIter iter;
	GtkWidget *dialog;
	GtkSpinButton *spin;

	GtkTextView *textview1;
	GtkTextBuffer *textbuffer;
	GtkTextIter iter1, iter2;

	GdaTransaction *trans;
	GdaCommand *cmd;
	GdaDataModel *data;
	GdaValue *v;

	gchar buffer[MAX_BUFFER], bufferfecha[12], *text, *s0, *s1, *s2;
	gint asiento, n, cuenta;
	gdouble debe, haber;
	GDate *fecha;


	child = gconta_get_child(window);
	treeview = g_object_get_data (G_OBJECT (child), "treeview");
	store = (GtkListStore *) gtk_tree_view_get_model (treeview);
	entry = g_object_get_data (G_OBJECT (child), "entry1");
	fecha = g_object_get_data (G_OBJECT (entry), "fecha");
	spin = g_object_get_data (G_OBJECT (child), "spin");
	textview1 = g_object_get_data (G_OBJECT (child), "textview1");

	/* Comprobar existen partidas */
	if (gtk_tree_model_iter_n_children (GTK_TREE_MODEL (store), NULL) <=
	    1)
	{
		dialog = create_dialog ("Debe añadir mas partidas", TRUE);
		gtk_dialog_run (GTK_DIALOG (dialog));
		gtk_widget_destroy (dialog);
		return;
	}

	n = 0;
	gtk_tree_model_foreach (GTK_TREE_MODEL (store),
				diario_barra_guardar_comprobar, &n);
	switch (n)
	{
	case 1:
		dialog = create_dialog
			("Existen partidas sin cuentas specificadas", TRUE);
		gtk_dialog_run (GTK_DIALOG (dialog));
		gtk_widget_destroy (dialog);
		return;
		break;

	case 2:
		dialog = create_dialog
			("Existen partidas con cuentas repetidas", TRUE);
		gtk_dialog_run (GTK_DIALOG (dialog));
		gtk_widget_destroy (dialog);
		return;
		break;

	case 3:
		dialog = create_dialog ("Existen partidas sin cuantía",
					TRUE);
		gtk_dialog_run (GTK_DIALOG (dialog));
		gtk_widget_destroy (dialog);
		return;
		break;
	}
	
	if (diario_sumar (GTK_TREE_MODEL (store)) != 0.0)
	{
		dialog = create_dialog ("El asiento no cuadra (Debe = Haber)",
					TRUE);
		gtk_dialog_run (GTK_DIALOG (dialog));
		gtk_widget_destroy (dialog);
		return;
	}

	/* Comprobar que el asiento es valido y la fecha es la del ejercicio */
	/* Usar ISO-8601 para gurdar la fecha AAAA-MM-DD */
	/* mysql 4.0 no soporta subconsultas :'''( */
	g_return_if_fail (gconta_conectado ());

	/* Asiento  */
	asiento = gtk_spin_button_get_value_as_int (spin);
	if (diario_ultimo_asiento () + 1 < asiento)
	{
		dialog = create_dialog ("El numero de asiento es incorrecto", TRUE);
		gtk_dialog_run (GTK_DIALOG (dialog));
		gtk_widget_destroy (dialog);
		return;
	}

	// comprobar asiento libre
	g_snprintf (buffer, MAX_BUFFER, "SELECT * FROM DIARIO%d WHERE asiento = %d", gconta_main.year, asiento);
	cmd = gda_command_new (buffer, GDA_COMMAND_TYPE_SQL, GDA_COMMAND_OPTION_STOP_ON_ERRORS);
	data = gda_connection_execute_single_command (gconta_main.conn, cmd, NULL);
	gda_command_free (cmd);
	if (data == NULL) {
		gconta_errores ();
		return;
	}
	v = (GdaValue *) gda_data_model_get_value_at (data, 0, 0);
	if (v != NULL) {
		dialog = create_dialog("Ya existe un asiento con ese número", TRUE);
		gtk_dialog_run (GTK_DIALOG (dialog));
		gtk_widget_destroy (dialog);
		g_object_unref(data);
		return;
	}
	g_object_unref(G_OBJECT(data));
	
	// Fecha dentro del ejercicio¿?
	if (g_date_compare (fecha, gconta_main.ejercicio_ini) < 0 || 
			g_date_compare (fecha, gconta_main.ejercicio_fin) > 0)
	{
		dialog = create_dialog
			("La fecha debe estar dentro del ejercicio",
			 TRUE);
		gtk_dialog_run (GTK_DIALOG (dialog));
		gtk_widget_destroy (dialog);
		return;
	}

	// comprobar transacciones
	if (!gda_connection_supports(gconta_main.conn,
		GDA_CONNECTION_FEATURE_TRANSACTIONS))
	{
		dialog = create_dialog ("El SGBD no soporta transacciones!!", TRUE);
		gtk_dialog_run (GTK_DIALOG (dialog));
		gtk_widget_destroy (dialog);
		return;
	}
	
	/* comienza transaccion */
	trans = gda_transaction_new ("asiento");
	gda_transaction_set_isolation_level (trans,
					     GDA_TRANSACTION_ISOLATION_SERIALIZABLE);
	if (!gda_connection_begin_transaction (gconta_main.conn, trans)) {
		gconta_errores ();
		dialog = create_dialog ("No se pudo comenzar la transacción", TRUE);
		gtk_dialog_run (GTK_DIALOG (dialog));
		gtk_widget_destroy (dialog);
		return;
	}

	/* Insertar en DIARIO */
	g_date_strftime (bufferfecha, 11, "%Y-%m-%d", fecha);
	g_snprintf (buffer, MAX_BUFFER,
		   "INSERT INTO DIARIO%d (asiento, fecha) VALUES (%d, '%s')",
			gconta_main.year, asiento, bufferfecha);
	GCONTA_nonquery(buffer, "Ocurrió un error al guardar el asiento", trans);
	
	/* Si hay algo en descripcion insertar en DIARIO_DESCRIPCION */
	textbuffer = gtk_text_view_get_buffer (textview1);
	if (gtk_text_buffer_get_char_count (textbuffer) > 0)
	{
		gtk_text_buffer_get_bounds (textbuffer, &iter1, &iter2);
		text = gtk_text_buffer_get_text (textbuffer, &iter1, &iter2,
						 FALSE);
		g_snprintf (buffer, MAX_BUFFER,
			   "INSERT INTO DIARIO_DESCRIPCION%d (asiento, descripcion) VALUES (%d, '%s')",
			   gconta_main.year, asiento, text);
		g_free (text);
		GCONTA_nonquery(buffer, "Ocurrió un error al guardar la descripción", trans);
	}

	if (!gtk_tree_model_get_iter_first (GTK_TREE_MODEL(store), &iter))
	{
		gda_connection_rollback_transaction (gconta_main.conn, trans);
		g_object_unref (trans);
		return;
	}

	do
	{
		gtk_tree_model_get (GTK_TREE_MODEL(store), &iter, 0, &s0, 2, &s1, 3, &s2, -1);
		cuenta = (gint) g_ascii_strtod (s0, NULL);
		debe = g_ascii_strtod (s1, NULL);
		haber = g_ascii_strtod (s2, NULL);
		cambiar_coma(s1);
		cambiar_coma(s2);
		if (haber == 0)
			g_snprintf (buffer, MAX_BUFFER,
				   "INSERT INTO DIARIO_DEBE%d  (asiento, cuenta, cuantia) VALUES (%d, %d, %s)",
				   gconta_main.year, asiento, cuenta, s1);
		else
			g_snprintf (buffer, MAX_BUFFER,
				   "INSERT INTO DIARIO_HABER%d (asiento, cuenta, cuantia) VALUES (%d, %d, %s)",
				   gconta_main.year, asiento, cuenta, s2);
		GCONTA_nonquery(buffer, "Ocurrió un error al guardar una partida", trans);
		g_free (s0);
		g_free (s1);
		g_free (s2);
		
	}
	while (gtk_tree_model_iter_next (GTK_TREE_MODEL(store), &iter));
	

	gda_connection_commit_transaction (gconta_main.conn, trans);
	g_object_unref (trans);
	
	/* Limpiar asiento */
	diario_barra_limpiar(NULL, window);
	
	gtk_text_buffer_set_text(textbuffer, "", -1);
	
	/* Actualizar ultimo asiento */
	diario_actualizar_ultimo_asiento(spin);
	
	/* Añadir una partida */
	diario_barra_add(NULL, window);
}

void
diario_barra_buscar (GtkToolButton * b, gpointer window)
{
	GtkWidget *child;
	
	child = gconta_get_child(window);
	gconta_busca_cuenta (GTK_WINDOW (window));
}


void
diario_actualizar_ultimo_asiento(GtkSpinButton * spinbutton1)
{
	gint n;
	
	n = diario_ultimo_asiento() + 1;
	gtk_spin_button_set_range(spinbutton1, 1.0, (gdouble) n);
	gtk_spin_button_set_value(spinbutton1, (gdouble) n);
}

gboolean
diario_tree_popup	(GtkWidget *treeview,
					GdkEventButton *event,
            	    gpointer window)
{
	GtkWidget * menu, * menuitem;
	GtkWidget * tmp_image;
	
	if (event->type == GDK_BUTTON_PRESS  &&  event->button == 3) {
		menu = gtk_menu_new();
		
		menuitem = gtk_image_menu_item_new_with_label("Añadir");
		tmp_image =	gtk_image_new_from_stock ("gtk-add", GTK_ICON_SIZE_MENU);
		gtk_image_menu_item_set_image(GTK_IMAGE_MENU_ITEM(menuitem), tmp_image);
		gtk_menu_shell_append(GTK_MENU_SHELL(menu), menuitem);
		g_signal_connect(menuitem, "activate",
							G_CALLBACK(diario_barra_add), window);

		menuitem = gtk_image_menu_item_new_with_label("Eliminar");
		tmp_image =	gtk_image_new_from_stock ("gtk-remove", GTK_ICON_SIZE_MENU);
		gtk_image_menu_item_set_image(GTK_IMAGE_MENU_ITEM(menuitem), tmp_image);
		gtk_menu_shell_append(GTK_MENU_SHELL(menu), menuitem);
		g_signal_connect(menuitem, "activate",
							G_CALLBACK(diario_barra_remove), window);

		menuitem = gtk_image_menu_item_new_with_label("Ver Mayor");
		tmp_image =	gtk_image_new_from_stock ("gtk-justify-center", GTK_ICON_SIZE_MENU);
		gtk_image_menu_item_set_image(GTK_IMAGE_MENU_ITEM(menuitem), tmp_image);
		gtk_menu_shell_append(GTK_MENU_SHELL(menu), menuitem);
		g_signal_connect(menuitem, "activate",
							G_CALLBACK(diario_barra_ver_mayor), window);

		menuitem = gtk_image_menu_item_new_with_label("Ver Descripcion");
		tmp_image =	gtk_image_new_from_stock ("gtk-dialog-question", GTK_ICON_SIZE_MENU);
		gtk_image_menu_item_set_image(GTK_IMAGE_MENU_ITEM(menuitem), tmp_image);
		gtk_menu_shell_append(GTK_MENU_SHELL(menu), menuitem);
		g_signal_connect(menuitem, "activate",
							G_CALLBACK(diario_barra_ver_descripcion), window);

		menuitem = gtk_image_menu_item_new_with_label("Buscar cuenta");
		tmp_image =	gtk_image_new_from_stock ("gtk-find", GTK_ICON_SIZE_MENU);
		gtk_image_menu_item_set_image(GTK_IMAGE_MENU_ITEM(menuitem), tmp_image);
		gtk_menu_shell_append(GTK_MENU_SHELL(menu), menuitem);
		g_signal_connect(menuitem, "activate",
							G_CALLBACK(diario_barra_buscar), window);

		gtk_widget_show_all(menu);
		gtk_menu_popup(GTK_MENU(menu), NULL, NULL, NULL, NULL,
						(event != NULL) ? event->button : 0,
						gdk_event_get_time((GdkEvent*)event));
	}
	
	return FALSE;
}

void
diario_barra_ver_mayor 	(GtkToolButton *b,
						gpointer window)
{
	GtkWidget *child;
	GtkEntry *entry1;
	GtkTreeView *treeview;
	GtkTreeModel *store;
	GtkTreePath *path;
	GtkTreeIter iter;
	gchar *s0;
	gchar buffer[MAX_BUFFER];
	gint n;
	
	child = gconta_get_child(window);
	treeview = g_object_get_data(G_OBJECT(child), "treeview");
		
	gtk_tree_view_get_cursor(treeview, &path, NULL);
	if (path != NULL) {
		store = gtk_tree_view_get_model(treeview);
		gtk_tree_model_get_iter(store, &iter, path);
		gtk_tree_model_get(store, &iter, 0, &s0, -1);
		n = g_ascii_strtod(s0, NULL);
		g_free(s0);
		
		if (n >= 100) {
			g_snprintf(buffer, MAX_BUFFER, "%d", n);
			boton_mayor(NULL, window);
			child = gconta_get_child(window);
			entry1 = g_object_get_data(G_OBJECT(child), "entry1");
			gtk_entry_set_text(entry1, buffer);
			mayor_ver(window);
		}
	}
}

void
diario_barra_ver_descripcion 	(GtkToolButton *b,
								gpointer window)
{
	GtkWidget *child;
	GtkTreeView *treeview;
	GtkTreeModel *store;
	GtkTreePath *path;
	GtkTreeIter iter;
	gchar *s0;
	gchar buffer[MAX_BUFFER];
	gint n;
	
	child = gconta_get_child(window);
	treeview = g_object_get_data(G_OBJECT(child), "treeview");
		
	gtk_tree_view_get_cursor(treeview, &path, NULL);
	if (path != NULL) {
		store = gtk_tree_view_get_model(treeview);
		gtk_tree_model_get_iter(store, &iter, path);
		gtk_tree_model_get(store, &iter, 0, &s0, -1);
		n = g_ascii_strtod(s0, NULL);
		g_free(s0);
		
		if (n >= 100) {
			g_snprintf(buffer, MAX_BUFFER, "%d", n);
			boton_consultas(NULL, window);
			consultas_ver(buffer, window);
		}
	}
}

void
diario_actualizar	(GtkButton *b,
					gpointer window)
{
	// Traer asiento y mostrarlo, descativar guardar
	GtkWidget *child;
	GtkWidget *dialog;
	GtkSpinButton *spin;
	GtkEntry *entry;
	GtkTextView *textview;
	GtkTextBuffer *textbuffer;
	GdaCommand *cmd;
	GdaDataModel *data;
	GdaValue *v;
	GDate *date;
	GtkListStore *store;
	GtkTreeView *treeview;
	GtkTreeIter iter;
	GtkTreePath *path, *path1;
	GtkTreeViewColumn *col;
	GList *l;
	gchar buffer[MAX_BUFFER];
	gchar buffer2[11];
	gchar *t, *text_path, *cuenta;
	gint i, asiento;
	gdouble valor, debe, haber;

	child = gconta_get_child(window);
	spin = g_object_get_data (G_OBJECT(child), "spin");
	entry = g_object_get_data (G_OBJECT(child), "entry1");
	textview = g_object_get_data (G_OBJECT (child), "textview1");
	treeview = g_object_get_data (G_OBJECT (child), "treeview");
	store = (GtkListStore *) gtk_tree_view_get_model (treeview);
	diario_barra_limpiar (NULL, window);
	
	asiento = gtk_spin_button_get_value_as_int(spin);
	
	// Obtenemos la fecha
	g_snprintf(buffer, MAX_BUFFER, "SELECT fecha FROM DIARIO%d WHERE asiento = %d", gconta_main.year, asiento);
	cmd = gda_command_new(buffer, GDA_COMMAND_TYPE_SQL, GDA_COMMAND_OPTION_STOP_ON_ERRORS);
	data = gda_connection_execute_single_command(gconta_main.conn, cmd, NULL);
	if (data == NULL) {
		gconta_errores();
		return;
	}
	v = (GdaValue *) gda_data_model_get_value_at(data, 0, 0);
	if (v == NULL || gda_value_is_null(v)) {
		dialog = create_dialog("El asiento especificado no existe", TRUE);
		gtk_dialog_run(GTK_DIALOG(dialog));
		gtk_widget_destroy(dialog);
		g_object_unref(G_OBJECT(data));
		return;
	}
	t = gda_value_stringify(v);
	g_object_unref(G_OBJECT(data));
	date = g_date_new();
	g_date_set_parse(date, t);
	g_free(t);
	g_date_strftime(buffer2, 11, "%d/%m/%y", date);
	g_date_free(date);
	gtk_entry_set_text(entry, buffer2);
	
	// Partidas
	g_snprintf(buffer, MAX_BUFFER,	"SELECT cuenta, cuantia, 0 FROM DIARIO_DEBE%d "
			"WHERE asiento = %d UNION SELECT cuenta, 0, cuantia FROM DIARIO_HABER%d "
			"WHERE asiento = %d ORDER BY 3", gconta_main.year, asiento, gconta_main.year, asiento);
	cmd = gda_command_new(buffer, GDA_COMMAND_TYPE_SQL, GDA_COMMAND_OPTION_STOP_ON_ERRORS);
	data = gda_connection_execute_single_command(gconta_main.conn, cmd, NULL);
	gda_command_free(cmd);
	if (data == NULL) {
		gconta_errores();
		return;
	}
	for(i = 0; i < gda_data_model_get_n_rows(data); i++) {
		// Cuenta
		v = (GdaValue *) gda_data_model_get_value_at(data, 0, i);
		cuenta = gda_value_stringify(v);
		// debe
		v = (GdaValue *) gda_data_model_get_value_at(data, 1, i);
		t = gda_value_stringify(v);
		debe = g_strtod(t, NULL);
		g_free(t);
		// haber
		v = (GdaValue *) gda_data_model_get_value_at(data, 2, i);
		t = gda_value_stringify(v);
		haber = g_strtod(t, NULL);
		g_free(t);
		
		// Añado la linea de la partida
		gtk_list_store_append (store, &iter);
		gtk_list_store_set (store, &iter, 0, "", 1, "- XXX -", 2, "", 3, "", -1);
		path = gtk_tree_model_get_path (GTK_TREE_MODEL (store), &iter);
		text_path = gtk_tree_path_to_string(path);
		
		// Edito la cuenta
		col = gtk_tree_view_get_column (treeview, 0);
		l = gtk_tree_view_column_get_cell_renderers (col);
		diario_editar_cuenta(l->data, text_path, cuenta, treeview);
		g_list_free(l);
		
		// Edito la cuantia
		if (debe > 0) col = gtk_tree_view_get_column (treeview, 2);
		else col = gtk_tree_view_get_column (treeview, 3);
		valor = (debe > 0) ? debe : haber;
		g_snprintf(buffer, MAX_BUFFER, "%.4f", valor);
		l = gtk_tree_view_column_get_cell_renderers (col);
		diario_editar_cuantia(l->data, text_path, buffer, window);
		g_list_free(l);
		
		// Al editar correctamente una cuantia se añade una partida
		// automaticamente, eliminarla si la ultima mesa - XXX -
		// comprobar el cursor con el iter siguiente al ultimo

		gtk_tree_view_get_cursor (treeview, &path1, NULL);
		if (gtk_tree_path_compare(path, path1) != 0)
			diario_barra_remove(NULL, window);
		
		g_free(cuenta);
	}		
	g_object_unref(G_OBJECT(data));

	// DESCRIPCION
	g_snprintf(buffer, MAX_BUFFER, "SELECT descripcion FROM DIARIO_DESCRIPCION%d WHERE asiento = %d", gconta_main.year, asiento);
	cmd = gda_command_new(buffer, GDA_COMMAND_TYPE_SQL, GDA_COMMAND_OPTION_STOP_ON_ERRORS);
	data = gda_connection_execute_single_command(gconta_main.conn, cmd, NULL);
	if (data == NULL) {
		gconta_errores();
		return;
	}
	v = (GdaValue *) gda_data_model_get_value_at(data, 0, 0);
	if (v != NULL && !gda_value_is_null(v)) {
		t = gda_value_stringify(v);
		textbuffer = gtk_text_view_get_buffer(textview);
		gtk_text_buffer_set_text(textbuffer, t, -1);
		g_free(t);
	}
	
	
}

void
diario_barra_eliminar_cuenta	(GtkToolButton *b,
								gpointer window)
{
	GtkWidget *child;
	GtkWidget *dialog;
	GtkSpinButton *spin;
	GdaTransaction *trans;
	gchar buffer[MAX_BUFFER];
	gint asiento, val;
	
	child = gconta_get_child(window);
	spin = g_object_get_data (G_OBJECT(child), "spin");
	asiento = gtk_spin_button_get_value_as_int(spin);

	
	g_snprintf(buffer, MAX_BUFFER, 	"Ha elegido eliminar el asiento nº %d.\n"
									"Al eliminar un asiento podría ocurrir desajustes negativos\n"
									"en las cuentas de tesorería. Si es consciente de que estos\n"
									"desajustes no se poducirán puede continuar.", asiento);
	dialog = create_dialog(buffer, TRUE);
	gtk_dialog_run(GTK_DIALOG(dialog));
	gtk_widget_destroy(dialog);

	dialog = create_dialog("¿Esta seguro que desea eliminar el asiento?", FALSE);
	val = gtk_dialog_run(GTK_DIALOG(dialog));
	gtk_widget_destroy(dialog);
	if (val != GTK_RESPONSE_ACCEPT) return;

	if (!gda_connection_supports(gconta_main.conn,
		GDA_CONNECTION_FEATURE_TRANSACTIONS))
	{
		dialog = create_dialog ("El SGBD no soporta transacciones!!", TRUE);
		gtk_dialog_run (GTK_DIALOG (dialog));
		gtk_widget_destroy (dialog);
		return;
	}
	
	/* comienza transaccion */
	trans = gda_transaction_new ("diarioborrar");
	gda_transaction_set_isolation_level (trans,
						 GDA_TRANSACTION_ISOLATION_SERIALIZABLE);
	if (!gda_connection_begin_transaction (gconta_main.conn, trans)) {
		gconta_errores ();
		dialog = create_dialog ("No se pudo comenzar la transacción para eliminar", TRUE);
		gtk_dialog_run (GTK_DIALOG (dialog));
		gtk_widget_destroy (dialog);
		return;
	}
	
	g_snprintf(buffer, MAX_BUFFER, "DELETE FROM DIARIO_DESCRIPCION%d WHERE asiento = %d", gconta_main.year, asiento);
	GCONTA_nonquery(buffer, "Ocurrió un error al eliminar la descripcion", trans);

	g_snprintf(buffer, MAX_BUFFER, "DELETE FROM DIARIO_DEBE%d WHERE asiento = %d", gconta_main.year, asiento);
	GCONTA_nonquery(buffer, "Ocurrió un error al eliminar del Debe", trans);

	g_snprintf(buffer, MAX_BUFFER, "DELETE FROM DIARIO_HABER%d WHERE asiento = %d", gconta_main.year, asiento);
	GCONTA_nonquery(buffer, "Ocurrió un error al eliminar del Haber", trans);

	g_snprintf(buffer, MAX_BUFFER, "DELETE FROM DIARIO%d WHERE asiento = %d", gconta_main.year, asiento);
	GCONTA_nonquery(buffer, "Ocurrió un error al eliminar del asiento", trans);

	if (!gda_connection_commit_transaction (gconta_main.conn, trans)) {
		g_object_unref (trans);
		gconta_errores();
		dialog = create_dialog ("No se pudo completar la transacción", TRUE);
		gtk_widget_destroy(dialog);
		return;
	}
	g_object_unref (trans);
	
	child = gconta_get_child(window);
	spin = g_object_get_data (G_OBJECT (child), "spin");
	diario_actualizar_ultimo_asiento(spin);
}
