/*
 * diario.h
 * This file is part of gconta
 *
 * Copyright (C) 2004 Bruno Orcha Garcia
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, 
 * Boston, MA 02111-1307, USA. 
 */

#ifndef _DIARIO_H_
#define _DIARIO_H_

#include <gtk/gtk.h>
#include "principal.h"

typedef struct _tsimb {
	char * var;
	char * question;
	gdouble val;
} tsimb;

typedef struct _tpartidas {
	char * cuenta;
	char * cuantia;
	gboolean debe;
} tpartidas;

typedef struct _tpredefinido {
	gchar *nombre;
	GList *ts;
	GList *tp;
} tpredefinido;

GtkWidget * diario_barra (gpointer window);
GtkWidget * diario_child (gpointer window);
void diario_barra_cerrar (GtkToolButton * b, gpointer user_data);
void diario_barra_limpiar (GtkToolButton *b, gpointer window);
void diario_barra_add (GtkToolButton *b, gpointer window);
void diario_barra_remove (GtkToolButton *b, gpointer window);
void diario_barra_guardar (GtkToolButton *b, gpointer window);
void diario_barra_eliminar_cuenta (GtkToolButton *b, gpointer window);
void diario_barra_buscar (GtkToolButton *b, gpointer window);
void diario_barra_combo_changed (GtkComboBox *combobox, gpointer window);

void diario_editar_cuenta (GtkCellRendererText *cellrenderertext, gchar *arg1, gchar *arg2, gpointer user_data);
void diario_editar_cuantia (GtkCellRendererText *cellrenderertext, gchar *path, gchar *text, gpointer treeview);

gint diario_ultimo_asiento();

void diario_actualizar_ultimo_asiento(GtkSpinButton *spin);

gboolean diario_tree_popup (GtkWidget *treeview, GdkEventButton *event, gpointer window);
void diario_barra_ver_mayor (GtkToolButton *b, gpointer window);
void diario_barra_ver_descripcion (GtkToolButton *b, gpointer window);

void diario_actualizar (GtkButton *b, gpointer window);

void diario_predefinidos_add_partidas(gpointer window);
void diario_predefinidos_rellenar_variables();
void diario_predefinidos_resolver_cuantias ();
int diario_predefinidos_anasin();
void diario_predefinidos_editar (GtkToolButton *b, gpointer window);
void diario_predefinidos_editar_combo(GtkComboBox *b, gpointer *window1);

void diario_predefinidos_editar_add(GtkToolButton *b, gpointer *window);
void diario_predefinidos_editar_remove(GtkToolButton *b, gpointer *window);
void diario_predefinidos_editar_boton_exit(GtkButton *b, gpointer window);
gboolean diario_predefinidos_editar_exit(GtkWidget *w, GdkEvent *event, gpointer window);
void diario_predefinidos_editar_col (GtkCellRendererText * cellrenderertext, gchar * path, gchar * text, gpointer treeview);
void diario_predefinidos_editar_save (GtkButton *b, gpointer window);
void diario_predefinidos_editar_guardar_cambios (gpointer window);
void diario_predefinidos_editar_question (GtkCellRendererText * cellrenderertext, gchar * path, gchar * text, gpointer treeview);
void diario_predefinidos_editar_new (GtkButton *b, gpointer window);
void diario_predefinidos_editar_eliminar (GtkButton *b, gpointer window);



#endif
