/*
 * informes.c
 * This file is part of gconta
 *
 * Copyright (C) 2004 Bruno Orcha Garcia
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, 
 * Boston, MA 02111-1307, USA. 
 */

#include "informes.h"
#include <libgtkhtml/gtkhtml.h>

GtkWidget *
informes_barra (gpointer window)
{
	GtkWidget *toolbar1;
	gint tmp_toolbar_icon_size;
	GtkWidget *toolbutton1;
	GtkWidget *toolbutton2;
	GtkWidget *toolitem1;
	GtkWidget *label1;
	GtkWidget *toolitem2;
	GtkWidget *combobox1;
	GtkWidget *separatortoolitem1;
	GtkWidget *toolbuttoncerrar;
	GtkCellRenderer *renderer;
	GtkListStore *store;

	toolbar1 = gtk_toolbar_new ();
	gtk_widget_show (toolbar1);
	gtk_toolbar_set_style (GTK_TOOLBAR (toolbar1), GTK_TOOLBAR_ICONS);
	tmp_toolbar_icon_size =
		gtk_toolbar_get_icon_size (GTK_TOOLBAR (toolbar1));

	toolbutton1 =
		(GtkWidget *) gtk_tool_button_new_from_stock ("gtk-save");
	gtk_widget_show (toolbutton1);
	gtk_container_add (GTK_CONTAINER (toolbar1), toolbutton1);

	toolbutton2 =
		(GtkWidget *) gtk_tool_button_new_from_stock ("gtk-print");
	gtk_widget_show (toolbutton2);
	gtk_container_add (GTK_CONTAINER (toolbar1), toolbutton2);

	toolitem1 = (GtkWidget *) gtk_tool_item_new ();
	gtk_widget_show (toolitem1);
	gtk_container_add (GTK_CONTAINER (toolbar1), toolitem1);

	label1 = gtk_label_new (_("Informe a mostrar"));
	gtk_widget_show (label1);
	gtk_container_add (GTK_CONTAINER (toolitem1), label1);
	gtk_misc_set_padding (GTK_MISC (label1), 6, 0);

	toolitem2 = (GtkWidget *) gtk_tool_item_new ();
	gtk_widget_show (toolitem2);
	gtk_container_add (GTK_CONTAINER (toolbar1), toolitem2);

	store = gtk_list_store_new(1, G_TYPE_STRING);
	xml_informes(store);
	
	combobox1 = gtk_combo_box_new_with_model(GTK_TREE_MODEL(store));
	gtk_widget_show (combobox1);
	gtk_container_add(GTK_CONTAINER(toolitem2), combobox1);

	renderer = gtk_cell_renderer_text_new ();
	gtk_cell_layout_pack_start (GTK_CELL_LAYOUT (combobox1), renderer, TRUE);
	gtk_cell_layout_set_attributes (GTK_CELL_LAYOUT (combobox1), renderer,
									"text", 0,
									NULL);

	separatortoolitem1 = (GtkWidget *) gtk_separator_tool_item_new ();
	gtk_widget_show (separatortoolitem1);
	gtk_tool_item_set_expand (GTK_TOOL_ITEM (separatortoolitem1), TRUE);
	gtk_container_add (GTK_CONTAINER (toolbar1), separatortoolitem1);

	toolbuttoncerrar =
		(GtkWidget *) gtk_tool_button_new_from_stock ("gtk-close");
	gtk_widget_show (toolbuttoncerrar);
	gtk_container_add (GTK_CONTAINER (toolbar1), toolbuttoncerrar);

	g_object_set_data(G_OBJECT(toolbar1), "combobox1", combobox1);

	g_signal_connect ((gpointer) toolbutton1, "clicked",
			  G_CALLBACK (informes_barra_guardar), window);
	g_signal_connect ((gpointer) toolbutton2, "clicked",
			  G_CALLBACK (informes_barra_imprimir), window);
	g_signal_connect ((gpointer) toolbuttoncerrar, "clicked",
			  G_CALLBACK (informes_barra_cerrar), window);
	g_signal_connect((gpointer) combobox1, "changed",
						G_CALLBACK(informes_barra_combo_changed), window);
			  
	return toolbar1;

	
}

GtkWidget *
informes_child (gpointer window)
{
	GtkWidget *vbox1;
	GtkWidget *label1;
	GtkWidget *scrolledwindow1;
	GtkWidget *html_view1;
	HtmlDocument *document;
	GString *st = NULL;
	GList *informe = NULL;
	
	vbox1 = gtk_vbox_new (FALSE, 12);
	gtk_widget_show (vbox1);
	gtk_box_set_spacing(GTK_BOX(vbox1), 12);
	gtk_container_set_border_width (GTK_CONTAINER (vbox1), 6);
		
	label1 = gtk_label_new ("");
	gtk_widget_show (label1);
	gtk_box_pack_start (GTK_BOX (vbox1), label1, FALSE, FALSE, 0);
	gtk_label_set_use_markup (GTK_LABEL (label1), TRUE);
	
	scrolledwindow1 = gtk_scrolled_window_new (NULL, NULL);
	gtk_widget_show (scrolledwindow1);
	gtk_box_pack_start (GTK_BOX (vbox1), scrolledwindow1, TRUE, TRUE, 0);
	gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow1), GTK_POLICY_AUTOMATIC, GTK_POLICY_ALWAYS);
	
	document = html_document_new ();
	html_document_clear (document);
	html_view1 = html_view_new();
	gtk_widget_show(html_view1);
	html_view_set_document (HTML_VIEW (html_view1), document);

	g_object_set_data(G_OBJECT(vbox1), "label1", label1);
	g_object_set_data(G_OBJECT(vbox1), "document", document);
	g_object_set_data(G_OBJECT(vbox1), "buffer", st);
	g_object_set_data(G_OBJECT(vbox1), "informe", informe);

	gtk_container_add(GTK_CONTAINER(scrolledwindow1), html_view1);

	return vbox1;
}

void
informes_liberar_informe(GList *l)
{
	GList *node;
	tinforme *tip;
	
	for(node = g_list_first(l); node != NULL; node = g_list_next(node)) {
		tip = (tinforme *) node->data;
		if (tip->cuentas != NULL) g_free(tip->cuentas);
		if (tip->texto != NULL) g_free(tip->texto);
		if (tip->var != NULL) g_free(tip->var);
		if (tip->hijos != NULL) informes_liberar_informe(tip->hijos);
		g_free(tip);
	}
	g_list_free(l);
}

void
informes_barra_cerrar (GtkToolButton * b, gpointer window)
{
	GtkWidget *child;
	GList *l;
	GString *st;
	
	child = gconta_get_child(window);
	l = g_object_get_data(G_OBJECT(child), "informe");
	st = g_object_get_data(G_OBJECT(child), "buffer");
	informes_liberar_informe(l);
	if (st != NULL) g_string_free(st, TRUE);
	gconta_barra_cerrar(window);
}


gboolean
informes_analiza_get_value(GList *l, gchar *var, gdouble *valor)
{
	tinforme *tip;
	
	for(l = g_list_first(l); l != NULL; l = g_list_next(l)) {
		tip = (tinforme *) l->data;
		if (tip->var != NULL && !strcmp(tip->var, var)) {
			if (tip->ok) {
				*valor = tip->valor;
				return TRUE;
			} else return FALSE;
		}
	}
	
	g_warning("Variable no encontrada!");
	return FALSE;
}

void
informes_analiza(GList *l)
{
	GList *node;
	gdouble valor, total;
	gboolean ok, restar, faltan;
	gchar **vars, *var;
	gint i;
	tinforme *tip;
	
	faltan = 1;
	while(faltan > 0) {
		faltan = 0;
		for(node = g_list_first(l); node != NULL; node = g_list_next(node)) {
			tip = (tinforme *) node->data;
			if (!tip->ok) { // Vamos a resolver esa variable
				vars = g_strsplit(tip->cuentas, " ", 0);
				total = 0.0;
				i = 0;
				ok = TRUE;
				while(ok && vars[i] != NULL) {
					if (g_str_has_prefix(vars[i], "-")) {
						var = &(vars[i][1]);
						restar = TRUE;
					} else {
						var = vars[i];
						restar = FALSE;
					}
					ok = informes_analiza_get_value(l, var, &valor);
					if (ok) {
						if (restar) total -= valor;
						else total += valor;
					}
					i++;
				}
				if (ok) {
					g_free(tip->cuentas);
					tip->cuentas = NULL;
					tip->valor = total;
					tip->ok = TRUE;
				} else faltan++;
			}
		}
	}
}


void
informes_barra_combo_changed (GtkComboBox *combobox,
							gpointer window)
{
	GtkWidget *child;
	GtkWidget *bar;
	GtkComboBox *combo;
	GtkListStore *store;
	GtkTreeIter iter;
	gchar *buffer;
	GList * informe;
			
	child = gconta_get_child(window);
	bar = g_object_get_data(G_OBJECT(child), "barra");
	combo = g_object_get_data(G_OBJECT(bar), "combobox1");
	store = (GtkListStore*) gtk_combo_box_get_model(combo);
	if (gtk_combo_box_get_active_iter(combo, &iter)) {
		gtk_tree_model_get(GTK_TREE_MODEL(store), &iter, 0, &buffer, -1);
		if (strlen(buffer) == 0) {
			g_free(buffer);
			return;
		}
		
		informe = NULL;
		xml_informes_llenar(&informe, buffer);
		g_free(buffer);
		informes_analiza(informe);
		informes_mostar_html(informe, window);
		g_object_set_data(G_OBJECT(child), "informe", informe);
	} else g_error("No se pudo adquirir el iter del combo\n");
}

void
informes_add_textos(GList *informe, GString **st, gint pad)
{
	GList *node;
	tinforme *ti;
	gchar *buffer, *cuentas, *texto;
	gdouble val;



	for (node = g_list_first(informe); node != NULL; node = g_list_next(node)) {
		ti = (tinforme *) node->data;
		// Distinguir entre salto y datos
		
		if (ti->var == NULL) { // Salto
			buffer = g_strdup_printf(
					"</table><br /><br /><br /><table border=\"0\" cellspacing=\"0\" width=\"100%%\"><tr>"
					"<td class=\"top\" width=\"24%%\">Numero de cuenta</td>"
					"<td class=\"top\" width=\"50%%\">%s</td>"
					"<td class=\"top\" width=\"13%%\">Ejercicio Actual</td>"
					"<td class=\"top\" width=\"13%%\">Ejercicio Anterior</td></tr>",
					ti->texto);
			*st = g_string_append(*st, buffer);
			g_free(buffer);
		} else {
			if (ti->valor == 0) val = 0.0; // Evitar q aparezca el -0.0000 !!
			else val = ti->valor;
	
			if (ti->cuentas != NULL) cuentas = ti->cuentas;
			else cuentas = "";
			
			if (ti->bold) {
				texto = g_strdup_printf("<b>%s</b>", ti->texto);
				buffer = g_strdup_printf(
					"<tr><td class=\"suma\"></td>"
					"<td class=\"suma\" style=\"padding-left: %dpx;\">%s</td>"
					"<td class=\"suma\" style=\"text-align: right\">%.4f</td>"
					"<td class=\"suma\" style=\"text-align: right\"></td></tr>\n",
					20 * (1 + pad), texto, val);
				g_free(texto);
			} else {
				buffer = g_strdup_printf(
					"<tr><td class=\"cuentas\">%s</td>"
					"<td style=\"padding-left: %dpx;\">%s</td>"
					"<td class=\"cuantia\">%.4f</td>"
					"<td class=\"cuantia\"></td></tr>\n",
					cuentas, 20 * (1 + pad), ti->texto, val);
			}
			
			
			*st = g_string_append(*st, buffer);
			g_free(buffer);
			if (ti->hijos != NULL) informes_add_textos(ti->hijos, st, pad + 1);
		}
	}
	
}

void
informes_mostar_html(GList *informe, gpointer window)
{
	HtmlDocument *document;
	GtkWidget *child;
	GString *st;
	gchar *filename, *pagina;
	gint len;
	
	child = gconta_get_child(window);
	filename = gconta_uri("gconta-informes-head.html");
	if (g_file_get_contents (filename, &pagina, &len, NULL)) {
		st = g_object_get_data(G_OBJECT(child), "buffer");
		if (st != NULL) g_string_free(st, TRUE);
		st = g_string_new(pagina);
		g_free(pagina);
		
		informes_add_textos(informe, &st, 0);		
		
		g_string_append(st, "</table></body></html>");
		document = g_object_get_data(G_OBJECT(child), "document");	
		html_document_clear(document);
		html_document_open_stream (document, "text/html");
		html_document_write_stream (document, st->str, st->len);
		html_document_close_stream (document);
		
		g_object_set_data(G_OBJECT(child), "buffer", st);
	} else g_warning("No se pudo abrir fichero de cabecera de informes");
	g_free(filename);
}


void
informes_barra_guardar (GtkToolButton *b,
						gpointer window)
{
	GtkWidget *child;
	GtkWidget *dialog;
	GIOChannel *file;
	GString *st;
	gchar *t;
	gint len;

	child = gconta_get_child(window);
	st = g_object_get_data(G_OBJECT(child), "buffer");

	if (st == NULL) return;
	
	dialog = gtk_file_chooser_dialog_new ("Seleccione un nombre de archivo",
				      GTK_WINDOW(window),
				      GTK_FILE_CHOOSER_ACTION_SAVE,
				      GTK_STOCK_CANCEL, GTK_RESPONSE_CANCEL,
				      GTK_STOCK_SAVE, GTK_RESPONSE_ACCEPT,
				      NULL);
	if (gtk_dialog_run(GTK_DIALOG(dialog)) == GTK_RESPONSE_ACCEPT) {
		t = gtk_file_chooser_get_filename(GTK_FILE_CHOOSER(dialog));
		if (t == NULL) {
			gtk_widget_destroy(dialog);
			return;
		}
		if (g_file_test(t, G_FILE_TEST_EXISTS)) {
			child = create_dialog("El fichero ya existe. ¿Desea sobre escribirlo?", FALSE);
			if (gtk_dialog_run(GTK_DIALOG(child)) != GTK_RESPONSE_OK) {
				gtk_widget_destroy(child);
				gtk_widget_destroy(dialog);
				return;
			}
		}
		file = g_io_channel_new_file (t, "w", NULL);
		if (file == NULL) {
			child = create_dialog("Fallo al crear el fichero.\nCompruebe que tiene permiso.", TRUE);
			gtk_dialog_run(GTK_DIALOG(child));
			gtk_widget_destroy(child);
			gtk_widget_destroy(dialog);
			return;
		}
		if (g_io_channel_write_chars(file, st->str, st->len, &len, NULL) != G_IO_STATUS_NORMAL) {
			child = create_dialog("Fallo al guardar el archivo", TRUE);
			gtk_dialog_run(GTK_DIALOG(child));
			gtk_widget_destroy(child);
			gtk_widget_destroy(dialog);
			return;
		}
		g_io_channel_close(file);
	}
	gtk_widget_destroy(dialog);
	
}



void
informes_cabecera_tabla (gconta_print *gp, tinforme *ti)
{
	GnomeFont *font;
	gdouble wf, x;
	gint l, max;
	
	font = gnome_font_find_closest ("Sans Bold", 10);
	wf = gnome_font_get_size(font);
	gnome_print_setfont (gp->gpc, font);

	// Almaceno la posición de la primera linea
	gp->y1 = gp->y + wf;
	gnome_print_line_stroked(gp->gpc, gp->margen, gp->y + wf, gp->xsize - gp->margen, gp->y + wf);
	
	x = gp->margen;
	max = gconta_poner_texto(gp, font, x, 100, 0, "Número de cuentas");
	
	x = gp->margen + 100;
	l = gconta_poner_texto(gp, font, x, 250, 0, ti->texto);
	max = MAX(max, l);
	
	x = gp->xsize - gp->margen - 147.5;
	l = gconta_poner_texto(gp, font, x, 70, 1, "Ejercicio Actual");
	max = MAX(max, l);
	
	x = gp->xsize - gp->margen - 72.5;
	l = gconta_poner_texto(gp, font, x, 70, 1, "Ejercicio Anterior");
	max = MAX(max, l);
	g_object_unref(G_OBJECT(font));
	gp->y -= max * wf;

	gnome_print_line_stroked(gp->gpc, gp->margen, gp->y + wf - 5, gp->xsize - gp->margen, gp->y + wf - 5);
	
	gp->y -= 10;
}

void
informes_cerrar_tabla(gconta_print *gp)
{
	gnome_print_line_stroked(gp->gpc, gp->margen, gp->y1, gp->margen, gp->y);
	gnome_print_line_stroked(gp->gpc, gp->margen + 100, gp->y1, gp->margen + 100, gp->y);
	gnome_print_line_stroked(gp->gpc, gp->xsize - gp->margen - 150, gp->y1, gp->xsize - gp->margen - 150, gp->y);
	gnome_print_line_stroked(gp->gpc, gp->xsize - gp->margen - 75, gp->y1, gp->xsize - gp->margen - 75, gp->y);
	gnome_print_line_stroked(gp->gpc, gp->xsize - gp->margen, gp->y1, gp->xsize - gp->margen, gp->y);
	gnome_print_line_stroked(gp->gpc, gp->margen, gp->y, gp->xsize - gp->margen, gp->y);
}

void
informes_print_textos	(gconta_print *gp,
						GList *informe,
						gdouble pad)
{
	GList *node;
	gchar *buffer;
	tinforme *ti;
	gdouble wf;
	GnomeFont *font;
	gint max, l;

	for (node = g_list_first(informe); node != NULL; node = g_list_next(node)) {
		ti = (tinforme *) node->data;
		if (ti->var == NULL) { // Salto
			if (gp->page > 0) {
				informes_cerrar_tabla(gp);
				gnome_print_showpage(gp->gpc);
				gnome_print_beginpage(gp->gpc, NULL);
				gp->y = gp->ysize - gp->margen;
			}
			gp->page ++;
			
			informes_cabecera_tabla(gp, ti);
			
		} else {
			if (gp->y < gp->margen) informes_salto_de_pagina(gp);

			if (ti->bold) font = gnome_font_find_closest ("Sans Bold", 9);
			else font = gnome_font_find_closest ("Sans Regular", 9);
			wf = gnome_font_get_size(font);
			gnome_print_setfont (gp->gpc, font);

			// Cuentas
			max = 0;
			if (ti->cuentas != NULL) {
				l = gconta_poner_texto(gp, font, gp->margen + 2.5, 95, 0, ti->cuentas);
				max = MAX(max, l);
			}

			// Texto
			l = gconta_poner_texto(gp, font, gp->margen + 105 + pad * 20, 245 - pad * 20, -1, ti->texto);
			max = MAX(max, l);
			
			// Valor
			if (ti->valor == 0) buffer = g_strdup_printf("0.0000");
			else buffer = g_strdup_printf("%.4f", ti->valor);
			l = gconta_poner_texto(gp, font, gp->xsize - gp->margen - 147.5, 70, 1, buffer);
			max = MAX(max, l);
			g_free(buffer);

			g_object_unref(G_OBJECT(font));
			gp->y -= max * wf;

			if (ti->hijos != NULL)
				informes_print_textos(gp, ti->hijos, pad + 1);
			if (!pad) gp->y -= wf;
		}
	}
}



void
informes_barra_imprimir(GtkToolButton *b, gpointer window)
{
	GtkWidget *child;
	GtkWidget *bar;
	GtkComboBox *combo;
	GtkListStore *store;
	GtkTreeIter iter;
	GList *informe;
	GnomePrintJob *job;
	GnomePrintConfig *config;
	gconta_print *gp;
	gchar *buffer;
	
	child = gconta_get_child(window);
	informe = g_object_get_data(G_OBJECT(child), "informe");	
	
	if (informe == NULL) return;

	
	child = gconta_get_child(window);
	bar = g_object_get_data(G_OBJECT(child), "barra");
	combo = g_object_get_data(G_OBJECT(bar), "combobox1");
	store = (GtkListStore*) gtk_combo_box_get_model(combo);
	if (gtk_combo_box_get_active_iter(combo, &iter)) {
		gtk_tree_model_get(GTK_TREE_MODEL(store), &iter, 0, &buffer, -1);
		if (strlen(buffer) == 0) {
			g_free(buffer);
			return;
		}
	} else return;

	// Inicialiamos gp
	gp = g_new(gconta_print, 1);
	job = gnome_print_job_new (NULL);
	gp->gpc = gnome_print_job_get_context (job);
	config = gnome_print_job_get_config (job);
	gnome_print_config_get_page_size(config, &(gp->xsize), &(gp->ysize));
	gp->page = 0;
	gp->margen = 50.0;
	gp->y = gp->ysize - gp->margen;
	
	gnome_print_beginpage(gp->gpc, NULL);
	gconta_cabecera_empresa(gp, buffer);
	informes_print_textos(gp, informe, 0);
	informes_cerrar_tabla(gp);
	gnome_print_showpage (gp->gpc);
	gnome_print_job_close (job);

	gconta_imprimir_dialog(job, "Informe");
	
	g_free(buffer);
	g_object_unref (G_OBJECT (config));
	g_object_unref (G_OBJECT (gp->gpc));
}

void
informes_salto_de_pagina(gconta_print * gp)
{
	gnome_print_line_stroked(gp->gpc, gp->margen, gp->y1, gp->margen, gp->y);
	gnome_print_line_stroked(gp->gpc, gp->margen + 100, gp->y1, gp->margen + 100, gp->y);
	gnome_print_line_stroked(gp->gpc, gp->xsize - gp->margen - 150, gp->y1, gp->xsize - gp->margen - 150, gp->y);
	gnome_print_line_stroked(gp->gpc, gp->xsize - gp->margen - 75, gp->y1, gp->xsize - gp->margen - 75, gp->y);
	gnome_print_line_stroked(gp->gpc, gp->xsize - gp->margen, gp->y1, gp->xsize - gp->margen, gp->y);

	gnome_print_showpage(gp->gpc);
	gnome_print_beginpage(gp->gpc, NULL);
	gp->y = gp->ysize - gp->margen;
	gp->y1 = gp->y + 15;
	gp->page ++;
}
