/*
 * informes.h
 * This file is part of gconta
 *
 * Copyright (C) 2004 Bruno Orcha Garcia
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, 
 * Boston, MA 02111-1307, USA. 
 */

#ifndef _INFORMES_H_
#define _INFORMES_H_

#include <gtk/gtk.h>
#include <libgnomeprint/gnome-print.h>
#include <libgnomeprint/gnome-print-job.h>
#include <libgnomeprintui/gnome-print-dialog.h>
#include <libgnomeprintui/gnome-print-job-preview.h>
#include "principal.h"

typedef struct {
	gchar *cuentas; // En un primer escaneo aki se guarda la expresion de los nodos suma
	gboolean bold;
	gchar *texto; 
	gchar *var; // If texto == NULL --> salto de pagina
	gdouble valor;
	gdouble valor_ant;
	gboolean ok;
	GList *hijos;
} tinforme;

GtkWidget * informes_barra (gpointer window);
GtkWidget * informes_child (gpointer window);
void informes_barra_cerrar (GtkToolButton * b, gpointer user_data);
void informes_barra_combo_changed (GtkComboBox *combobox, gpointer window);
void informes_barra_guardar (GtkToolButton *b, gpointer window);
void informes_barra_imprimir(GtkToolButton *b, gpointer window);

void informes_mostar_html(GList *informe, gpointer window);

void informes_salto_de_pagina(gconta_print *gp);
void informes_print_textos	(gconta_print *gp, GList *informe, gdouble pad);
void informes_cerrar_tabla(gconta_print *gp);
void informes_cabecera_tabla (gconta_print *gp, tinforme *ti);
void informes_imprimir_response (GtkWidget *dialog, int response, GnomePrintJob *job);
gboolean informes_preview_exit(GtkWidget *wp, GtkWidget *dialog);

#endif
