/*
 * listados.c
 * This file is part of gconta
 *
 * Copyright (C) 2004 Bruno Orcha Garcia
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, 
 * Boston, MA 02111-1307, USA. 
 */

#include "listados.h"
#include <libgtkhtml/gtkhtml.h>


GtkWidget *
listados_barra (gpointer window)
{
	GtkWidget *toolbar1;
	gint tmp_toolbar_icon_size;
	GtkWidget *toolbutton1;
	GtkWidget *toolbutton2;
	GtkWidget *toolbutton3;
	GtkWidget *toolbutton4;
	GtkWidget *separatortoolitem1;
	GtkWidget *separatortoolitem2;
	GtkWidget *toolbuttoncerrar;
	
	toolbar1 = gtk_toolbar_new ();
	gtk_widget_show (toolbar1);
	gtk_toolbar_set_style (GTK_TOOLBAR (toolbar1), GTK_TOOLBAR_BOTH_HORIZ);
	tmp_toolbar_icon_size = gtk_toolbar_get_icon_size (GTK_TOOLBAR (toolbar1));
	
	toolbutton1 = (GtkWidget*) gtk_tool_button_new_from_stock ("gtk-justify-center");
	gtk_widget_show (toolbutton1);
	gtk_container_add (GTK_CONTAINER (toolbar1), toolbutton1);
	
	toolbutton2 = (GtkWidget*) gtk_tool_button_new_from_stock ("gtk-copy");
	gtk_widget_show (toolbutton2);
	gtk_container_add (GTK_CONTAINER (toolbar1), toolbutton2);

	separatortoolitem2 = (GtkWidget*) gtk_separator_tool_item_new ();
	gtk_widget_show (separatortoolitem2);
	gtk_container_add (GTK_CONTAINER (toolbar1), separatortoolitem2);
	
	toolbutton3 = (GtkWidget*) gtk_tool_button_new_from_stock ("gtk-save");
	gtk_widget_show (toolbutton3);
	gtk_container_add (GTK_CONTAINER (toolbar1), toolbutton3);

	toolbutton4 = (GtkWidget*) gtk_tool_button_new_from_stock ("gtk-print");
	gtk_widget_show (toolbutton4);
	gtk_widget_set_sensitive(toolbutton4, FALSE);
	gtk_container_add (GTK_CONTAINER (toolbar1), toolbutton4);

	separatortoolitem1 = (GtkWidget*) gtk_separator_tool_item_new ();
	gtk_widget_show (separatortoolitem1);
	gtk_tool_item_set_expand (GTK_TOOL_ITEM (separatortoolitem1), TRUE);
	gtk_container_add (GTK_CONTAINER (toolbar1), separatortoolitem1);
	
	toolbuttoncerrar = (GtkWidget*) gtk_tool_button_new_from_stock ("gtk-close");
	gtk_widget_show (toolbuttoncerrar);
	gtk_container_add (GTK_CONTAINER (toolbar1), toolbuttoncerrar);

	g_signal_connect ((gpointer) toolbutton1, "clicked",
			  G_CALLBACK (listados_barra_diario), window);
	g_signal_connect ((gpointer) toolbutton2, "clicked",
			  G_CALLBACK (listados_barra_mayor), window);
 
	g_signal_connect ((gpointer) toolbutton3, "clicked",
			  G_CALLBACK (listados_barra_guardar), window);
  	g_signal_connect ((gpointer) toolbutton4, "clicked",
			  G_CALLBACK (listados_barra_imprimir), window);
	g_signal_connect ((gpointer) toolbuttoncerrar, "clicked",
			  G_CALLBACK (listados_barra_cerrar), window);
	
	return toolbar1;
}

GtkWidget *
listados_child (gpointer window)
{
	GtkWidget *vbox1;
	GtkWidget *label1;
	GtkWidget *scrolledwindow1;
	GtkWidget *html_view1;
	HtmlDocument *document;
	GString *st = NULL;
	
	vbox1 = gtk_vbox_new (FALSE, 12);
	gtk_widget_show (vbox1);
	gtk_box_set_spacing(GTK_BOX(vbox1), 12);
	gtk_container_set_border_width (GTK_CONTAINER (vbox1), 6);
		
	label1 = gtk_label_new ("");
	gtk_widget_show (label1);
	gtk_box_pack_start (GTK_BOX (vbox1), label1, FALSE, FALSE, 0);
	gtk_label_set_use_markup (GTK_LABEL (label1), TRUE);
	
	scrolledwindow1 = gtk_scrolled_window_new (NULL, NULL);
	gtk_widget_show (scrolledwindow1);
	gtk_box_pack_start (GTK_BOX (vbox1), scrolledwindow1, TRUE, TRUE, 0);
	gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow1), GTK_POLICY_AUTOMATIC, GTK_POLICY_ALWAYS);
	
	document = html_document_new ();
	html_document_clear (document);
	html_view1 = html_view_new();
	gtk_widget_show(html_view1);
	html_view_set_document (HTML_VIEW (html_view1), document);

	g_object_set_data(G_OBJECT(vbox1), "label1", label1);
	g_object_set_data(G_OBJECT(vbox1), "document", document);
	g_object_set_data(G_OBJECT(vbox1), "buffer", st);

	gtk_container_add(GTK_CONTAINER(scrolledwindow1), html_view1);

	return vbox1;
}


GtkWidget*
listados_diario_dialog (void)
{
	GtkWidget *dialog1;
	GtkWidget *dialog_vbox1;
	GtkWidget *vbox1;
	GtkWidget *label1;
	GtkWidget *radiobutton1;
	GSList *radiobutton1_group = NULL;
	GtkWidget *hbox1;
	GtkWidget *label4;
	GtkWidget *label2;
	GtkWidget *entry1;
	GtkWidget *radiobutton2;
	GtkWidget *hbox2;
	GtkWidget *label5;
	GtkWidget *entry2;
	GtkWidget *button1;
	GtkWidget *image2;
	GtkWidget *entry3;
	GtkWidget *button2;
	GtkWidget *image1;
	GtkWidget *radiobutton3;
	GtkWidget *hbox3;
	GtkWidget *label6;
	GtkWidget *label3;
	GtkWidget *entry4;
	GtkWidget *dialog_action_area1;
	GtkWidget *cancelbutton1;
	GtkWidget *okbutton1;
	GDate *date1;
	
	dialog1 = gtk_dialog_new ();
	gtk_window_set_title (GTK_WINDOW (dialog1), _("Listado de diario"));
	gtk_window_set_type_hint (GTK_WINDOW (dialog1), GDK_WINDOW_TYPE_HINT_DIALOG);
	
	dialog_vbox1 = GTK_DIALOG (dialog1)->vbox;
	gtk_widget_show (dialog_vbox1);
	
	vbox1 = gtk_vbox_new (FALSE, 12);
	gtk_widget_show (vbox1);
	gtk_box_pack_start (GTK_BOX (dialog_vbox1), vbox1, TRUE, TRUE, 0);
	gtk_container_set_border_width (GTK_CONTAINER (vbox1), 6);
	
	label1 = gtk_label_new (_("<b>Seleccione que asientos mostrar</b>"));
	gtk_widget_show (label1);
	gtk_box_pack_start (GTK_BOX (vbox1), label1, FALSE, FALSE, 0);
	gtk_label_set_use_markup (GTK_LABEL (label1), TRUE);
	
	radiobutton1 = gtk_radio_button_new_with_label (NULL, _("Listar los siguientes asientos (se permiten rangos)"));
	gtk_widget_show (radiobutton1);
	gtk_box_pack_start (GTK_BOX (vbox1), radiobutton1, FALSE, FALSE, 0);
	radiobutton1_group = gtk_radio_button_get_group (GTK_RADIO_BUTTON (radiobutton1));
	
	hbox1 = gtk_hbox_new (FALSE, 12);
	gtk_widget_show (hbox1);
	gtk_box_pack_start (GTK_BOX (vbox1), hbox1, FALSE, TRUE, 0);
	gtk_widget_set_sensitive (hbox1, FALSE);
	
	label4 = gtk_label_new ("");
	gtk_widget_show (label4);
	gtk_box_pack_start (GTK_BOX (hbox1), label4, FALSE, FALSE, 0);
	gtk_widget_set_size_request (label4, 50, -1);
	
	label2 = gtk_label_new (_("Asientos:"));
	gtk_widget_show (label2);
	gtk_box_pack_start (GTK_BOX (hbox1), label2, FALSE, FALSE, 0);
	
	entry1 = gtk_entry_new ();
	gtk_widget_show (entry1);
	gtk_box_pack_start (GTK_BOX (hbox1), entry1, TRUE, TRUE, 0);
	
	radiobutton2 = gtk_radio_button_new_with_label (radiobutton1_group, _("Listar asientos entre dos fechas"));
	gtk_widget_show (radiobutton2);
	gtk_box_pack_start (GTK_BOX (vbox1), radiobutton2, FALSE, FALSE, 0);
	radiobutton1_group = gtk_radio_button_get_group(GTK_RADIO_BUTTON(radiobutton2));
	
	hbox2 = gtk_hbox_new (FALSE, 12);
	gtk_widget_show (hbox2);
	gtk_box_pack_start (GTK_BOX (vbox1), hbox2, FALSE, TRUE, 0);
	
	label5 = gtk_label_new ("");
	gtk_widget_show (label5);
	gtk_box_pack_start (GTK_BOX (hbox2), label5, FALSE, FALSE, 0);
	gtk_widget_set_size_request (label5, 50, -1);
	
	entry2 = gtk_entry_new ();
	gtk_widget_show (entry2);
	gtk_box_pack_start (GTK_BOX (hbox2), entry2, TRUE, TRUE, 0);
	date1 = gconta_date_today(entry2);
	g_object_set_data_full(G_OBJECT(entry2), "fecha", date1, (GDestroyNotify) g_date_free);
	
	button1 = gtk_button_new ();
	gtk_widget_show (button1);
	gtk_box_pack_start (GTK_BOX (hbox2), button1, FALSE, FALSE, 0);
	
	image2 = gtk_image_new_from_stock ("gtk-jump-to", GTK_ICON_SIZE_BUTTON);
	gtk_widget_show (image2);
	gtk_container_add (GTK_CONTAINER (button1), image2);
	
	entry3 = gtk_entry_new ();
	gtk_widget_show (entry3);
	gtk_box_pack_start (GTK_BOX (hbox2), entry3, TRUE, TRUE, 0);
	date1 = gconta_date_today(entry3);
	g_object_set_data_full(G_OBJECT(entry3), "fecha", date1, (GDestroyNotify) g_date_free);


	button2 = gtk_button_new ();
	gtk_widget_show (button2);
	gtk_box_pack_start (GTK_BOX (hbox2), button2, FALSE, FALSE, 0);
	
	image1 = gtk_image_new_from_stock ("gtk-jump-to", GTK_ICON_SIZE_BUTTON);
	gtk_widget_show (image1);
	gtk_container_add (GTK_CONTAINER (button2), image1);
	
	radiobutton3 = gtk_radio_button_new_with_label (radiobutton1_group, _("Listar los últimos n asientos"));
	gtk_widget_show (radiobutton3);
	gtk_box_pack_start (GTK_BOX (vbox1), radiobutton3, FALSE, FALSE, 0);
	
	hbox3 = gtk_hbox_new (FALSE, 12);
	gtk_widget_show (hbox3);
	gtk_box_pack_start (GTK_BOX (vbox1), hbox3, TRUE, TRUE, 0);
	
	label6 = gtk_label_new ("");
	gtk_widget_show (label6);
	gtk_box_pack_start (GTK_BOX (hbox3), label6, FALSE, FALSE, 0);
	gtk_widget_set_size_request (label6, 50, -1);
	
	label3 = gtk_label_new (_("Numero de asientos a mostrar"));
	gtk_widget_show (label3);
	gtk_box_pack_start (GTK_BOX (hbox3), label3, FALSE, FALSE, 0);
	
	entry4 = gtk_entry_new ();
	gtk_entry_set_text(GTK_ENTRY(entry4), "5");
	gtk_widget_show (entry4);
	gtk_box_pack_start (GTK_BOX (hbox3), entry4, TRUE, TRUE, 0);
	
	dialog_action_area1 = GTK_DIALOG (dialog1)->action_area;
	gtk_widget_show (dialog_action_area1);
	gtk_button_box_set_layout (GTK_BUTTON_BOX (dialog_action_area1), GTK_BUTTONBOX_END);
	
	cancelbutton1 = gtk_button_new_from_stock ("gtk-cancel");
	gtk_widget_show (cancelbutton1);
	gtk_dialog_add_action_widget (GTK_DIALOG (dialog1), cancelbutton1, GTK_RESPONSE_CANCEL);
	GTK_WIDGET_SET_FLAGS (cancelbutton1, GTK_CAN_DEFAULT);
	
	okbutton1 = gtk_button_new_from_stock ("gtk-ok");
	gtk_widget_show (okbutton1);
	gtk_dialog_add_action_widget (GTK_DIALOG (dialog1), okbutton1, GTK_RESPONSE_OK);
	GTK_WIDGET_SET_FLAGS (okbutton1, GTK_CAN_DEFAULT);

	g_object_set_data(G_OBJECT(dialog1), "opcion", GPOINTER_TO_INT(0));
	g_object_set_data(G_OBJECT(dialog1), "hbox1", hbox1);
	g_object_set_data(G_OBJECT(dialog1), "hbox2", hbox2);
	g_object_set_data(G_OBJECT(dialog1), "hbox3", hbox3);
	g_object_set_data(G_OBJECT(radiobutton1), "hbox", hbox1);
	g_object_set_data(G_OBJECT(radiobutton1), "opcion", GINT_TO_POINTER(1));
	g_object_set_data(G_OBJECT(hbox1), "entry1", entry1);
	g_object_set_data(G_OBJECT(radiobutton2), "hbox", hbox2);
	g_object_set_data(G_OBJECT(radiobutton2), "opcion", GINT_TO_POINTER(2));
	g_object_set_data(G_OBJECT(hbox2), "entry1", entry2);
	g_object_set_data(G_OBJECT(hbox2), "entry2", entry3);
	g_object_set_data(G_OBJECT(radiobutton3), "hbox", hbox3);
	g_object_set_data(G_OBJECT(radiobutton3), "opcion", GINT_TO_POINTER(3));
	g_object_set_data(G_OBJECT(hbox3), "entry1", entry4);
	
	g_signal_connect(radiobutton1, "toggled", G_CALLBACK(listados_diario_dialog_modo), dialog1);
	g_signal_connect(radiobutton2, "toggled", G_CALLBACK(listados_diario_dialog_modo), dialog1);
	g_signal_connect(radiobutton3, "toggled", G_CALLBACK(listados_diario_dialog_modo), dialog1);
	g_signal_connect (button1, "clicked", G_CALLBACK (gconta_seleccionar_fecha), entry2);
	g_signal_connect (button2, "clicked", G_CALLBACK (gconta_seleccionar_fecha), entry3);

	listados_diario_dialog_modo(GTK_RADIO_BUTTON(radiobutton1), dialog1);
	listados_diario_dialog_modo(GTK_RADIO_BUTTON(radiobutton2), dialog1);
	listados_diario_dialog_modo(GTK_RADIO_BUTTON(radiobutton3), dialog1);

	return dialog1;
}

void
listados_barra_cerrar (GtkToolButton * b, gpointer window)
{
	gconta_barra_cerrar(window);
}


void
listados_add_asiento (GString *pagina, gint asiento)
{
	GdaCommand *cmd;
	GdaDataModel *data;
	GdaValue *v;
	GDate *date;
	gchar buffer[MAX_BUFFER];
	gchar buffer2[11];
	gchar *t;
	gint i, cuenta;
	gdouble cuantia;

	g_snprintf(buffer, MAX_BUFFER, "SELECT fecha FROM DIARIO%d WHERE asiento = %d", gconta_main.year, asiento);
	cmd = gda_command_new(buffer, GDA_COMMAND_TYPE_SQL, GDA_COMMAND_OPTION_STOP_ON_ERRORS);
	data = gda_connection_execute_single_command(gconta_main.conn, cmd, NULL);
	if (data == NULL) {
		gconta_errores();
		return;
	}
	v = (GdaValue *) gda_data_model_get_value_at(data, 0, 0);
	if (v == NULL || gda_value_is_null(v)) {
		g_object_unref(G_OBJECT(data));
		return;
	}
	t = gda_value_stringify(v);
	g_object_unref(G_OBJECT(data));
	date = g_date_new();
	g_date_set_parse(date, t);
	g_free(t);
	g_date_strftime(buffer2, 11, "%d/%m/%y", date);
	g_date_free(date),
	
	// CABECERA
	g_snprintf(buffer, MAX_BUFFER, "<tr><td class=\"top\" colspan=\"4\"><div class=\"top\">"
			"Asiento nº %d, Fecha: %s</div></td></tr>", asiento, buffer2);
	pagina = g_string_append(pagina, buffer);
	
	// PARTIDAS
	
	g_snprintf(buffer, MAX_BUFFER,	"SELECT D.cuenta, nombre, cuantia "
		"FROM DIARIO_DEBE%d AS D INNER JOIN PGC%d AS P ON P.cuenta = D.cuenta WHERE asiento = %d",
				gconta_main.year, gconta_main.year, asiento);
	cmd = gda_command_new(buffer, GDA_COMMAND_TYPE_SQL, GDA_COMMAND_OPTION_STOP_ON_ERRORS);
	data = gda_connection_execute_single_command(gconta_main.conn, cmd, NULL);
	if (data == NULL) {
		gconta_errores();
		return;
	}
	for(i = 0; i < gda_data_model_get_n_rows(data); i++) {
		// Cuenta
		v = (GdaValue *) gda_data_model_get_value_at(data, 0, i);
		t = gda_value_stringify(v);
		cuenta = g_strtod(t, NULL);
		g_free(t);
		// Cuantia
		v = (GdaValue *) gda_data_model_get_value_at(data, 2, i);
		t = gda_value_stringify(v);
		cuantia = g_strtod(t, NULL);
		g_free(t);
		// Nombre
		v = (GdaValue *) gda_data_model_get_value_at(data, 1, i);
		t = gda_value_stringify(v);

		g_snprintf(buffer, MAX_BUFFER, "<tr><td class=\"col\">%.4f</td><td>(%d) %s</td>"
				"<td></td><td class=\"col\"></td></tr>", cuantia, cuenta, t);
		pagina = g_string_append(pagina, buffer);

		g_free(t);
	}		
	g_object_unref(G_OBJECT(data));


	g_snprintf(buffer, MAX_BUFFER,	"SELECT D.cuenta, nombre, cuantia "
		"FROM DIARIO_HABER%d AS D INNER JOIN PGC%d AS P ON P.cuenta = D.cuenta WHERE asiento = %d",
		gconta_main.year, gconta_main.year, asiento);
	cmd = gda_command_new(buffer, GDA_COMMAND_TYPE_SQL, GDA_COMMAND_OPTION_STOP_ON_ERRORS);
	data = gda_connection_execute_single_command(gconta_main.conn, cmd, NULL);
	if (data == NULL) {
		gconta_errores();
		return;
	}
	for(i = 0; i < gda_data_model_get_n_rows(data); i++) {
		// Cuenta
		v = (GdaValue *) gda_data_model_get_value_at(data, 0, i);
		t = gda_value_stringify(v);
		cuenta = g_strtod(t, NULL);
		g_free(t);
		// Cuantia
		v = (GdaValue *) gda_data_model_get_value_at(data, 2, i);
		t = gda_value_stringify(v);
		cuantia = g_strtod(t, NULL);
		g_free(t);
		// Nombre
		v = (GdaValue *) gda_data_model_get_value_at(data, 1, i);
		t = gda_value_stringify(v);

		g_snprintf(buffer, MAX_BUFFER, "<tr><td class=\"col\"></td><td></td>"
				"<td>a (%d) %s</td><td class=\"col\">%.4f</td></tr>", cuenta, t, cuantia);
		pagina = g_string_append(pagina, buffer);

		g_free(t);
	}		
	g_object_unref(G_OBJECT(data));
	
	// DESCRIPCION / PIE
	
	g_snprintf(buffer, MAX_BUFFER, "SELECT descripcion FROM DIARIO_DESCRIPCION%d WHERE asiento = %d",
		gconta_main.year, asiento);
	cmd = gda_command_new(buffer, GDA_COMMAND_TYPE_SQL, GDA_COMMAND_OPTION_STOP_ON_ERRORS);
	data = gda_connection_execute_single_command(gconta_main.conn, cmd, NULL);
	if (data == NULL) {
		gconta_errores();
		return;
	}
	v = (GdaValue *) gda_data_model_get_value_at(data, 0, 0);
	if (v != NULL && !gda_value_is_null(v)) {
		t = gda_value_stringify(v);
		g_snprintf(buffer, MAX_BUFFER, "<tr><td class=\"coldesc\"></td><td class=\"desc\" colspan=\"2\">"
			"<hr />%s</td><td class=\"coldesc\"></td></tr>", t);
		g_free(t);
	} else g_snprintf(buffer, MAX_BUFFER, "<tr><td class=\"coldesc\"></td><td class=\"desc\" colspan=\"2\">"
			"</td><td class=\"coldesc\"></td></tr>");

	pagina = g_string_append(pagina, buffer);
	g_object_unref(G_OBJECT(data));                                                                              
}


void
listados_barra_diario	(GtkToolButton *b,
						gpointer window)
{
	GtkWidget *dialog;
	GtkWidget *child;
	GtkWidget *entry1;
	GtkWidget *entry2;
	GtkWidget *hbox;
	GSList *lista_asientos;
	GdaCommand *cmd;
	GdaDataModel *data;
	gchar buffer[MAX_BUFFER];
	gchar buffer1[11];
	gchar buffer2[11];
	gchar *t;
	gint len, n, i, j;
	gint uno, dos;
	GDate *date1;
	
	lista_asientos = NULL;
	dialog = listados_diario_dialog();
	if (gtk_dialog_run(GTK_DIALOG(dialog)) != GTK_RESPONSE_OK) {
		gtk_widget_destroy(dialog);
		return;
	}
	n = GPOINTER_TO_INT(g_object_get_data(G_OBJECT(dialog), "opcion"));
	switch(n) {
	case 1:
		// Asientos sueltos y ragos
		hbox = g_object_get_data(G_OBJECT(dialog), "hbox1");
		entry1 = g_object_get_data(G_OBJECT(hbox), "entry1");
		t = (gchar *) gtk_entry_get_text(GTK_ENTRY(entry1));
		child = gconta_get_child(window);
		g_snprintf(buffer, MAX_BUFFER, "Listados de los asientos %s", t);
		gtk_label_set_text(GTK_LABEL(g_object_get_data(G_OBJECT(child), "label1")), buffer);
		uno = 0;
		n = 0;
		for(i = 0; i <= strlen(t); i++) {
			if (g_ascii_isdigit(t[i])) {
				buffer[n] = t[i];
				n++;
			} else if (t[i] == ',' || i == strlen(t)) {
				buffer[n] = '\0';
				dos = g_strtod(buffer, NULL);
				if (dos == 0) break;
				if (uno == 0) uno = dos;
				for (j = uno; j <= dos; j++)
					lista_asientos = g_slist_append(lista_asientos, GINT_TO_POINTER(j));
				uno = 0;
				n = 0;
			} else if (t[i] == '-') {
				buffer[n] = '\0';
				uno = g_strtod(buffer, NULL);
				if (uno == 0) break;
				n = 0;
			} else break;
		}
		break;
	case 2:
		// Asientos entre dos fechas
		hbox = g_object_get_data(G_OBJECT(dialog), "hbox2");
		entry1 = g_object_get_data(G_OBJECT(hbox), "entry1");
		entry2 = g_object_get_data(G_OBJECT(hbox), "entry2");
		date1 = g_object_get_data(G_OBJECT(entry1), "fecha");
		g_date_strftime(buffer1, 11, "%Y-%m-%d", date1);
		date1 = g_object_get_data(G_OBJECT(entry2), "fecha");
		g_date_strftime(buffer2, 11, "%Y-%m-%d", date1);
		child = gconta_get_child(window);
		g_snprintf(buffer, MAX_BUFFER, "Listados de los asientos entre %s y %s",
				gtk_entry_get_text(GTK_ENTRY(entry1)),
				gtk_entry_get_text(GTK_ENTRY(entry2)));
		gtk_label_set_text(GTK_LABEL(g_object_get_data(G_OBJECT(child), "label1")), buffer);
		g_snprintf(buffer, MAX_BUFFER, "SELECT asiento, fecha FROM DIARIO%d"
			" WHERE fecha >= '%s' AND fecha <= '%s' ORDER BY 2", gconta_main.year, buffer1, buffer2);
		cmd = gda_command_new(buffer, GDA_COMMAND_TYPE_SQL, GDA_COMMAND_OPTION_STOP_ON_ERRORS);
		data = gda_connection_execute_single_command(gconta_main.conn, cmd, NULL);
		if (data == NULL) {
			gconta_errores();
			return;
		}
		for (i = 0; i < gda_data_model_get_n_rows(data); i++)  {
			t = gda_value_stringify((GdaValue *) gda_data_model_get_value_at(data, 0, i));
			n = g_strtod(t, NULL);
			g_free(t);
			if (n != 0) lista_asientos = g_slist_append(lista_asientos, GINT_TO_POINTER(n));
		}
		g_object_unref(G_OBJECT(data));
		break;
	case 3:
		// Ultimos n asientos
		hbox = g_object_get_data(G_OBJECT(dialog), "hbox3");
		entry1 = g_object_get_data(G_OBJECT(hbox), "entry1");
		n = g_strtod(gtk_entry_get_text(GTK_ENTRY(entry1)), NULL);
		child = gconta_get_child(window);
		g_snprintf(buffer, MAX_BUFFER, "Listados de los últimos %d asientos", n);
		gtk_label_set_text(GTK_LABEL(g_object_get_data(G_OBJECT(child), "label1")), buffer);
		len = diario_ultimo_asiento();
		for (i = CLAMP(len - n + 1, 0, len); i <= len; i++)
			lista_asientos = g_slist_append(lista_asientos, GINT_TO_POINTER(i));
		break;
	}
	// Mostar los asientos de la lista
	listados_diario_mostrar(lista_asientos, window);
	
	gtk_widget_destroy(dialog);
	g_slist_free(lista_asientos);
}

void
listados_diario_dialog_modo (GtkRadioButton *b,
							gpointer window)
{
	GtkWidget *hbox;
	gboolean sel;
	gint n;
	
	hbox = g_object_get_data(G_OBJECT(b), "hbox");
	sel = gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(b));
	gtk_widget_set_sensitive(hbox, sel);
	if (sel) {
		n = GPOINTER_TO_INT(g_object_get_data(G_OBJECT(b), "opcion"));
		g_object_set_data(G_OBJECT(window), "opcion", GINT_TO_POINTER(n));
	}
}

void
listados_diario_mostrar(GSList *lista_asientos, gpointer window)
{
	GtkWidget *child;
	HtmlDocument *document;
	GSList *node;
	GString *st;
	gchar *pagina, *filename;
	gint len;

	child = gconta_get_child(window);
	if (lista_asientos == NULL) return;
	filename = gconta_uri("gconta-diario-head.html");
	if (g_file_get_contents (filename, &pagina, &len, NULL)) {
		st = g_object_get_data(G_OBJECT(child), "buffer");
		if (st != NULL) g_string_free(st, TRUE);
		st = g_string_new(pagina);
		g_free(pagina);
		for(node = lista_asientos; node != NULL; node = g_slist_next(node)) 
			listados_add_asiento(st, GPOINTER_TO_INT(node->data));

		g_string_append(st, "</table></body></html>");
		child = gconta_get_child(window);
		document = g_object_get_data(G_OBJECT(child), "document");	
		html_document_clear(document);
		html_document_open_stream (document, "text/html");
		html_document_write_stream (document, st->str, st->len);
		html_document_close_stream (document);
		
		g_object_set_data(G_OBJECT(child), "buffer", st);
	} else g_warning("No se pudo abrir fichero de cabecera de listados de diario");
	g_free(filename);
}

void
listados_barra_guardar (GtkToolButton *b,
						gpointer window)
{
	GtkWidget *child;
	GtkWidget *dialog;
	GIOChannel *file;
	GString *st;
	gchar *t;
	gint len;

	child = gconta_get_child(window);
	st = g_object_get_data(G_OBJECT(child), "buffer");

	if (st == NULL) return;
	
	dialog = gtk_file_chooser_dialog_new ("Seleccione un nombre de archivo",
				      GTK_WINDOW(window),
				      GTK_FILE_CHOOSER_ACTION_SAVE,
				      GTK_STOCK_CANCEL, GTK_RESPONSE_CANCEL,
				      GTK_STOCK_SAVE, GTK_RESPONSE_ACCEPT,
				      NULL);
	if (gtk_dialog_run(GTK_DIALOG(dialog)) == GTK_RESPONSE_ACCEPT) {
		t = gtk_file_chooser_get_filename(GTK_FILE_CHOOSER(dialog));
		if (t == NULL) {
			gtk_widget_destroy(dialog);
			return;
		}
		if (g_file_test(t, G_FILE_TEST_EXISTS)) {
			child = create_dialog("El fichero ya existe. ¿Desea sobre escribirlo?", FALSE);
			if (gtk_dialog_run(GTK_DIALOG(child)) != GTK_RESPONSE_OK) {
				gtk_widget_destroy(child);
				gtk_widget_destroy(dialog);
				return;
			}
		}
		file = g_io_channel_new_file (t, "w", NULL);
		if (file == NULL) {
			child = create_dialog("Fallo al crear el fichero.\nCompruebe que tiene permiso.", TRUE);
			gtk_dialog_run(GTK_DIALOG(child));
			gtk_widget_destroy(child);
			gtk_widget_destroy(dialog);
			return;
		}
		if (g_io_channel_write_chars(file, st->str, st->len, &len, NULL) != G_IO_STATUS_NORMAL) {
			child = create_dialog("Fallo al guardar el archivo", TRUE);
			gtk_dialog_run(GTK_DIALOG(child));
			gtk_widget_destroy(child);
			gtk_widget_destroy(dialog);
			return;
		}
		g_io_channel_close(file);
	}
	gtk_widget_destroy(dialog);
	
}


void
listados_add_cuenta (GString *pagina, gint cuenta)
{
	GdaCommand *cmd;
	GdaDataModel *data;
	GdaValue *v;
	GDate *date;
	gchar buffer[MAX_BUFFER];
	gchar bufferfecha[11];
	gchar bufferdebe[100];
	gchar bufferhaber[100];
	gchar *nombre;
	gchar *descripcion;
	gchar *asiento;
	gchar *fecha;
	gchar *partida_descripcion;
	gchar *cuantia;
	gint i;

	g_snprintf(buffer, MAX_BUFFER,
		"SELECT nombre, descripcion FROM"
		"(PGC%d AS P LEFT JOIN PGC_DESCRIPCION%d AS pd ON P.cuenta = pd.cuenta) "
		"WHERE P.cuenta = %d", gconta_main.year, gconta_main.year, cuenta);
	cmd = gda_command_new (buffer, GDA_COMMAND_TYPE_SQL, GDA_COMMAND_OPTION_STOP_ON_ERRORS);
	data = gda_connection_execute_single_command (gconta_main.conn, cmd, NULL);
	gda_command_free (cmd);
	if (data == NULL) {
		gconta_errores ();
		return;
	}
	v = (GdaValue *) gda_data_model_get_value_at (data, 0, 0);
	if (v == NULL || gda_value_is_null(v)) {
		g_object_unref(G_OBJECT(data));
		return;
	}

	nombre = gda_value_stringify(v);

	v = (GdaValue *) gda_data_model_get_value_at (data, 1, 0);
	if (v == NULL || gda_value_is_null(v)) descripcion = NULL;
	else descripcion = gda_value_stringify(v);
	g_object_unref(G_OBJECT(data));
	
	// CABECERA
	g_snprintf(buffer, MAX_BUFFER, 
			"<table border=\"0\" cellspacing=\"0\" width=\"100%%\">"
			"<tr><td class=\"cuenta\" colspan=\"5\">(%d) %s</td>"
			"</tr><tr><td class=\"top\" width=\"5%%\">Asiento</td><td class=\"top\" width=\"10%%\">"
			"Fecha</td><td class=\"top\" width=\"55%%\">Descripción</td>"
			"<td class=\"top\" width=\"10%%\">Debe</td><td class=\"top\" width=\"10%%\">"
			"Haber</td></tr>", cuenta, nombre);
	pagina = g_string_append(pagina, buffer);
	g_free(nombre);
	
	// PARTIDAS
	
	g_snprintf(buffer, MAX_BUFFER,
		"(SELECT d.asiento, fecha, descripcion, cuantia, 0 "
		"FROM (DIARIO%d AS d INNER JOIN DIARIO_DEBE%d AS dd ON d.asiento = dd.asiento) "
		"LEFT JOIN DIARIO_DESCRIPCION%d AS ddes ON ddes.asiento = d.asiento "
		"WHERE dd.cuenta = %d) UNION "
		"(SELECT d.asiento, fecha, descripcion, 0, cuantia "
		"FROM (DIARIO%d AS d INNER JOIN DIARIO_HABER%d AS dd ON d.asiento = dd.asiento) "
		"LEFT JOIN DIARIO_DESCRIPCION%d AS ddes ON ddes.asiento = d.asiento "
		"WHERE dd.cuenta = %d) ORDER BY 1",
			gconta_main.year, gconta_main.year, gconta_main.year, cuenta,
			gconta_main.year, gconta_main.year, gconta_main.year, cuenta);
	cmd = gda_command_new (buffer, GDA_COMMAND_TYPE_SQL, GDA_COMMAND_OPTION_STOP_ON_ERRORS);
	data = gda_connection_execute_single_command (gconta_main.conn, cmd, NULL);
	gda_command_free (cmd);
	if (data == NULL) {
		gconta_errores ();
		return;
	}
	for (i = 0; i < gda_data_model_get_n_rows (data); i++) {
		// Asiento
		v = (GdaValue *) gda_data_model_get_value_at(data, 0, i);
		asiento = gda_value_stringify(v);
		// Fecha
		v = (GdaValue *) gda_data_model_get_value_at(data, 1, i);
		fecha = gda_value_stringify(v);
		date = g_date_new();
		g_date_set_parse(date, fecha);
		g_date_strftime(bufferfecha, 11, "%d/%m/%y", date);
		// Descripción
		v = (GdaValue *) gda_data_model_get_value_at(data, 2, i);
		if (!gda_value_is_null(v)) partida_descripcion = gda_value_stringify(v);
		else partida_descripcion = "";
		// Debe o haber
		g_snprintf(bufferdebe, 1, " ");
		g_snprintf(bufferhaber, 1, " ");
		cuantia = gda_value_stringify((GdaValue *) gda_data_model_get_value_at(data, 3, i));
		if (g_ascii_strtod(cuantia, NULL) > 0) 
			g_snprintf(bufferdebe, MAX_BUFFER, "%.4f", g_ascii_strtod(cuantia, NULL));
		else {
			g_free(cuantia);
			cuantia = gda_value_stringify((GdaValue *) gda_data_model_get_value_at(data, 4, i));
			g_snprintf(bufferhaber, MAX_BUFFER, "%.4f", g_ascii_strtod(cuantia, NULL));
		}

		g_snprintf(buffer, MAX_BUFFER, "<tr><td>%s</td><td>%s</td><td class=\"des\">%s"
				"</td><td>%s</td><td>%s</td></tr>",
			asiento, bufferfecha, partida_descripcion, bufferdebe, bufferhaber);
		pagina = g_string_append(pagina, buffer);

		g_free(asiento);
		g_free(fecha);
		g_free(partida_descripcion);
		g_free(cuantia);
	}
	g_object_unref(G_OBJECT(data));
	
	// DESCRIPCION / PIE
	
	if (descripcion == NULL) g_snprintf(buffer, MAX_BUFFER,
			"<tr><td class=\"desc\" colspan=\"5\"></td></tr></table><br />");
	else g_snprintf(buffer, MAX_BUFFER,
			"<tr><td class=\"desc\" colspan=\"5\"><hr />%s</td></tr></table><br />", descripcion);
	pagina = g_string_append(pagina, buffer);
	if (descripcion != NULL) g_free(descripcion);
}

void
listados_barra_mayor	(GtkToolButton *b,
						gpointer window)
{
	GtkWidget *dialog;
	GtkWidget *entry;
	GSList *lista_cuentas = NULL;
	const gchar *t;
	gchar buffer[100];
	gint i, j, n, uno, dos;
	
	
	dialog = listados_mayor_dialog();
	if (gtk_dialog_run(GTK_DIALOG(dialog)) != GTK_RESPONSE_OK) {
		gtk_widget_destroy(dialog);
		return;
	}
	entry = g_object_get_data(G_OBJECT(dialog), "entry1");
	t = gtk_entry_get_text(GTK_ENTRY(entry));
	uno = 0;
	n = 0;
	
	for(i = 0; i <= strlen(t); i++) {
		if (g_ascii_isdigit(t[i])) {
			buffer[n] = t[i];
			n++;
		} else if (t[i] == ',' || i == strlen(t) || t[i] == '\0') {
			buffer[n] = '\0';
			dos = g_strtod(buffer, NULL);
			if (dos == 0) break;
			if (uno == 0) uno = dos;
			for (j = uno; j <= dos; j++)
				lista_cuentas = g_slist_append(lista_cuentas, GINT_TO_POINTER(j));
			uno = 0;
			n = 0;
		} else if (t[i] == '-') {
			buffer[n] = '\0';
			uno = g_strtod(buffer, NULL);
			if (uno == 0) break;
			n = 0;
		} else break;
	}
	gtk_widget_destroy(dialog);
	listados_mayor_mostrar(lista_cuentas, window);
	g_slist_free(lista_cuentas);
}

void
listados_mayor_mostrar(GSList *lista_cuentas, gpointer window)
{
	GtkWidget *child;
	HtmlDocument *document;
	GSList *node;
	GString *st;
	gchar *pagina, *filename;
	gint len;

	child = gconta_get_child(window);
	if (lista_cuentas == NULL) return;
	filename = gconta_uri("gconta-mayor-head.html");
	if (g_file_get_contents (filename, &pagina, &len, NULL)) {
		st = g_object_get_data(G_OBJECT(child), "buffer");
		if (st != NULL) g_string_free(st, TRUE);
		st = g_string_new(pagina);
		g_free(pagina);
		for(node = lista_cuentas; node != NULL; node = g_slist_next(node)) 
			listados_add_cuenta(st, GPOINTER_TO_INT(node->data));

		g_string_append(st, "</body></html>");
		child = gconta_get_child(window);
		document = g_object_get_data(G_OBJECT(child), "document");	
		html_document_clear(document);
		html_document_open_stream (document, "text/html");
		html_document_write_stream (document, st->str, st->len);
		html_document_close_stream (document);
		
		g_object_set_data(G_OBJECT(child), "buffer", st);
	} else g_warning("No se pudo abrir fichero de cabecera de listados de mayor");
	g_free(filename);
}

GtkWidget*
listados_mayor_dialog (void)
{
	GtkWidget *dialog1;
	GtkWidget *dialog_vbox1;
	GtkWidget *vbox1;
	GtkWidget *label1;
	GtkWidget *entry1;
	GtkWidget *dialog_action_area1;
	GtkWidget *cancelbutton1;
	GtkWidget *okbutton1;
	
	dialog1 = gtk_dialog_new ();
	gtk_window_set_title (GTK_WINDOW (dialog1), _("Seleccionar cuentas"));
	gtk_window_set_type_hint (GTK_WINDOW (dialog1), GDK_WINDOW_TYPE_HINT_DIALOG);
	
	dialog_vbox1 = GTK_DIALOG (dialog1)->vbox;
	gtk_widget_show (dialog_vbox1);
	
	vbox1 = gtk_vbox_new (FALSE, 12);
	gtk_widget_show (vbox1);
	gtk_box_pack_start (GTK_BOX (dialog_vbox1), vbox1, TRUE, TRUE, 0);
	gtk_container_set_border_width (GTK_CONTAINER (vbox1), 6);
	
	label1 = gtk_label_new (_("<b>Selecciones cuentas a mostrar</b>"));
	gtk_widget_show (label1);
	gtk_box_pack_start (GTK_BOX (vbox1), label1, FALSE, FALSE, 0);
	gtk_label_set_use_markup (GTK_LABEL (label1), TRUE);
	
	entry1 = gtk_entry_new ();
	gtk_widget_show (entry1);
	gtk_box_pack_start (GTK_BOX (vbox1), entry1, FALSE, FALSE, 0);
	
	dialog_action_area1 = GTK_DIALOG (dialog1)->action_area;
	gtk_widget_show (dialog_action_area1);
	gtk_button_box_set_layout (GTK_BUTTON_BOX (dialog_action_area1), GTK_BUTTONBOX_END);
	
	cancelbutton1 = gtk_button_new_from_stock ("gtk-cancel");
	gtk_widget_show (cancelbutton1);
	gtk_dialog_add_action_widget (GTK_DIALOG (dialog1), cancelbutton1, GTK_RESPONSE_CANCEL);
	GTK_WIDGET_SET_FLAGS (cancelbutton1, GTK_CAN_DEFAULT);
	
	okbutton1 = gtk_button_new_from_stock ("gtk-ok");
	gtk_widget_show (okbutton1);
	gtk_dialog_add_action_widget (GTK_DIALOG (dialog1), okbutton1, GTK_RESPONSE_OK);
	GTK_WIDGET_SET_FLAGS (okbutton1, GTK_CAN_DEFAULT);
	
	g_object_set_data(G_OBJECT(dialog1), "entry1", entry1);
	
	return dialog1;
}

void
listados_barra_imprimir (GtkToolButton *b,
						gpointer window)
{
	
}

void
listado_de_diario(GtkMenuItem *i, gpointer window)
{
	boton_listados(NULL, window);
	listados_barra_diario(NULL, window);
}

void
listado_de_mayor(GtkMenuItem *i, gpointer window)
{
	boton_listados(NULL, window);
	listados_barra_mayor(NULL, window);
}
