/*
 * mayor.c
 * This file is part of gconta
 *
 * Copyright (C) 2004 Bruno Orcha Garcia
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, 
 * Boston, MA 02111-1307, USA. 
 */

#include "mayor.h"


GtkWidget *
mayor_barra (gpointer window)
{
	GtkWidget *toolbar1;
	gint tmp_toolbar_icon_size;
	GtkWidget *toolbutton1;
	GtkWidget *separatortoolitem1;
	GtkWidget *toolbuttoncerrar;
	
	toolbar1 = gtk_toolbar_new ();
	gtk_widget_show (toolbar1);
	gtk_toolbar_set_style (GTK_TOOLBAR (toolbar1), GTK_TOOLBAR_BOTH_HORIZ);
	tmp_toolbar_icon_size = gtk_toolbar_get_icon_size (GTK_TOOLBAR (toolbar1));
	
	toolbutton1 = (GtkWidget*) gtk_tool_button_new_from_stock ("gtk-find");
	gtk_widget_show (toolbutton1);
	gtk_container_add (GTK_CONTAINER (toolbar1), toolbutton1);
	
	separatortoolitem1 = (GtkWidget*) gtk_separator_tool_item_new ();
	gtk_widget_show (separatortoolitem1);
	gtk_tool_item_set_expand (GTK_TOOL_ITEM (separatortoolitem1), TRUE);
	gtk_container_add (GTK_CONTAINER (toolbar1), separatortoolitem1);
	
	toolbuttoncerrar = (GtkWidget*) gtk_tool_button_new_from_stock ("gtk-close");
	gtk_widget_show (toolbuttoncerrar);
	gtk_container_add (GTK_CONTAINER (toolbar1), toolbuttoncerrar);
	
	g_signal_connect ((gpointer) toolbutton1, "clicked",
			  G_CALLBACK (mayor_barra_buscar), window);
	g_signal_connect ((gpointer) toolbuttoncerrar, "clicked",
			  G_CALLBACK (mayor_barra_cerrar), window);
	
	
	return toolbar1;
}

GtkWidget *
mayor_child (gpointer window)
{
	GtkWidget *vbox1;
	GtkWidget *hbox1;
	GtkWidget *label2;
	GtkWidget *entry1;
	GtkWidget *tmp_image;
	GtkWidget *button1;
	GtkWidget *label3;
	GtkWidget *entry2;
	GtkWidget *vpaned1;
	GtkWidget *scrolledwindow4;
	GtkWidget *treeview1;
	GtkWidget *vbox4;
	GtkWidget *label7;
	GtkWidget *scrolledwindow3;
	GtkWidget *textview1;
	GtkWidget *hbox3;
	GtkWidget *table1;
	GtkWidget *label8;
	GtkWidget *label9;
	GtkWidget *entry3;
	GtkWidget *entry4;
	GtkWidget *label10;
	GtkWidget *entry5;
	GtkCellRenderer *rend;
	GtkTreeViewColumn *col;
	GtkTreeStore *store;
	
	vbox1 = gtk_vbox_new (FALSE, 12);
	gtk_widget_show (vbox1);
	gtk_container_set_border_width (GTK_CONTAINER (vbox1), 6);
	
	hbox1 = gtk_hbox_new (FALSE, 12);
	gtk_widget_show (hbox1);
	gtk_box_pack_start (GTK_BOX (vbox1), hbox1, FALSE, TRUE, 0);
	
	label2 = gtk_label_new (_("<b>Cuenta</b>"));
	gtk_widget_show (label2);
	gtk_box_pack_start (GTK_BOX (hbox1), label2, FALSE, FALSE, 0);
	gtk_label_set_use_markup (GTK_LABEL (label2), TRUE);
	
	entry1 = gtk_entry_new ();
	gtk_widget_show (entry1);
	gtk_box_pack_start (GTK_BOX (hbox1), entry1, FALSE, TRUE, 0);

	button1 = gtk_button_new ();
	tmp_image =	gtk_image_new_from_stock ("gtk-refresh", GTK_ICON_SIZE_BUTTON);
	gtk_widget_show (tmp_image);
	gtk_container_add (GTK_CONTAINER (button1), tmp_image);
	gtk_widget_show (button1);
	gtk_box_pack_start (GTK_BOX (hbox1), button1, FALSE, FALSE, 0);

	label3 = gtk_label_new (_("<b>Nombre</b>"));
	gtk_widget_show (label3);
	gtk_box_pack_start (GTK_BOX (hbox1), label3, FALSE, FALSE, 0);
	gtk_label_set_use_markup (GTK_LABEL (label3), TRUE);
	
	entry2 = gtk_entry_new ();
	gtk_widget_show (entry2);
	gtk_box_pack_start (GTK_BOX (hbox1), entry2, TRUE, TRUE, 0);
	gtk_editable_set_editable (GTK_EDITABLE (entry2), FALSE);
	
	
	vpaned1 = gtk_vpaned_new ();
	gtk_widget_show (vpaned1);
	gtk_box_pack_start (GTK_BOX (vbox1), vpaned1, TRUE, TRUE, 0);
	gtk_paned_set_position (GTK_PANED (vpaned1), 280);
	
	scrolledwindow4 = gtk_scrolled_window_new (NULL, NULL);
	gtk_widget_show (scrolledwindow4);
	gtk_paned_pack1 (GTK_PANED (vpaned1), scrolledwindow4, FALSE, TRUE);
	gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow4), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
	
	store = gtk_tree_store_new (6, G_TYPE_STRING, G_TYPE_STRING,
		G_TYPE_STRING, G_TYPE_STRING, G_TYPE_STRING, G_TYPE_STRING);

	treeview1 = gtk_tree_view_new_with_model(GTK_TREE_MODEL(store));
	gtk_tree_view_set_rules_hint (GTK_TREE_VIEW (treeview1), TRUE);
	g_object_unref (G_OBJECT (store));
	gtk_widget_show (treeview1);

	rend = gtk_cell_renderer_text_new ();
	col = gtk_tree_view_column_new_with_attributes ("Asiento", rend, "text", 0, NULL);
	gtk_tree_view_append_column (GTK_TREE_VIEW (treeview1), col);

	rend = gtk_cell_renderer_text_new ();
	col = gtk_tree_view_column_new_with_attributes ("Fecha", rend, "text", 1, NULL);
	gtk_tree_view_append_column (GTK_TREE_VIEW (treeview1), col);
	
	rend = gtk_cell_renderer_text_new ();
	col = gtk_tree_view_column_new_with_attributes ("Descripción", rend, "text", 2, NULL);
	gtk_tree_view_column_set_resizable (col, TRUE);
	gtk_tree_view_append_column (GTK_TREE_VIEW (treeview1), col);

	rend = gtk_cell_renderer_text_new ();
	g_object_set (G_OBJECT (rend), "xalign", 1.0, NULL);
	col = gtk_tree_view_column_new_with_attributes ("Debe", rend, "text", 3, NULL);
	gtk_tree_view_append_column (GTK_TREE_VIEW (treeview1), col);

	rend = gtk_cell_renderer_text_new ();
	g_object_set (G_OBJECT (rend), "xalign", 1.0, NULL);
	col = gtk_tree_view_column_new_with_attributes ("Haber", rend, "text", 4, NULL);
	gtk_tree_view_append_column (GTK_TREE_VIEW (treeview1), col);

	rend = gtk_cell_renderer_text_new ();
	col = gtk_tree_view_column_new_with_attributes ("", rend, "text", 5, NULL);
	gtk_tree_view_append_column (GTK_TREE_VIEW (treeview1), col);

	gtk_container_add (GTK_CONTAINER (scrolledwindow4), treeview1);	
	
	vbox4 = gtk_vbox_new (FALSE, 12);
	gtk_widget_show (vbox4);
	gtk_paned_pack2 (GTK_PANED (vpaned1), vbox4, TRUE, TRUE);
	
	label7 = gtk_label_new (_("Descripción:"));
	gtk_widget_show (label7);
	gtk_box_pack_start (GTK_BOX (vbox4), label7, FALSE, FALSE, 0);
	gtk_misc_set_alignment (GTK_MISC (label7), 0, 0.5);
	
	scrolledwindow3 = gtk_scrolled_window_new (NULL, NULL);
	gtk_widget_show (scrolledwindow3);
	gtk_box_pack_start (GTK_BOX (vbox4), scrolledwindow3, TRUE, TRUE, 0);
	gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow3), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
	
	textview1 = gtk_text_view_new ();
	gtk_widget_show (textview1);
	gtk_container_add (GTK_CONTAINER (scrolledwindow3), textview1);
	gtk_text_view_set_editable (GTK_TEXT_VIEW (textview1), FALSE);
	
	hbox3 = gtk_hbox_new (FALSE, 12);
	gtk_widget_show (hbox3);
	gtk_box_pack_start (GTK_BOX (vbox1), hbox3, FALSE, TRUE, 0);
	
	table1 = gtk_table_new (2, 2, FALSE);
	gtk_widget_show (table1);
	gtk_box_pack_start (GTK_BOX (hbox3), table1, FALSE, TRUE, 0);
	gtk_table_set_row_spacings (GTK_TABLE (table1), 12);
	gtk_table_set_col_spacings (GTK_TABLE (table1), 12);
	
	label8 = gtk_label_new (_("<b>Saldo Deudor</b>"));
	gtk_widget_show (label8);
	gtk_table_attach (GTK_TABLE (table1), label8, 0, 1, 0, 1,
					(GtkAttachOptions) (GTK_FILL),
					(GtkAttachOptions) (0), 0, 0);
	gtk_label_set_use_markup (GTK_LABEL (label8), TRUE);
	gtk_misc_set_alignment (GTK_MISC (label8), 0, 0.5);
	
	label9 = gtk_label_new (_("<b>Saldo Acreedor</b>"));
	gtk_widget_show (label9);
	gtk_table_attach (GTK_TABLE (table1), label9, 0, 1, 1, 2,
					(GtkAttachOptions) (GTK_FILL),
					(GtkAttachOptions) (0), 0, 0);
	gtk_label_set_use_markup (GTK_LABEL (label9), TRUE);
	gtk_misc_set_alignment (GTK_MISC (label9), 0, 0.5);
	
	entry3 = gtk_entry_new ();
	gtk_widget_show (entry3);
	gtk_editable_set_editable (GTK_EDITABLE (entry3), FALSE);
	gtk_table_attach (GTK_TABLE (table1), entry3, 1, 2, 0, 1,
					(GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
					(GtkAttachOptions) (0), 0, 0);
	
	entry4 = gtk_entry_new ();
	gtk_widget_show (entry4);
	gtk_editable_set_editable (GTK_EDITABLE (entry4), FALSE);
	gtk_table_attach (GTK_TABLE (table1), entry4, 1, 2, 1, 2,
					(GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
					(GtkAttachOptions) (0), 0, 0);
	
	label10 = gtk_label_new (_("<span weight=\"bold\" size=\"large\">Saldo acreedor/deudor</span>"));
	gtk_widget_show (label10);
	gtk_box_pack_start (GTK_BOX (hbox3), label10, FALSE, FALSE, 0);
	gtk_label_set_use_markup (GTK_LABEL (label10), TRUE);
	
	entry5 = gtk_entry_new ();
	gtk_widget_show (entry5);
	gtk_editable_set_editable (GTK_EDITABLE (entry5), FALSE);
	gtk_box_pack_start (GTK_BOX (hbox3), entry5, FALSE, TRUE, 0);
	
	g_object_set_data(G_OBJECT(vbox1), "entry1", entry1);
	g_object_set_data(G_OBJECT(vbox1), "entry2", entry2);
	g_object_set_data(G_OBJECT(vbox1), "entry3", entry3);
	g_object_set_data(G_OBJECT(vbox1), "entry4", entry4);
	g_object_set_data(G_OBJECT(vbox1), "entry5", entry5);
	g_object_set_data(G_OBJECT(vbox1), "treeview1", treeview1);
	g_object_set_data(G_OBJECT(vbox1), "textview1", textview1);
	g_object_set_data(G_OBJECT(vbox1), "label10", label10);
	
	g_signal_connect(button1, "clicked", G_CALLBACK(mayor_actualizar), window);
	return vbox1;
}


void
mayor_barra_cerrar (GtkToolButton * b, gpointer window)
{
	gconta_barra_cerrar(window);
}

void
mayor_barra_buscar	(GtkToolButton *b,
					gpointer window)
{
	gconta_busca_cuenta(window);
}

void
mayor_actualizar	(GtkButton *b,
					gpointer window)
{
	mayor_ver(window);
}

void
mayor_limpiar	(gpointer window)
{
	GtkNotebook *nb;
	GtkWidget *child;
	GtkTreeView *treeview;
	GtkEntry *entry;
	GtkTextView *text;
	GtkTextBuffer *buffer;
	gint n;

	nb = g_object_get_data (window, "notebook");
	n = gtk_notebook_get_current_page (nb);
	child = gtk_notebook_get_nth_page (nb, n);
	treeview = g_object_get_data (G_OBJECT (child), "treeview1");
	
	gtk_tree_store_clear(GTK_TREE_STORE(gtk_tree_view_get_model(treeview)));
	
	entry = g_object_get_data(G_OBJECT(child), "entry1");
	gtk_entry_set_text(entry, "");
	entry = g_object_get_data(G_OBJECT(child), "entry2");
	gtk_entry_set_text(entry, "");
	entry = g_object_get_data(G_OBJECT(child), "entry3");
	gtk_entry_set_text(entry, "");
	entry = g_object_get_data(G_OBJECT(child), "entry4");
	gtk_entry_set_text(entry, "");
	entry = g_object_get_data(G_OBJECT(child), "entry5");
	gtk_entry_set_text(entry, "");
	
	text = g_object_get_data(G_OBJECT(child), "textview1");
	buffer = gtk_text_view_get_buffer(text);
	gtk_text_buffer_set_text(buffer, "", 0);
	
}

void
mayor_ver	(gpointer window)
{
	GtkWidget *child;
	GtkWidget *dialog;
	GtkTreeView *treeview1;
	GtkTreeIter iter;
	GtkEntry *entry;
	GtkLabel *label10;
	GtkTextView *textview1;
	GtkTreeStore *store;
	GtkTextBuffer *textbuffer;
	GdaCommand *cmd;
	GdaDataModel *data;
	GdaValue *v;
	GDate *date;
	gchar buffer[MAX_BUFFER];
	gchar *s0;
	gint i, cuenta;
	gdouble	debe, haber;
	
	g_return_if_fail(gconta_conectado ());
	
	child = gconta_get_child(window);
	entry = g_object_get_data(G_OBJECT(child), "entry1");
	cuenta = (gint) g_ascii_strtod(gtk_entry_get_text(entry), NULL);
	if (cuenta < 100) {
		dialog = create_dialog ("La cuenta especificada no es valida", TRUE);
		gtk_dialog_run (GTK_DIALOG (dialog));
		gtk_widget_destroy(dialog);
		return;
	}

	mayor_limpiar(window);	
	g_snprintf(buffer, MAX_BUFFER,
		"SELECT nombre, descripcion FROM"
		"(PGC%d AS P LEFT JOIN PGC_DESCRIPCION%d AS pd ON P.cuenta = pd.cuenta) "
		"WHERE P.cuenta = %d", gconta_main.year, gconta_main.year, cuenta);
	cmd = gda_command_new (buffer, GDA_COMMAND_TYPE_SQL, GDA_COMMAND_OPTION_STOP_ON_ERRORS);
	data = gda_connection_execute_single_command (gconta_main.conn, cmd, NULL);
	gda_command_free (cmd);
	if (data == NULL)
	{
		gconta_errores ();
		g_object_unref (G_OBJECT (data));			
		return;
	}
	v = (GdaValue *) gda_data_model_get_value_at (data, 0, 0);
	if (v == NULL || gda_value_is_null (v)) {
		dialog = create_dialog ("La cuenta especificada no existe!", TRUE);
		gtk_dialog_run (GTK_DIALOG (dialog));
		gtk_widget_destroy(dialog);
		g_object_unref (G_OBJECT (data));			
		return;
	}
	g_snprintf(buffer, MAX_BUFFER, "%d", cuenta);
	entry = g_object_get_data(G_OBJECT(child), "entry1");
	gtk_entry_set_text(entry, buffer);
	s0 = gda_value_stringify(v);
	entry = g_object_get_data(G_OBJECT(child), "entry2");
	gtk_entry_set_text(entry, s0);
	g_free(s0);
	
	v = (GdaValue *) gda_data_model_get_value_at (data, 1, 0);
	if (!gda_value_is_null (v)) {
		s0 = gda_value_stringify(v);
		textview1 = g_object_get_data(G_OBJECT(child), "textview1");
		textbuffer = gtk_text_view_get_buffer(textview1);
		gtk_text_buffer_set_text(textbuffer, s0, -1);
		g_free(s0);
	}
	
	g_object_unref (G_OBJECT (data));
	
	// Rellenar el treeview
	g_snprintf(buffer, MAX_BUFFER,
		"(SELECT d.asiento, fecha, descripcion, cuantia, 0 "
		"FROM (DIARIO%d AS d INNER JOIN DIARIO_DEBE%d AS dd ON d.asiento = dd.asiento) "
		"LEFT JOIN DIARIO_DESCRIPCION%d AS ddes ON ddes.asiento = d.asiento "
		"WHERE dd.cuenta = %d) UNION "
		"(SELECT d.asiento, fecha, descripcion, 0, cuantia "
		"FROM (DIARIO%d AS d INNER JOIN DIARIO_HABER%d AS dd ON d.asiento = dd.asiento) "
		"LEFT JOIN DIARIO_DESCRIPCION%d AS ddes ON ddes.asiento = d.asiento "
		"WHERE dd.cuenta = %d) ORDER BY 1",
		gconta_main.year, gconta_main.year, gconta_main.year, cuenta,
		gconta_main.year, gconta_main.year, gconta_main.year, cuenta);

	cmd = gda_command_new (buffer, GDA_COMMAND_TYPE_SQL, GDA_COMMAND_OPTION_STOP_ON_ERRORS);
	data = gda_connection_execute_single_command (gconta_main.conn, cmd, NULL);
	gda_command_free (cmd);
	if (data == NULL)
	{
		gconta_errores ();
		return;
	}
	debe = 0;
	haber = 0;
	treeview1 = g_object_get_data(G_OBJECT(child), "treeview1");
	store = (GtkTreeStore *) gtk_tree_view_get_model(treeview1);
	for (i = 0; i < gda_data_model_get_n_rows (data); i++) {
		gtk_tree_store_append(store, &iter, NULL);			
		// Asiento
		v = (GdaValue *) gda_data_model_get_value_at(data, 0, i);
		s0 = gda_value_stringify(v);
		gtk_tree_store_set(store, &iter, 0, s0, -1);
		g_free(s0);
		// Fecha
		v = (GdaValue *) gda_data_model_get_value_at(data, 1, i);
		s0 = gda_value_stringify(v);
		date = g_date_new();
		g_date_set_parse(date, s0);
		g_date_strftime(buffer, 11, "%d/%m/%y", date);
		gtk_tree_store_set(store, &iter, 1, buffer, -1);
		g_free(s0);
		g_date_free(date);
		// Descripción
		v = (GdaValue *) gda_data_model_get_value_at(data, 2, i);
		if (!gda_value_is_null(v)) {
			s0 = gda_value_stringify(v);
			gtk_tree_store_set(store, &iter, 2, s0, -1);
			g_free(s0);
		}
		// Debe
		v = (GdaValue *) gda_data_model_get_value_at(data, 3, i);
		s0 = gda_value_stringify(v);
		if (g_ascii_strtod(s0, NULL) > 0) {
			debe += g_ascii_strtod(s0, NULL);
			g_snprintf(buffer, MAX_BUFFER, "%.4f", g_ascii_strtod(s0, NULL));
			gtk_tree_store_set(store, &iter, 3, buffer, -1);
		} else {
			g_free(s0);
			v = (GdaValue *) gda_data_model_get_value_at(data, 4, i);
			s0 = gda_value_stringify(v);
			haber += g_ascii_strtod(s0, NULL);
			g_snprintf(buffer, MAX_BUFFER, "%.4f", g_ascii_strtod(s0, NULL));
			gtk_tree_store_set(store, &iter, 4, buffer, -1);
		}
		g_free(s0);
	}
	g_object_unref(G_OBJECT(data));
	
	g_snprintf(buffer, MAX_BUFFER, "%.4f", debe);
	entry = g_object_get_data(G_OBJECT(child), "entry3");
	gtk_entry_set_text(entry, buffer);

	g_snprintf(buffer, MAX_BUFFER, "%.4f", haber);
	entry = g_object_get_data(G_OBJECT(child), "entry4");
	gtk_entry_set_text(entry, buffer);
	
	label10 = g_object_get_data(G_OBJECT(child), "label10");
	debe = debe - haber;
	if (debe < 0) gtk_label_set_text(label10, "<span weight=\"bold\" size=\"large\">Saldo acreedor</span>");
	else gtk_label_set_text(label10, "<span weight=\"bold\" size=\"large\">Saldo deudor</span>");
	gtk_label_set_use_markup (label10, TRUE);
	debe = ABS(debe);		
	g_snprintf(buffer, MAX_BUFFER, "%.4f", debe);
	entry = g_object_get_data(G_OBJECT(child), "entry5");
	gtk_entry_set_text(entry, buffer);
}
