/*
 * pgc.c
 * This file is part of gconta
 *
 * Copyright (C) 2004 Bruno Orcha Garcia
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, 
 * Boston, MA 02111-1307, USA. 
 */

#include "pgc.h"


GtkWidget *
pgc_barra (gpointer *window)
{
	GtkWidget *toolbar1;
	GtkWidget *toolbutton1;
	GtkWidget *toolbutton2;
	GtkWidget *toolbutton3;
	GtkWidget *toolbutton4;
	GtkWidget *toolbutton5;
	GtkWidget *toolbutton6;
	GtkWidget *separatortoolitem1;
	GtkWidget *toolitem1;
	GtkWidget *label1;
	GtkWidget *toolitem2;
	GtkListStore *store;
	GtkCellRenderer *renderer;
	GtkWidget *combobox1;
	GtkWidget *separatortoolitem2;
	GtkWidget *toolbuttoncerrar;
	gint tmp_toolbar_icon_size;
	GtkWidget *tmp_image;

	toolbar1 = gtk_toolbar_new ();
	gtk_widget_show (toolbar1);
	gtk_toolbar_set_style (GTK_TOOLBAR (toolbar1), GTK_TOOLBAR_ICONS);
	tmp_toolbar_icon_size =	gtk_toolbar_get_icon_size (GTK_TOOLBAR (toolbar1));

	tmp_image =
		gtk_image_new_from_stock ("gtk-add", tmp_toolbar_icon_size);
	gtk_widget_show (tmp_image);
	toolbutton1 = (GtkWidget *) gtk_tool_button_new (tmp_image, "");
	gtk_widget_show (toolbutton1);
	gtk_container_add (GTK_CONTAINER (toolbar1), toolbutton1);
	gtk_tool_item_set_is_important (GTK_TOOL_ITEM (toolbutton1), TRUE);

	tmp_image =	gtk_image_new_from_stock ("gtk-remove", tmp_toolbar_icon_size);
	gtk_widget_show (tmp_image);
	toolbutton2 =
		(GtkWidget *) gtk_tool_button_new (tmp_image, _("Eliminar"));
	gtk_widget_show (toolbutton2);
	gtk_container_add (GTK_CONTAINER (toolbar1), toolbutton2);

	toolbutton3 = (GtkWidget*) gtk_tool_button_new_from_stock ("gtk-justify-center");
	gtk_widget_show (toolbutton3);
	gtk_container_add (GTK_CONTAINER (toolbar1), toolbutton3);

	tmp_image =	gtk_image_new_from_stock ("gtk-dialog-question", tmp_toolbar_icon_size);
	gtk_widget_show (tmp_image);
	toolbutton4 =
		(GtkWidget *) gtk_tool_button_new (tmp_image, _("Ver descripcion"));
	gtk_widget_show (toolbutton4);
	gtk_container_add (GTK_CONTAINER (toolbar1), toolbutton4);

	separatortoolitem1 = (GtkWidget *) gtk_separator_tool_item_new ();
	gtk_widget_show (separatortoolitem1);
	gtk_container_add (GTK_CONTAINER (toolbar1), separatortoolitem1);
	gtk_separator_tool_item_set_draw (GTK_SEPARATOR_TOOL_ITEM
					  (separatortoolitem1), FALSE);

	tmp_image =	gtk_image_new_from_stock ("gtk-goto-bottom", tmp_toolbar_icon_size);
	gtk_widget_show (tmp_image);
	toolbutton5 =
		(GtkWidget *) gtk_tool_button_new (tmp_image, _("Expandir todo"));
	gtk_widget_show (toolbutton5);
	gtk_container_add (GTK_CONTAINER (toolbar1), toolbutton5);

	tmp_image =	gtk_image_new_from_stock ("gtk-goto-top", tmp_toolbar_icon_size);
	gtk_widget_show (tmp_image);
	toolbutton6 =
		(GtkWidget *) gtk_tool_button_new (tmp_image, _("Contraer todo"));
	gtk_widget_show (toolbutton6);
	gtk_container_add (GTK_CONTAINER (toolbar1), toolbutton6);

	separatortoolitem1 = (GtkWidget *) gtk_separator_tool_item_new ();
	gtk_widget_show (separatortoolitem1);
	gtk_container_add (GTK_CONTAINER (toolbar1), separatortoolitem1);
	gtk_separator_tool_item_set_draw (GTK_SEPARATOR_TOOL_ITEM
					  (separatortoolitem1), FALSE);

	toolitem1 = (GtkWidget *) gtk_tool_item_new ();
	gtk_widget_show (toolitem1);
	gtk_container_add (GTK_CONTAINER (toolbar1), toolitem1);

	label1 = gtk_label_new (_("Modo"));
	gtk_widget_show (label1);
	gtk_container_add (GTK_CONTAINER (toolitem1), label1);
	gtk_misc_set_padding (GTK_MISC (label1), 6, 0);

	toolitem2 = (GtkWidget *) gtk_tool_item_new ();
	gtk_widget_show (toolitem2);
	gtk_container_add (GTK_CONTAINER (toolbar1), toolitem2);

	store = gtk_list_store_new(1, G_TYPE_STRING);
	xml_pgc_modos(store);
	
	combobox1 = gtk_combo_box_new_with_model(GTK_TREE_MODEL(store));
	gtk_widget_show (combobox1);
	gtk_container_add(GTK_CONTAINER(toolitem2), combobox1);

	renderer = gtk_cell_renderer_text_new ();
	gtk_cell_layout_pack_start (GTK_CELL_LAYOUT (combobox1), renderer, TRUE);
	gtk_cell_layout_set_attributes (GTK_CELL_LAYOUT (combobox1), renderer,
									"text", 0,
									NULL);


	separatortoolitem2 = (GtkWidget *) gtk_separator_tool_item_new ();
	gtk_widget_show (separatortoolitem2);
	gtk_tool_item_set_expand (GTK_TOOL_ITEM (separatortoolitem2), TRUE);
	gtk_container_add (GTK_CONTAINER (toolbar1), separatortoolitem2);
	gtk_separator_tool_item_set_draw (GTK_SEPARATOR_TOOL_ITEM
					  (separatortoolitem2), FALSE);

	tmp_image =
		gtk_image_new_from_stock ("gtk-close", tmp_toolbar_icon_size);
	gtk_widget_show (tmp_image);
	toolbuttoncerrar = (GtkWidget *) gtk_tool_button_new (tmp_image, "");
	gtk_widget_show (toolbuttoncerrar);
	gtk_container_add (GTK_CONTAINER (toolbar1), toolbuttoncerrar);

	g_object_set_data(G_OBJECT(toolbar1), "combobox1", combobox1);

	g_signal_connect((gpointer) toolbutton1, "clicked",
						G_CALLBACK(pgc_barra_add), window);
	g_signal_connect((gpointer) toolbutton2, "clicked",
						G_CALLBACK(pgc_barra_remove), window);
	g_signal_connect((gpointer) toolbutton3, "clicked",
						G_CALLBACK(pgc_barra_ver_mayor), window);
	g_signal_connect((gpointer) toolbutton5, "clicked",
						G_CALLBACK(pgc_barra_expandir), window);
	g_signal_connect((gpointer) toolbutton6, "clicked",
						G_CALLBACK(pgc_barra_contraer), window);
	g_signal_connect((gpointer) toolbuttoncerrar, "clicked",
						G_CALLBACK(pgc_barra_cerrar), window);
	g_signal_connect((gpointer) combobox1, "changed",
						G_CALLBACK(pgc_barra_combo_changed), window);
	
	return toolbar1;
}

GtkWidget *
pgc_child (gpointer window)
{
	GtkWidget *sw;
	GtkTreeStore * store;
	GtkWidget * tree;
	GtkCellRenderer * rend;
	GtkTreeViewColumn * col;
	
	// Creacoin del widget incrustado
	sw = gtk_scrolled_window_new(NULL, NULL);
	gtk_scrolled_window_set_policy(GTK_SCROLLED_WINDOW(sw),
		GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
	gtk_widget_show(sw);
	
	/* Model, datos*/
	store = gtk_tree_store_new(1, G_TYPE_STRING);
	
	/* Creamos View */
	tree = gtk_tree_view_new_with_model(GTK_TREE_MODEL(store));
	gtk_tree_view_set_rules_hint (GTK_TREE_VIEW(tree), TRUE);
	g_object_unref(G_OBJECT(store));
	gtk_widget_show(tree);
	
	/* Añadimos la columna */
	rend = gtk_cell_renderer_text_new();
	col = gtk_tree_view_column_new_with_attributes("Cuenta", rend, "text", 0, NULL);
	gtk_tree_view_append_column(GTK_TREE_VIEW(tree), col);
	
	gtk_container_add (GTK_CONTAINER (sw), tree);
	
	g_object_set_data(G_OBJECT(sw), "treeview", tree);
	
	g_signal_connect((gpointer) tree, "button-press-event",
						G_CALLBACK(pgc_tree_popup), window);
	
	return sw;
}


GtkWidget*
pgc_crear_cuenta_dialog ()
{
  GtkWidget *dialog1;
  GtkWidget *dialog_vbox1;
  GtkWidget *vbox1;
  GtkWidget *hbox1;
  GtkWidget *label3;
  GtkWidget *entry2;
  GtkWidget *label4;
  GtkWidget *entry3;
  GtkWidget *label2;
  GtkWidget *entry1;
  GtkWidget *label1;
  GtkWidget *scrolledwindow1;
  GtkWidget *textview1;
  GtkWidget *dialog_action_area1;
  GtkWidget *button1;
  GtkWidget *button2;

  dialog1 = gtk_dialog_new ();
  gtk_window_set_title (GTK_WINDOW (dialog1), _("Nueva cuenta"));
  gtk_window_set_type_hint (GTK_WINDOW (dialog1), GDK_WINDOW_TYPE_HINT_DIALOG);

  dialog_vbox1 = GTK_DIALOG (dialog1)->vbox;
  gtk_widget_show (dialog_vbox1);

  vbox1 = gtk_vbox_new (FALSE, 12);
  gtk_widget_show (vbox1);
  gtk_box_pack_start (GTK_BOX (dialog_vbox1), vbox1, TRUE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (vbox1), 6);

  hbox1 = gtk_hbox_new (FALSE, 12);
  gtk_widget_show (hbox1);
  gtk_box_pack_start (GTK_BOX (vbox1), hbox1, FALSE, TRUE, 0);

  label3 = gtk_label_new (_("<b>Cuenta</b>"));
  gtk_widget_show (label3);
  gtk_box_pack_start (GTK_BOX (hbox1), label3, FALSE, FALSE, 0);
  gtk_label_set_use_markup (GTK_LABEL (label3), TRUE);

  entry1 = gtk_entry_new ();
  gtk_widget_show (entry1);
  gtk_box_pack_start (GTK_BOX (hbox1), entry1, TRUE, TRUE, 0);

  label4 = gtk_label_new (_("es subcuenta de"));
  gtk_widget_show (label4);
  gtk_box_pack_start (GTK_BOX (hbox1), label4, FALSE, FALSE, 0);

  entry2 = gtk_entry_new ();
  gtk_entry_set_editable(GTK_ENTRY(entry2), FALSE);
  gtk_widget_show (entry2);
  gtk_box_pack_start (GTK_BOX (hbox1), entry2, TRUE, TRUE, 0);

  label2 = gtk_label_new (_("<b>Nombre de la cuenta</b>"));
  gtk_widget_show (label2);
  gtk_box_pack_start (GTK_BOX (vbox1), label2, FALSE, FALSE, 0);
  gtk_label_set_use_markup (GTK_LABEL (label2), TRUE);
  gtk_misc_set_alignment (GTK_MISC (label2), 0, 0.5);

  entry3 = gtk_entry_new ();
  gtk_widget_show (entry3);
  gtk_box_pack_start (GTK_BOX (vbox1), entry3, FALSE, FALSE, 0);

  label1 = gtk_label_new (_("Descripci\303\263n de la cuenta:"));
  gtk_widget_show (label1);
  gtk_box_pack_start (GTK_BOX (vbox1), label1, FALSE, FALSE, 0);
  gtk_misc_set_alignment (GTK_MISC (label1), 0, 0.5);

  scrolledwindow1 = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_show (scrolledwindow1);
  gtk_box_pack_start (GTK_BOX (vbox1), scrolledwindow1, TRUE, TRUE, 0);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow1), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);

  textview1 = gtk_text_view_new ();
  gtk_widget_show (textview1);
  gtk_container_add (GTK_CONTAINER (scrolledwindow1), textview1);

  dialog_action_area1 = GTK_DIALOG (dialog1)->action_area;
  gtk_widget_show (dialog_action_area1);
  gtk_button_box_set_layout (GTK_BUTTON_BOX (dialog_action_area1), GTK_BUTTONBOX_END);

  button1 = gtk_button_new_from_stock ("gtk-cancel");
  gtk_widget_show (button1);
  gtk_dialog_add_action_widget (GTK_DIALOG (dialog1), button1, GTK_RESPONSE_CANCEL);
  GTK_WIDGET_SET_FLAGS (button1, GTK_CAN_DEFAULT);

  button2 = gtk_button_new_from_stock ("gtk-ok");
  gtk_widget_show (button2);
  gtk_dialog_add_action_widget (GTK_DIALOG (dialog1), button2, GTK_RESPONSE_OK);
  GTK_WIDGET_SET_FLAGS (button2, GTK_CAN_DEFAULT);
  
  g_object_set_data(G_OBJECT(dialog1), "entry1", entry1);
  g_object_set_data(G_OBJECT(dialog1), "entry2", entry2);
  g_object_set_data(G_OBJECT(dialog1), "entry3", entry3);
  g_object_set_data(G_OBJECT(dialog1), "textview1", textview1);

  return dialog1;
}


void
pgc_barra_cerrar	(GtkToolButton * b,
					 gpointer window)
{
	gconta_barra_cerrar(window);
}

void
pgc_barra_combo_changed		(GtkComboBox *combobox,
							 gpointer window)
{
//	GtkStatusbar *st;
//	GThread *uno;
	GtkWidget *child;
	GtkWidget *bar;
	GtkComboBox *combo;
	GtkTreeView *treeview;
	GtkListStore *store;
	GtkTreeStore *store2;
	GtkTreeIter iter;
	gchar *buffer;
		
//	st = g_object_get_data(window, "statusbar");
//	gtk_statusbar_push(st, 1, _("Consultando"));
	child = gconta_get_child(window);
	bar = g_object_get_data(G_OBJECT(child), "barra");
	combo = g_object_get_data(G_OBJECT(bar), "combobox1");
	store = (GtkListStore*) gtk_combo_box_get_model(combo);
	if (gtk_combo_box_get_active_iter(combo, &iter)) {
		gtk_tree_model_get(GTK_TREE_MODEL(store), &iter, 0, &buffer, -1);
		if (strlen(buffer) == 0) return;
		treeview = g_object_get_data(G_OBJECT(child), "treeview");
		store2 = (GtkTreeStore *)gtk_tree_view_get_model(treeview);
		gtk_tree_store_clear(store2);
		g_object_set_data(G_OBJECT(store2), "nombre", buffer);
		
		//if (!g_thread_supported ()) g_thread_init (NULL);
	    //uno =  g_thread_create (pgc_llenar, treeview, FALSE, NULL);
		
		pgc_llenar(store2);
		gtk_tree_view_expand_all(treeview);
		g_free(buffer);
	} else g_error("No se pudo adquirir el iter del combo\n");
}


gpointer
pgc_llenar(gpointer store)
{
	gchar *buffer;
//	static GStaticMutex mutex = G_STATIC_MUTEX_INIT;

	
//	g_static_mutex_lock (&mutex);
	buffer = g_object_get_data(G_OBJECT(store), "nombre");
	if (gconta_conectado()) xml_pgc_modos_cargar(GTK_TREE_STORE(store), buffer);
//	g_static_mutex_unlock (&mutex);
	
	return NULL;
}


void
pgc_llenar_nodos(GtkTreeStore * store, GtkTreeIter *iter_parent, gint ini, gint fin, gint mas)
{
	GdaCommand * cmd;
	GdaDataModel * data;
	GdaValue * v;
	GtkTreeIter iter;
	gint i, n_cuenta;
	gchar * string, *string2;
	gchar buffer[MAX_BUFFER];
	

	g_snprintf(buffer, MAX_BUFFER,
		"SELECT cuenta, nombre FROM PGC%d WHERE cuenta >= %d AND cuenta < %d ORDER BY 1",
		gconta_main.year, ini, fin);
	cmd = gda_command_new(buffer, GDA_COMMAND_TYPE_SQL, GDA_COMMAND_OPTION_STOP_ON_ERRORS);
	data = gda_connection_execute_single_command(gconta_main.conn, cmd, NULL);
	gda_command_free(cmd);
	if (data == NULL) {
		gconta_errores();
		return;
	}
	
	for (i = 0; i < gda_data_model_get_n_rows (data); i++) {
		gtk_tree_store_append(store, &iter, iter_parent);

		v = (GdaValue *) gda_data_model_get_value_at(data, 0, i);
		string = gda_value_stringify(v);
		n_cuenta = gda_value_get_integer(v);

		v = (GdaValue *) gda_data_model_get_value_at(data, 1, i);
		string2 = gda_value_stringify(v);
		
		g_snprintf(buffer, MAX_BUFFER, "(%s) %s", string, string2);
		gtk_tree_store_set(store, &iter, 0, buffer, -1);
		g_free (string);
		g_free (string2);
		
		if (mas != 0) pgc_llenar_nodos_padre(store, &iter, n_cuenta, mas);
	}

	g_object_unref(G_OBJECT(data));
	
}

void
pgc_llenar_nodos_padre(GtkTreeStore * store, GtkTreeIter *iter_parent, gint n_cuenta, gint mas)
{
	GdaCommand * cmd;
	GdaDataModel * data;
	GdaValue * v;
	gint i, n;
	gchar buffer[MAX_BUFFER];
	
	g_assert(mas != 0);
	g_snprintf(buffer, MAX_BUFFER, "SELECT cuenta FROM PGC%d WHERE padre = %d ORDER BY 1", gconta_main.year, n_cuenta);
	cmd = gda_command_new(buffer, GDA_COMMAND_TYPE_SQL, GDA_COMMAND_OPTION_STOP_ON_ERRORS);
	data = gda_connection_execute_single_command(gconta_main.conn, cmd, NULL);
	gda_command_free(cmd);
	if (data == NULL) {
		gconta_errores();
		return;
	}

	for (i = 0; i < gda_data_model_get_n_rows (data); i++) {
		v = (GdaValue *) gda_data_model_get_value_at(data, 0, i);
		n = gda_value_get_integer(v);

		if (mas < 0) mas = -1;
		pgc_llenar_nodos(store, iter_parent, n, n + 1, mas - 1);
	}
	g_object_unref(G_OBJECT(data));
	
}

gboolean
pgc_comprobar_es_subcuenta (const gchar * c1, const gchar *c2)
{
	int i1, i2;
	gchar buffer[MAX_BUFFER];
	
	i1 = g_ascii_strtod(c1, NULL);
	i2 = g_ascii_strtod(c2, NULL);
	
	// Compruebo que la cuenta es correcta
	if (i1 <= 0) return FALSE;
	
	// Compruebo que no tenga decimiles ...
	g_snprintf(buffer, MAX_BUFFER, "%d", i1);
	if (strlen(c1) != strlen(buffer)) return FALSE;
	
	// c1 debe tener mas digitos que c2	
	if (strlen(c1) <= strlen(c2)) return FALSE;
		
	// Si c1 es subcuenta debe tener los mismo digitos iniciales
	if (i2 != 0 && g_ascii_strncasecmp(c1, c2, strlen(c2)) != 0) return FALSE;
		
	return TRUE;
}

void
pgc_barra_add		(GtkToolButton * b,
					 gpointer window)
{
	GtkWidget *dialog;
	GtkWidget *dialog2;
	GtkWidget *child;
	GtkEntry *entry;
	GtkTextView *textview;
	GtkTreeView *treeview;
	GtkTextBuffer *textbuffer;
	GtkTreeModel *store = NULL;
	GtkTreePath *path;
	GtkTreeIter iter, iter3;
	GtkTextIter iter1, iter2;
	
	GdaTransaction *trans;
	GdaDataModel *data;
	GdaCommand * cmd;
	GdaValue *v;
	gchar *s0, *s1;
	gchar buffer[MAX_BUFFER];
	gint c1, c2;
	gboolean ok;

	g_return_if_fail(gconta_conectado());

	dialog = pgc_crear_cuenta_dialog();
	child = gconta_get_child(window);
	treeview = g_object_get_data(G_OBJECT(child), "treeview");
	gtk_tree_view_get_cursor(treeview, &path, NULL);
	if (path != NULL) {
		store = gtk_tree_view_get_model(treeview);
		gtk_tree_model_get_iter(store, &iter, path);
		gtk_tree_model_get(store, &iter, 0, &s0, -1);
		g_snprintf(buffer, MAX_BUFFER, "%d", gconta_analiza(s0));
		g_free(s0);
		
		entry = g_object_get_data(G_OBJECT(dialog), "entry1");
		gtk_entry_set_text(entry, buffer);
		entry = g_object_get_data(G_OBJECT(dialog), "entry2");
		gtk_entry_set_text(entry, buffer);
	}
	
	ok = TRUE;
	do {
		if (gtk_dialog_run(GTK_DIALOG(dialog)) == GTK_RESPONSE_OK) {
			ok = pgc_comprobar_es_subcuenta(
					gtk_entry_get_text(GTK_ENTRY(g_object_get_data(G_OBJECT(dialog), "entry1"))),
					gtk_entry_get_text(GTK_ENTRY(g_object_get_data(G_OBJECT(dialog), "entry2"))));
			if (!ok) {
				dialog2 = create_dialog("La cuenta especificada no es correcta", TRUE);
				gtk_dialog_run(GTK_DIALOG(dialog2));
				gtk_widget_destroy(dialog2);			
			} 
			if (strlen(gtk_entry_get_text(
						GTK_ENTRY(g_object_get_data(G_OBJECT(dialog), "entry3")))) == 0) {
				dialog2 = create_dialog("Debe escribir un nombre para la cuenta", TRUE);
				gtk_dialog_run(GTK_DIALOG(dialog2));
				gtk_widget_destroy(dialog2);			
				ok = FALSE;
			}
			if (ok) {
				entry = g_object_get_data(G_OBJECT(dialog), "entry1");
				c1 = g_ascii_strtod(gtk_entry_get_text(entry), NULL);
				g_snprintf(buffer, MAX_BUFFER, "SELECT cuenta FROM PGC%d WHERE cuenta = %d", gconta_main.year, c1);
				cmd = gda_command_new(buffer, GDA_COMMAND_TYPE_SQL, GDA_COMMAND_OPTION_STOP_ON_ERRORS);
				data = gda_connection_execute_single_command(gconta_main.conn, cmd, NULL);
				gda_command_free(cmd);	
				if (data == NULL) {
					gconta_errores();
					return;
				}
				
				v = (GdaValue *) gda_data_model_get_value_at(data, 0, 0);
				if (v != NULL) {
					dialog2 = create_dialog("La cuenta ya existe", TRUE);
					gtk_dialog_run(GTK_DIALOG(dialog2));
					gtk_widget_destroy(dialog2);
					ok = FALSE;
				}
				g_object_unref(data);

			}
		} else {
			gtk_widget_destroy(dialog);
			return;
		}
	} while (!ok);

	entry = g_object_get_data(G_OBJECT(dialog), "entry1");
	c1 = g_ascii_strtod(gtk_entry_get_text(entry), NULL);
	entry = g_object_get_data(G_OBJECT(dialog), "entry2");
	c2 = g_ascii_strtod(gtk_entry_get_text(entry), NULL);
	
	entry = g_object_get_data(G_OBJECT(dialog), "entry3");
	s0 = g_strdup(gtk_entry_get_text(entry));
	textview = g_object_get_data(G_OBJECT(dialog), "textview1");
	textbuffer = gtk_text_view_get_buffer(textview);
	if (gtk_text_buffer_get_char_count(textbuffer) != 0) {
		gtk_text_buffer_get_bounds(textbuffer, &iter1, &iter2);
		s1 = gtk_text_buffer_get_text(textbuffer, &iter1, &iter2, FALSE);
	} else s1 = NULL;
	
	gtk_widget_destroy(dialog);
	//Cuenta, subcuentas y nombre correctos

	// Comprobar que la cuenta no existe
	
	// Transacción para insertar datos en pgc
	// INSERT INTO PGC(cuenta, nombre, padre)
	//  VALUES (%d, \"%s\", %s) <-- numero o NULL
	// INSERT INTO PGC_DESCRIPCION(cuenta, descripcion)
	//  VALUES (%d, \"%s\")
	
	
	if (!gda_connection_supports(gconta_main.conn,
		GDA_CONNECTION_FEATURE_TRANSACTIONS))
	{
		dialog = create_dialog ("El SGBD no soporta transacciones!!", TRUE);
		gtk_dialog_run (GTK_DIALOG (dialog));
		gtk_widget_destroy (dialog);
		return;
	}
	
	/* comienza transaccion */
	trans = gda_transaction_new ("cuenta");
	gda_transaction_set_isolation_level (trans,
					     GDA_TRANSACTION_ISOLATION_SERIALIZABLE);
	if (!gda_connection_begin_transaction (gconta_main.conn, trans)) {
		gconta_errores ();
		dialog = create_dialog ("No se pudo comenzar la transacción", TRUE);
		gtk_dialog_run (GTK_DIALOG (dialog));
		gtk_widget_destroy (dialog);
		return;
	}
	/* Insertar en PGC */
	if (c2 == 0)
		g_snprintf (buffer, MAX_BUFFER,
			"INSERT INTO PGC%d(cuenta, nombre, padre) VALUES (%d, '%s', NULL)",
			gconta_main.year, c1, s0);
	else g_snprintf (buffer, MAX_BUFFER,
			"INSERT INTO PGC%d(cuenta, nombre, padre) VALUES (%d, '%s', %d)",
			gconta_main.year, c1, s0, c2);
	GCONTA_nonquery(buffer, "Ocurrió un error al guardar la cuenta", trans);
	
	/* Si hay algo en descripcion insertar en PGC_DESCRIPCION */
	if (s1 != NULL)
	{
		g_snprintf (buffer, MAX_BUFFER,
			   "INSERT INTO PGC_DESCRIPCION%d (cuenta, descripcion) VALUES (%d, '%s')",
			   gconta_main.year, c1, s1);
		g_free (s1);
		GCONTA_nonquery (buffer, "Ocurrió un error al guardar la descripción", trans);
	}
	
	gda_connection_commit_transaction (gconta_main.conn, trans);
	g_object_unref (trans);

	if (path != NULL) {
		g_snprintf(buffer, MAX_BUFFER, "(%d) %s", c1, s0);
		gtk_tree_store_append(GTK_TREE_STORE(store), &iter3, &iter);
		gtk_tree_store_set(GTK_TREE_STORE(store), &iter3, 0, buffer, -1);
	}
	g_free(s0);
}



void
pgc_barra_remove	(GtkToolButton * b,
					 gpointer window)
{
	GtkNotebook * nb;
	GtkWidget * child;
	GtkWidget * dialog;
	GtkTreeView * treeview;
	GtkTreePath * path;
	GtkTreeIter iter;
	GtkTreeModel *store;
	gint n, sal, cuenta;
	gchar *buffer;
	gchar buffer2[MAX_BUFFER];
	GdaTransaction *trans;	

	nb = g_object_get_data(window, "notebook");
	n = gtk_notebook_get_current_page(nb);
	child = gtk_notebook_get_nth_page(nb, n);
	treeview = g_object_get_data(G_OBJECT(child), "treeview");
	store = gtk_tree_view_get_model(treeview);
	gtk_tree_view_get_cursor(treeview, &path, NULL);
	if (path != NULL) {
		gtk_tree_model_get_iter(store, &iter, path);
		gtk_tree_model_get(store, &iter, 0, &buffer, -1);
		cuenta = gconta_analiza(buffer);
		g_free(buffer);
		if (cuenta != 0 && gconta_conectado()) {
			if (pgc_barra_remove_tiene_hijos(cuenta)) {
				dialog = create_dialog("No se puede eliminar una cuenta que tenga subcuentas", TRUE);
				gtk_dialog_run(GTK_DIALOG(dialog));
				gtk_widget_destroy(dialog);
				return;
			}
			if (pgc_barra_remove_tiene_partidas(cuenta)) {
				dialog = create_dialog("No se puede eliminar una cuenta que tenga partidas", TRUE);
				gtk_dialog_run(GTK_DIALOG(dialog));
				gtk_widget_destroy(dialog);
				return;
			}

			dialog = create_dialog("¿Eliminar la cuenta seleccionada?", FALSE);
			sal = gtk_dialog_run (GTK_DIALOG (dialog));
			gtk_widget_destroy(dialog);
			if (sal == GTK_RESPONSE_ACCEPT) {
				
				//Transaccion para elimnar cuentas del pgc
	
				if (!gda_connection_supports(gconta_main.conn,
					GDA_CONNECTION_FEATURE_TRANSACTIONS))
				{
					dialog = create_dialog ("El SGBD no soporta transacciones!!", TRUE);
					gtk_dialog_run (GTK_DIALOG (dialog));
					gtk_widget_destroy (dialog);
					return;
				}
				
				/* comienza transaccion */
				trans = gda_transaction_new ("cuentaborrar");
				gda_transaction_set_isolation_level (trans,
									 GDA_TRANSACTION_ISOLATION_SERIALIZABLE);
				if (!gda_connection_begin_transaction (gconta_main.conn, trans)) {
					gconta_errores ();
					dialog = create_dialog ("No se pudo comenzar la transacción para eliminar", TRUE);
					gtk_dialog_run (GTK_DIALOG (dialog));
					gtk_widget_destroy (dialog);
					return;
				}
				
				g_snprintf(buffer2, MAX_BUFFER, "DELETE FROM PGC_DESCRIPCION%d WHERE cuenta = %d", gconta_main.year, cuenta);
				GCONTA_nonquery(buffer2, "Ocurrió un error al eliminar la cuenta", trans);
				
				g_snprintf(buffer2, MAX_BUFFER, "DELETE FROM PGC%d WHERE cuenta = %d", gconta_main.year, cuenta);
				GCONTA_nonquery(buffer2, "Ocurrió un error al guardar la cuenta", trans);
				
				if (!gda_connection_commit_transaction (gconta_main.conn, trans)) {
					g_object_unref (trans);
					gconta_errores();
					dialog = create_dialog
						("No se pudo completar la transacción", TRUE);
					gtk_widget_destroy(dialog);
					return;
				}
				g_object_unref (trans);
				gtk_tree_store_remove(GTK_TREE_STORE(store), &iter);
			}
		} else g_warning("No conectado!");
	}
}

gboolean
pgc_barra_remove_tiene_hijos(gint n_cuenta)
{
	GdaCommand * cmd;
	GdaDataModel * data;
	GdaValue * v;
	gint n;
	gchar buffer[MAX_BUFFER];
	gchar *t;
	
	g_snprintf(buffer, MAX_BUFFER, "SELECT COUNT(*) FROM PGC%d WHERE padre = %d", gconta_main.year, n_cuenta);
	cmd = gda_command_new(buffer, GDA_COMMAND_TYPE_SQL, GDA_COMMAND_OPTION_STOP_ON_ERRORS);
	data = gda_connection_execute_single_command(gconta_main.conn, cmd, NULL);
	gda_command_free(cmd);
	if (data == NULL) {
		gconta_errores();
		return TRUE;
	}
	
	v = (GdaValue *) gda_data_model_get_value_at(data, 0, 0);
	t = gda_value_stringify(v);
	n = g_ascii_strtod(t, NULL);
	g_free(t);
	g_object_unref(G_OBJECT(data));

	return n != 0;
}

gboolean
pgc_barra_remove_tiene_partidas(gint n_cuenta)
{
	GdaCommand * cmd;
	GdaDataModel * data;
	GdaValue * v;
	gchar buffer[MAX_BUFFER];
	gchar *tt;
	gboolean ok;

	ok = TRUE;	
	g_snprintf(buffer, MAX_BUFFER, "SELECT COUNT(*) FROM DIARIO_DEBE%d WHERE cuenta = %d UNION "
		"SELECT COUNT(*) FROM DIARIO_HABER%d WHERE cuenta = %d", gconta_main.year, n_cuenta, gconta_main.year, n_cuenta);
	cmd = gda_command_new(buffer, GDA_COMMAND_TYPE_SQL, GDA_COMMAND_OPTION_STOP_ON_ERRORS);
	data = gda_connection_execute_single_command(gconta_main.conn, cmd, NULL);
	gda_command_free(cmd);
	if (data == NULL) {
		gconta_errores();
		return TRUE;
	}
	
	v = (GdaValue *) gda_data_model_get_value_at(data, 0, 0);
	tt = gda_value_stringify(v);
	if (strcmp(tt, "0") == 0) {
		if (gda_data_model_get_n_rows(data) > 1) {
			g_free(tt);
			v = (GdaValue *) gda_data_model_get_value_at(data, 0, 1);
			tt = gda_value_stringify(v);
			if (strcmp(tt, "0") == 0) ok = FALSE;
		} else ok = FALSE;
	}
	g_free(tt);
	g_object_unref(G_OBJECT(data));

	return ok;
}


gboolean
pgc_tree_popup	(GtkWidget *treeview,
				GdkEventButton *event,
                gpointer window)
{
	GtkWidget * menu, * menuitem;
	GtkWidget * tmp_image;
	
	if (event->type == GDK_BUTTON_PRESS  &&  event->button == 3) {
		menu = gtk_menu_new();
		
		menuitem = gtk_image_menu_item_new_with_label("Añadir");
		tmp_image =	gtk_image_new_from_stock ("gtk-add", GTK_ICON_SIZE_MENU);
		gtk_image_menu_item_set_image(GTK_IMAGE_MENU_ITEM(menuitem), tmp_image);
		gtk_menu_shell_append(GTK_MENU_SHELL(menu), menuitem);
		g_signal_connect(menuitem, "activate",
							G_CALLBACK(pgc_barra_add), window);

		menuitem = gtk_image_menu_item_new_with_label("Eliminar");
		tmp_image =	gtk_image_new_from_stock ("gtk-remove", GTK_ICON_SIZE_MENU);
		gtk_image_menu_item_set_image(GTK_IMAGE_MENU_ITEM(menuitem), tmp_image);
		gtk_menu_shell_append(GTK_MENU_SHELL(menu), menuitem);
		g_signal_connect(menuitem, "activate",
							G_CALLBACK(pgc_barra_remove), window);

		menuitem = gtk_image_menu_item_new_with_label("Ver Mayor");
		tmp_image =	gtk_image_new_from_stock ("gtk-justify-center", GTK_ICON_SIZE_MENU);
		gtk_image_menu_item_set_image(GTK_IMAGE_MENU_ITEM(menuitem), tmp_image);
		gtk_menu_shell_append(GTK_MENU_SHELL(menu), menuitem);
		g_signal_connect(menuitem, "activate",
							G_CALLBACK(pgc_barra_ver_mayor), window);

		menuitem = gtk_image_menu_item_new_with_label("Ver Descripcion");
		tmp_image =	gtk_image_new_from_stock ("gtk-dialog-question", GTK_ICON_SIZE_MENU);
		gtk_image_menu_item_set_image(GTK_IMAGE_MENU_ITEM(menuitem), tmp_image);
		gtk_menu_shell_append(GTK_MENU_SHELL(menu), menuitem);
		g_signal_connect(menuitem, "activate",
							G_CALLBACK(pgc_barra_ver_descripcion), window);

		gtk_widget_show_all(menu);
		gtk_menu_popup(GTK_MENU(menu), NULL, NULL, NULL, NULL,
						(event != NULL) ? event->button : 0,
						gdk_event_get_time((GdkEvent*)event));
	}
	
	return FALSE;
}

void
pgc_barra_contraer	(GtkToolButton *b,
					gpointer window)
{
	GtkNotebook * nb;
	GtkWidget * child;
	GtkTreeView *treeview;
	gint n;

	nb = g_object_get_data(window, "notebook");
	n = gtk_notebook_get_current_page(nb);
	child = gtk_notebook_get_nth_page(nb, n);
	treeview = g_object_get_data(G_OBJECT(child), "treeview");
	gtk_tree_view_collapse_all(treeview);
}

void
pgc_barra_expandir	(GtkToolButton *b,
					gpointer window)
{
	GtkNotebook * nb;
	GtkWidget * child;
	GtkTreeView *treeview;
	gint n;

	nb = g_object_get_data(window, "notebook");
	n = gtk_notebook_get_current_page(nb);
	child = gtk_notebook_get_nth_page(nb, n);
	treeview = g_object_get_data(G_OBJECT(child), "treeview");
	gtk_tree_view_expand_all(treeview);
}

void
pgc_barra_ver_mayor (GtkToolButton *b,
					gpointer window)
{
	GtkWidget *child;
	GtkEntry *entry1;
	GtkTreeView *treeview;
	GtkTreeModel *store;
	GtkTreePath *path;
	GtkTreeIter iter;
	gchar *s0;
	gchar buffer[MAX_BUFFER];
	gint n;
	
	child = gconta_get_child(window);
	treeview = g_object_get_data(G_OBJECT(child), "treeview");
		
	gtk_tree_view_get_cursor(treeview, &path, NULL);
	if (path != NULL) {
		store = gtk_tree_view_get_model(treeview);
		gtk_tree_model_get_iter(store, &iter, path);
		gtk_tree_model_get(store, &iter, 0, &s0, -1);
		n = gconta_analiza(s0);
		g_free(s0);
		
		if (n >= 100) {
			g_snprintf(buffer, MAX_BUFFER, "%d", n);
			boton_mayor(NULL, window);
			child = gconta_get_child(window);
			entry1 = g_object_get_data(G_OBJECT(child), "entry1");
			gtk_entry_set_text(entry1, buffer);
			mayor_ver(window);
		}
	}
}

void
pgc_barra_ver_descripcion	(GtkToolButton *b,
							gpointer window)
{
	GtkWidget *child;
	GtkTreeView *treeview;
	GtkTreeModel *store;
	GtkTreePath *path;
	GtkTreeIter iter;
	gchar *s0;
	gchar buffer[MAX_BUFFER];
	gint n;
	
	child = gconta_get_child(window);
	treeview = g_object_get_data(G_OBJECT(child), "treeview");
		
	gtk_tree_view_get_cursor(treeview, &path, NULL);
	if (path != NULL) {
		store = gtk_tree_view_get_model(treeview);
		gtk_tree_model_get_iter(store, &iter, path);
		gtk_tree_model_get(store, &iter, 0, &s0, -1);
		n = gconta_analiza(s0);
		g_free(s0);
		
		if (n >= 100) {
			g_snprintf(buffer, MAX_BUFFER, "%d", n);
			boton_consultas(NULL, window);
			consultas_ver(buffer, window);
		}
	}
}
