/*
 * principal.c
 * This file is part of gconta
 *
 * Copyright (C) 2004 Bruno Orcha Garcia
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, 
 * Boston, MA 02111-1307, USA. 
 */

#include "principal.h"

GtkWidget *
crear_menu_stock (gchar *stock, gchar *text, GtkWidget *menu)
{
	GtkWidget *tmp_image;
	GtkWidget *item;
	
	tmp_image = gtk_image_new_from_stock(stock, GTK_ICON_SIZE_MENU);
	item = gtk_image_menu_item_new_with_mnemonic(text);
	gtk_image_menu_item_set_image(GTK_IMAGE_MENU_ITEM(item), tmp_image);
	gtk_widget_show(item);
	gtk_container_add(GTK_CONTAINER(menu), item);
	
	return item;
}




GtkWidget *
crear_menu (GtkWidget *window)
{
	GtkWidget *menubar1;
	GtkWidget *menuitem1;
	GtkWidget *menuitem2;
	GtkWidget *menuitem3;
	GtkWidget *menuitem4;
	GtkWidget *menu1;
	GtkWidget *menu2;
	GtkWidget *menu3;
	GtkWidget *menu4;
	
	GtkWidget *exit;
	GtkWidget *ex_pgc;
	GtkWidget *pgc;
	GtkWidget *diario;
	GtkWidget *mayor;
	GtkWidget *separator1;
	GtkWidget *a_cierre;
	
	GtkWidget *ldiario;
	GtkWidget *lmayor;
	
	GtkWidget *manual;
	GtkWidget *notas;
	GtkWidget *consultas;
	GtkWidget *about;

	menubar1 = gtk_menu_bar_new ();
	gtk_widget_show (menubar1);

	menuitem1 = gtk_menu_item_new_with_mnemonic (_("_Empresa"));
	gtk_widget_show (menuitem1);
	gtk_container_add (GTK_CONTAINER (menubar1), menuitem1);

	menu1 = gtk_menu_new ();
	gtk_menu_item_set_submenu (GTK_MENU_ITEM (menuitem1), menu1);
	
	ex_pgc = crear_menu_stock(NULL, "_Exportar Plan", menu1);

	separator1 = gtk_separator_menu_item_new();
	gtk_widget_show(separator1);
	gtk_container_add(GTK_CONTAINER(menu1), separator1);
	
	exit = crear_menu_stock("gtk-quit", "_Salir", menu1);
	
	menuitem2 = gtk_menu_item_new_with_mnemonic (_("Contabilidad"));
	gtk_widget_show (menuitem2);
	gtk_container_add (GTK_CONTAINER (menubar1), menuitem2);

	menu2 = gtk_menu_new ();
	gtk_menu_item_set_submenu (GTK_MENU_ITEM (menuitem2), menu2);

	pgc = crear_menu_stock("gtk-index", "_Plan General Contable", menu2);
	diario = crear_menu_stock("gtk-justify-center", "_Diario", menu2);
	mayor = crear_menu_stock("gtk-copy", "_Mayor", menu2);

	separator1 = gtk_separator_menu_item_new();
	gtk_widget_show(separator1);
	gtk_container_add(GTK_CONTAINER(menu2), separator1);

	a_cierre = crear_menu_stock(NULL, "_Asiento de cierre", menu2);
	
	menuitem3 = gtk_menu_item_new_with_mnemonic (_("_Listados"));
	gtk_widget_show (menuitem3);
	gtk_container_add (GTK_CONTAINER (menubar1), menuitem3);

	menu3 = gtk_menu_new ();
	gtk_menu_item_set_submenu (GTK_MENU_ITEM (menuitem3), menu3);

	ldiario = crear_menu_stock("gtk-justify-center", "Listado de _Diario", menu3);
	lmayor = crear_menu_stock("gtk-copy", "Listado de _Mayor", menu3);

	menuitem4 = gtk_menu_item_new_with_mnemonic (_("_Ayuda"));
	gtk_widget_show (menuitem4);
	gtk_container_add (GTK_CONTAINER (menubar1), menuitem4);

	menu4 = gtk_menu_new ();
	gtk_menu_item_set_submenu (GTK_MENU_ITEM (menuitem4), menu4);

	manual = crear_menu_stock("gtk-help", "_Manual", menu4);
	gtk_widget_set_sensitive(manual, FALSE);
	notas = crear_menu_stock("gtk-new", "_Notas", menu4);
	consultas = crear_menu_stock("gtk-dialog-info", "_Consultas", menu4);
	
	separator1 = gtk_separator_menu_item_new();
	gtk_widget_show(separator1);
	gtk_container_add(GTK_CONTAINER(menu4), separator1);
	
	about = crear_menu_stock("gtk-jump-to", "_Sobre gconta", menu4);

	g_signal_connect(exit, "activate", G_CALLBACK(gtk_main_quit), (gpointer) window);	
	g_signal_connect(ex_pgc, "activate", G_CALLBACK(exportar_pgc), (gpointer) window);
	g_signal_connect(pgc, "activate", G_CALLBACK(boton_pgc), (gpointer) window);
	g_signal_connect(diario, "activate", G_CALLBACK(boton_diario), (gpointer) window);
	g_signal_connect(mayor, "activate", G_CALLBACK(boton_mayor), (gpointer) window);
	g_signal_connect(a_cierre, "activate", G_CALLBACK(asiento_cierre), (gpointer) window);
	g_signal_connect(ldiario, "activate", G_CALLBACK(listado_de_diario), (gpointer) window);
	g_signal_connect(lmayor, "activate", G_CALLBACK(listado_de_mayor), (gpointer) window);
	g_signal_connect(notas, "activate", G_CALLBACK(boton_notas), (gpointer) window);
	g_signal_connect(consultas, "activate", G_CALLBACK(boton_consultas), (gpointer) window);
	g_signal_connect(about, "activate", G_CALLBACK(gconta_about), (gpointer) window);
	
	return menubar1;
}


GtkWidget *
create_window1 (void)
{
	GtkWidget *window;
	GtkWidget *vbox;
	GtkWidget *vbox2;
	GtkWidget *menubar;
	GtkWidget *toolbar;
	gint tmp_toolbar_icon_size;
	GtkWidget *tmp_image;
	GtkWidget *toolbutton1;
	GtkWidget *toolbutton2;
	GtkWidget *toolbutton3;
	GtkWidget *toolbutton4;
	GtkWidget *toolbutton5;
	GtkWidget *toolbutton7;
	GtkWidget *toolbutton6;
	GtkWidget *notebook;
	GtkWidget *statusbar;
	gchar *file;
	gchar buffer[MAX_BUFFER];
	
	window = gtk_window_new (GTK_WINDOW_TOPLEVEL);
	gtk_window_set_resizable(GTK_WINDOW(window), TRUE);
	gtk_widget_set_size_request (window, 700, 500);
	g_snprintf(buffer, MAX_BUFFER, "%s (Ejercicio %d)", gconta_main.nombre_empresa, gconta_main.year);
	gtk_window_set_title (GTK_WINDOW (window), buffer);
	
	vbox = gtk_vbox_new (FALSE, 0);
	gtk_widget_show (vbox);
	gtk_container_add (GTK_CONTAINER (window), vbox);

	menubar = crear_menu (window);
	gtk_box_pack_start (GTK_BOX (vbox), menubar, FALSE, FALSE, 0);
	
	toolbar = gtk_toolbar_new ();
	gtk_widget_show (toolbar);
	gtk_box_pack_start (GTK_BOX (vbox), toolbar, FALSE, FALSE, 0);
	gtk_toolbar_set_style (GTK_TOOLBAR (toolbar), GTK_TOOLBAR_BOTH_HORIZ);
	tmp_toolbar_icon_size = gtk_toolbar_get_icon_size (GTK_TOOLBAR (toolbar));

	tmp_image =
		gtk_image_new_from_stock ("gtk-index", tmp_toolbar_icon_size);
	gtk_widget_show (tmp_image);
	toolbutton1 = (GtkWidget *) gtk_tool_button_new (tmp_image, _("PGC"));
	gtk_widget_show (toolbutton1);
	gtk_container_add (GTK_CONTAINER (toolbar), toolbutton1);
	gtk_tool_item_set_is_important (GTK_TOOL_ITEM (toolbutton1), TRUE);

	tmp_image =
		gtk_image_new_from_stock ("gtk-justify-center",
					  tmp_toolbar_icon_size);
	gtk_widget_show (tmp_image);
	toolbutton2 =
		(GtkWidget *) gtk_tool_button_new (tmp_image, _("Diario"));
	gtk_widget_show (toolbutton2);
	gtk_container_add (GTK_CONTAINER (toolbar), toolbutton2);
	gtk_tool_item_set_is_important (GTK_TOOL_ITEM (toolbutton2), TRUE);

	tmp_image =
		gtk_image_new_from_stock ("gtk-copy", tmp_toolbar_icon_size);
	gtk_widget_show (tmp_image);
	toolbutton3 =
		(GtkWidget *) gtk_tool_button_new (tmp_image, _("Mayor"));
	gtk_widget_show (toolbutton3);
	gtk_container_add (GTK_CONTAINER (toolbar), toolbutton3);
	gtk_tool_item_set_is_important (GTK_TOOL_ITEM (toolbutton3), TRUE);

	tmp_image =
		gtk_image_new_from_stock ("gtk-dialog-info", tmp_toolbar_icon_size);
	gtk_widget_show (tmp_image);
	toolbutton4 = (GtkWidget *) gtk_tool_button_new (tmp_image, _("Consultar Plan"));
	gtk_widget_show (toolbutton4);
	gtk_container_add (GTK_CONTAINER (toolbar), toolbutton4);
	gtk_tool_item_set_is_important (GTK_TOOL_ITEM (toolbutton4), TRUE);

	tmp_image =
		gtk_image_new_from_stock ("gtk-dnd-multiple", tmp_toolbar_icon_size);
	gtk_widget_show (tmp_image);
	toolbutton5 = (GtkWidget *) gtk_tool_button_new (tmp_image, _("Listados"));
	gtk_widget_show (toolbutton5);
	gtk_container_add (GTK_CONTAINER (toolbar), toolbutton5);
	gtk_tool_item_set_is_important (GTK_TOOL_ITEM (toolbutton5), TRUE);

	tmp_image =
		gtk_image_new_from_stock ("gtk-properties", tmp_toolbar_icon_size);
	gtk_widget_show (tmp_image);
	toolbutton6 = (GtkWidget *) gtk_tool_button_new (tmp_image, _("Informes"));
	gtk_widget_show (toolbutton6);
	gtk_container_add (GTK_CONTAINER (toolbar), toolbutton6);
	gtk_tool_item_set_is_important (GTK_TOOL_ITEM (toolbutton6), TRUE);

	tmp_image =
		gtk_image_new_from_stock ("gtk-new", tmp_toolbar_icon_size);
	gtk_widget_show (tmp_image);
	toolbutton7 = (GtkWidget *) gtk_tool_button_new (tmp_image, _("Notas"));
	gtk_widget_show (toolbutton7);
	gtk_container_add (GTK_CONTAINER (toolbar), toolbutton7);
	gtk_tool_item_set_is_important (GTK_TOOL_ITEM (toolbutton7), TRUE);

/******************************************************/
	vbox2 = gtk_vbox_new(FALSE, 0);
	gtk_box_pack_start (GTK_BOX (vbox), vbox2, FALSE, FALSE, 0);
	
/******************************************************/

	notebook = gtk_notebook_new ();
	gtk_notebook_set_scrollable(GTK_NOTEBOOK(notebook), TRUE);
	gtk_notebook_set_homogeneous_tabs(GTK_NOTEBOOK(notebook), TRUE);
	gtk_notebook_set_show_tabs(GTK_NOTEBOOK(notebook), FALSE);

	file = gconta_uri("logo.jpg");		
	tmp_image = gtk_image_new_from_file(file);
	g_free(file);
	gtk_widget_show(tmp_image);
	gtk_notebook_append_page(GTK_NOTEBOOK(notebook), tmp_image, NULL);

	gtk_widget_show (notebook);
	gtk_box_pack_start (GTK_BOX (vbox), notebook, TRUE, TRUE, 0);


	statusbar = gtk_statusbar_new ();
	gtk_statusbar_push(GTK_STATUSBAR(statusbar), 0, _("Aplicacion iniciada"));
	gtk_widget_show (statusbar);
	gtk_box_pack_start (GTK_BOX (vbox), statusbar, FALSE, FALSE, 0);


	
	GOBJ_SDATA (window, vbox, "vbox");
	GOBJ_SDATA (window, menubar, "menubar");
	GOBJ_SDATA (window, toolbar, "toolbar");
	GOBJ_SDATA (window, vbox2, "vbox2");
	GOBJ_SDATA (window, notebook, "notebook");
	GOBJ_SDATA (window, statusbar, "statusbar");



	g_signal_connect ((gpointer) toolbutton1 , "clicked",
					G_CALLBACK (boton_pgc), window);
	g_signal_connect ((gpointer) toolbutton2 , "clicked",
					G_CALLBACK (boton_diario), window);
	g_signal_connect ((gpointer) toolbutton3 , "clicked",
					G_CALLBACK (boton_mayor), window);
	g_signal_connect ((gpointer) toolbutton4 , "clicked",
					G_CALLBACK (boton_consultas), window);
	g_signal_connect ((gpointer) toolbutton5 , "clicked",
					G_CALLBACK (boton_listados), window);
	g_signal_connect ((gpointer) toolbutton6 , "clicked",
					G_CALLBACK (boton_informes), window);
	g_signal_connect ((gpointer) toolbutton7 , "clicked",
					G_CALLBACK (boton_notas), window);
	g_signal_connect ((gpointer) notebook , "switch-page",
					G_CALLBACK (solapa_cambia), window);
	g_signal_connect ((gpointer) window, "key-press-event",
					G_CALLBACK(gconta_tecla_pulsada), window);
	g_signal_connect (window, "destroy", G_CALLBACK(gtk_main_quit), NULL);
	
	return window;
}

void
gconta_error_dialog (GtkDialog *win, gint arg1, gpointer user_data)
{
	gtk_widget_destroy(GTK_WIDGET(win));
	gconta_main.error_dialog = NULL;
}

void
gconta_errores ()
{
	GtkWidget * text;
	GtkTextBuffer * buffer;
	GtkTextIter iter;
	GList * err, *node;
	GdaError * e;
	gchar message[MAX_BUFFER];
	gboolean ok = FALSE;
	
	err = (GList *) gda_connection_get_errors(gconta_main.conn);
	for(node = g_list_first(err); node != NULL; node = g_list_next(node)) {
		e = (GdaError *)node->data;
		if (!ok  && gconta_main.error_dialog == NULL) {
			gconta_main.error_dialog = gtk_dialog_new_with_buttons ("Error",
					NULL,
					0,
					GTK_STOCK_OK,
					GTK_RESPONSE_ACCEPT,
					NULL);
			g_signal_connect_swapped (gconta_main.error_dialog, "response",
					G_CALLBACK (gconta_error_dialog), NULL);
			gtk_widget_set_size_request(gconta_main.error_dialog, 300, 170);
			text = gtk_text_view_new();
			gtk_text_view_set_editable(GTK_TEXT_VIEW(text), FALSE);
			gtk_text_view_set_cursor_visible(GTK_TEXT_VIEW(text), FALSE);
			gtk_text_view_set_wrap_mode(GTK_TEXT_VIEW(text), GTK_WRAP_WORD_CHAR);
			gtk_container_add(GTK_CONTAINER(GTK_DIALOG(gconta_main.error_dialog)->vbox), text);
			ok = TRUE;
		}

		g_snprintf(message, MAX_BUFFER, "[%d] %s\n", (gint)gda_error_get_number(e), gda_error_get_description(e));
		text = (gtk_container_get_children(GTK_CONTAINER(GTK_DIALOG(gconta_main.error_dialog)->vbox)))->data;
		buffer = gtk_text_view_get_buffer(GTK_TEXT_VIEW(text));
		gtk_text_buffer_get_end_iter(buffer, &iter);
		gtk_text_buffer_insert(buffer, &iter, message,  g_utf8_strlen(message, -1));
	}
	if (ok) gtk_widget_show_all(gconta_main.error_dialog);
}

gboolean
gconta_conectar()
{
	gconta_main.cli = gda_client_new();
	gconta_main.conn = gda_client_open_connection(gconta_main.cli, gconta_main.gda_source, NULL, NULL, 0);//GDA_CONNECTION_OPTIONS_READ_ONLY);
	if (gconta_main.conn == NULL) {
		g_warning("No se pudo conectar\n");
		return FALSE;
	}

	//g_signal_connect(G_OBJECT(gconta_main.cli), "error", gconta_errores, NULL);
	
	return TRUE;
}

GtkWidget*
create_dialog (gchar *text, gboolean information)
{
  GtkWidget *dialog1;
  GtkWidget *dialog_vbox1;
  GtkWidget *hbox1;
  GtkWidget *image1;
  GtkWidget *label1;
  GtkWidget *dialog_action_area1;
  GtkWidget *cancelbutton1;
  GtkWidget *okbutton1;

  dialog1 = gtk_dialog_new ();
  gtk_container_set_border_width (GTK_CONTAINER (dialog1), 6);
  gtk_window_set_title (GTK_WINDOW (dialog1), _("gconta"));
  gtk_window_set_resizable (GTK_WINDOW (dialog1), FALSE);
  gtk_window_set_type_hint (GTK_WINDOW (dialog1), GDK_WINDOW_TYPE_HINT_DIALOG);
  gtk_dialog_set_has_separator (GTK_DIALOG (dialog1), FALSE);

  dialog_vbox1 = GTK_DIALOG (dialog1)->vbox;
  gtk_widget_show (dialog_vbox1);

  hbox1 = gtk_hbox_new (FALSE, 12);
  gtk_widget_show (hbox1);
  gtk_box_pack_start (GTK_BOX (dialog_vbox1), hbox1, TRUE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (hbox1), 6);

  if (information) image1 = gtk_image_new_from_stock ("gtk-dialog-warning", GTK_ICON_SIZE_DIALOG);
  else image1 = gtk_image_new_from_stock ("gtk-dialog-question", GTK_ICON_SIZE_DIALOG);
  gtk_widget_show (image1);
  gtk_box_pack_start (GTK_BOX (hbox1), image1, TRUE, TRUE, 0);
  gtk_misc_set_alignment (GTK_MISC (image1), 0.5, 0);

  label1 = gtk_label_new (text);
  gtk_widget_show (label1);
  gtk_box_pack_start (GTK_BOX (hbox1), label1, FALSE, FALSE, 0);
  gtk_label_set_use_markup (GTK_LABEL (label1), TRUE);
  gtk_label_set_line_wrap (GTK_LABEL (label1), TRUE);
  gtk_misc_set_alignment (GTK_MISC (label1), 0.5, 0);

  dialog_action_area1 = GTK_DIALOG (dialog1)->action_area;
  gtk_widget_show (dialog_action_area1);
  gtk_button_box_set_layout (GTK_BUTTON_BOX (dialog_action_area1), GTK_BUTTONBOX_END);

  if(!information) {
	  cancelbutton1 = gtk_button_new_from_stock ("gtk-no");
	  gtk_widget_show (cancelbutton1);
	  gtk_dialog_add_action_widget (GTK_DIALOG (dialog1), cancelbutton1, GTK_RESPONSE_CANCEL);
	  GTK_WIDGET_SET_FLAGS (cancelbutton1, GTK_CAN_DEFAULT);
	  
	  okbutton1 = gtk_button_new_from_stock ("gtk-yes");
  } else okbutton1 = gtk_button_new_from_stock ("gtk-ok");
  
  gtk_widget_show (okbutton1);
  gtk_dialog_add_action_widget (GTK_DIALOG (dialog1), okbutton1, GTK_RESPONSE_ACCEPT);
  GTK_WIDGET_SET_FLAGS (okbutton1, GTK_CAN_DEFAULT);

  return dialog1;
}

gboolean
gconta_conectado()
{
	return gda_connection_is_open(gconta_main.conn);
}

gboolean
gconta_busca_cuenta_boton	(GtkWidget *widget,
							GdkEventButton *event,
							gpointer window)
{
	GdkEventKey *ev;

	if (event->type == GDK_2BUTTON_PRESS) {
		ev = g_new(GdkEventKey, 1);
		ev->type = GDK_KEY_PRESS;
		ev->keyval = GDK_Return;
		gconta_busca_cuenta_tecla(widget, ev, window);
		g_free(ev);
	}

	return FALSE;
}

gboolean
gconta_busca_cuenta_tecla	(GtkWidget *widget,
							GdkEventKey *event,
							gpointer user_data)
{
	GtkWidget *entry;
	GtkWidget *child;
	GtkTreeView *treeview1;
	GtkTreeView *treeview;
	GtkTreePath *path;
	GtkTreeIter iter;
	GtkListStore *store;
	gchar buffer[MAX_BUFFER];
	gchar *a;
	gint n_cuenta, tipo;
	
	
	switch(event->keyval) {
		case GDK_Escape:
			gtk_widget_destroy(GTK_WIDGET(user_data));
			return TRUE;
			break;
		case GDK_Return:
		case GDK_KP_Enter:
			treeview1 = g_object_get_data(user_data, "treeview1");
			store = g_object_get_data(user_data, "store1");
			gtk_tree_view_get_cursor(treeview1, &path, NULL);
			if (path != NULL && gtk_tree_model_get_iter(GTK_TREE_MODEL(store), &iter, path)) {
				gtk_tree_model_get(GTK_TREE_MODEL(store), &iter, 0, &a, -1);
				n_cuenta = gconta_analiza(a);
				g_snprintf(buffer, MAX_BUFFER, "%d", n_cuenta);
				g_free(a);
				
				/* Obtengo el hijo actual */
				child = gconta_get_child(g_object_get_data(G_OBJECT(user_data), "parent"));
				tipo = GPOINTER_TO_INT(g_object_get_data(G_OBJECT(child), "tipo"));
				switch(tipo) {
				case GCONTA_DIARIO:
					treeview = g_object_get_data(G_OBJECT(child), "treeview");
					store = (GtkListStore *) gtk_tree_view_get_model(treeview);
					gtk_tree_view_get_cursor(treeview, &path, NULL);
					if (path != NULL && gtk_tree_model_get_iter(GTK_TREE_MODEL(store), &iter, path)) {
						gtk_list_store_set(store, &iter, 0, buffer, -1);
						a = gtk_tree_path_to_string(path);
						diario_editar_cuenta(NULL, a, buffer, treeview);
						g_free(a);
						gtk_widget_destroy(GTK_WIDGET(user_data));
					}
					break;
				case GCONTA_MAYOR:
					gtk_entry_set_text(GTK_ENTRY(g_object_get_data(G_OBJECT(child), "entry1")), buffer);
					mayor_ver(g_object_get_data(G_OBJECT(user_data), "parent"));
					gtk_widget_destroy(GTK_WIDGET(user_data));
					break;
				case GCONTA_CONSULTAS:
					consultas_ver(buffer, g_object_get_data(G_OBJECT(user_data), "parent"));
					gtk_widget_destroy(GTK_WIDGET(user_data));
					break;	
				}
				return TRUE;
			}
			if (gtk_tree_model_get_iter_first(GTK_TREE_MODEL(store), &iter)) {
				path = gtk_tree_model_get_path(GTK_TREE_MODEL(store), &iter);
				gtk_tree_view_set_cursor(treeview1, path, NULL, FALSE);
				gtk_widget_grab_focus(GTK_WIDGET(treeview1));
			}

			break;
		case GDK_Tab:
		case GDK_Up:
		case GDK_Down:
		case GDK_Left:
		case GDK_Right:
		case GDK_Page_Up:
		case GDK_Page_Down:
			break;
		default:
			entry = g_object_get_data(user_data, "entry1");
			if (!gtk_widget_is_focus(entry)) {
				gtk_window_set_focus (user_data, entry);
				gtk_editable_set_position (GTK_EDITABLE(entry), -1);
			}
	}
	
	return FALSE;
}

gboolean
gconta_busca_cuenta_compara	(GtkTreeModel *model,
							GtkTreePath *path,
							GtkTreeIter *iter2,
							gpointer data)
{
	gchar * a, *a1;
	gchar * b, *b1;
	gchar **v;
	GtkListStore *store1;
	GtkTreeIter iter;
	gboolean ok;
	gint i;
	
	
	b = g_strdup(gtk_entry_get_text(GTK_ENTRY(g_object_get_data(data, "entry1"))));
	b1 = g_utf8_strup(b, -1);
	g_free(b);
	
	gtk_tree_model_get(model, iter2, 0, &a, -1);
	a1 = g_utf8_strup(a, -1);
	
	ok = TRUE;
	v = g_strsplit (b1, " ", -1);
	if (v != NULL) {
		for(i = 0; ok && v[i] != NULL; i++) {
			b = g_strrstr(a1, v[i]);
			if (b == NULL) ok = FALSE;
		}
	} else ok = FALSE;

	if (ok) {
		store1 = g_object_get_data(data, "store1");
		gtk_list_store_append(store1, &iter);
		gtk_list_store_set(store1, &iter, 0, a, -1);
	}

	g_strfreev(v);	
	g_free(a);
	g_free(a1);
	g_free(b1);
	
	return FALSE;
}

void
gconta_busca_cuenta_editado	(GtkWidget *entry,
							gpointer window)
{
	GtkListStore *store1;
	GtkListStore *store2;
	
	store1 = g_object_get_data(window, "store1");
	store2 = g_object_get_data(window, "store2");
	gtk_list_store_clear(store1);
	
	gtk_tree_model_foreach (GTK_TREE_MODEL(store2), gconta_busca_cuenta_compara, window);
}

GtkWidget*
gconta_busca_cuenta	(GtkWindow *parent)
{
	GtkWidget *window1;
	GtkWidget *vbox1;
	GtkWidget *hbox1;
	GtkWidget *label1;
	GtkWidget *entry1;
	GtkWidget *scrolledwindow1;
	GtkWidget *treeview1;
	GtkListStore *store1;
	GtkListStore *store2;
	GtkCellRenderer *cel;
	GtkTreeViewColumn *col;
	GtkTreeIter iter;
	
	GdaCommand *cmd;
	GdaDataModel *data;
	GdaValue *v;
	gchar *string1;
	gchar *string2;
	gchar buffer[MAX_BUFFER];
	gint i;
	
	
	window1 = gtk_window_new (GTK_WINDOW_TOPLEVEL);
	gtk_window_set_transient_for(GTK_WINDOW(window1), parent);
	gtk_window_set_position(GTK_WINDOW(window1), GTK_WIN_POS_CENTER_ON_PARENT);
	gtk_window_set_modal(GTK_WINDOW(window1), TRUE);
	gtk_window_set_default_size(GTK_WINDOW(window1), 500, 300);
	gtk_window_set_position(GTK_WINDOW(window1), GTK_WIN_POS_CENTER_ON_PARENT);
	gtk_container_set_border_width (GTK_CONTAINER (window1), 6);
	
	vbox1 = gtk_vbox_new (FALSE, 12);
	gtk_widget_show (vbox1);
	gtk_container_add (GTK_CONTAINER (window1), vbox1);
	gtk_container_set_border_width (GTK_CONTAINER (vbox1), 6);
	
	hbox1 = gtk_hbox_new (FALSE, 12);
	gtk_widget_show (hbox1);
	gtk_box_pack_start (GTK_BOX (vbox1), hbox1, FALSE, TRUE, 0);
	
	label1 = gtk_label_new (_("Buscar:"));
	gtk_widget_show (label1);
	gtk_box_pack_start (GTK_BOX (hbox1), label1, FALSE, FALSE, 0);
	
	entry1 = gtk_entry_new ();
	gtk_widget_show (entry1);
	gtk_box_pack_start (GTK_BOX (hbox1), entry1, TRUE, TRUE, 0);
	
	scrolledwindow1 = gtk_scrolled_window_new (NULL, NULL);
	gtk_widget_show (scrolledwindow1);
	gtk_box_pack_start (GTK_BOX (vbox1), scrolledwindow1, TRUE, TRUE, 0);
	gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow1), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
	
	store1 = gtk_list_store_new(1, G_TYPE_STRING);
	store2 = gtk_list_store_new(1, G_TYPE_STRING);
	
	treeview1 = gtk_tree_view_new_with_model(GTK_TREE_MODEL(store1));
	cel = gtk_cell_renderer_text_new();
	col = gtk_tree_view_column_new_with_attributes("", GTK_CELL_RENDERER(cel), "text", 0, NULL);
	gtk_tree_view_append_column(GTK_TREE_VIEW(treeview1), GTK_TREE_VIEW_COLUMN(col));
	
	gtk_widget_show (treeview1);
	
	/*******************************************************************/  
	
	g_snprintf(buffer, MAX_BUFFER, "SELECT cuenta, nombre FROM PGC%d ORDER BY 1", gconta_main.year);
	cmd = gda_command_new(buffer, GDA_COMMAND_TYPE_SQL, GDA_COMMAND_OPTION_STOP_ON_ERRORS);
	data = gda_connection_execute_single_command (gconta_main.conn, cmd, NULL);
	gda_command_free(cmd);
	for (i = 0; i < gda_data_model_get_n_rows (data); i++) {
		v = (GdaValue *) gda_data_model_get_value_at(data, 0, i);
		string1 = gda_value_stringify(v);
		v = (GdaValue *) gda_data_model_get_value_at(data, 1, i);
		string2 = gda_value_stringify(v);
		g_snprintf(buffer, MAX_BUFFER, "(%s) %s", string1, string2);
		gtk_list_store_append(store2, &iter);
		gtk_list_store_set(store2, &iter, 0, buffer, -1);
		g_free(string1);
		g_free(string2);
	}
	g_object_unref(G_OBJECT(data));
	
	/*******************************************************************/  
	
	gtk_container_add (GTK_CONTAINER (scrolledwindow1), treeview1);
	gtk_tree_view_set_headers_visible (GTK_TREE_VIEW (treeview1), FALSE);
	gtk_tree_view_set_rules_hint (GTK_TREE_VIEW (treeview1), TRUE);
	
	g_object_set_data (G_OBJECT(window1), "entry1", entry1);
	g_object_set_data (G_OBJECT(window1), "store1", store1);
	g_object_set_data (G_OBJECT(window1), "store2", store2);
	g_object_set_data (G_OBJECT(window1), "treeview1", treeview1);
	g_object_set_data (G_OBJECT(window1), "parent", parent);
	
	g_signal_connect((gpointer) window1, "key-press-event",
					G_CALLBACK(gconta_busca_cuenta_tecla), window1);
	g_signal_connect((gpointer) treeview1, "button-press-event",
					G_CALLBACK(gconta_busca_cuenta_boton), window1);
	g_signal_connect((gpointer) entry1, "changed",
					G_CALLBACK(gconta_busca_cuenta_editado), window1);
	g_signal_emit_by_name(entry1, "changed");
	
	gtk_widget_show(window1);
	return window1;
}

int
gconta_analiza(gchar *buffer)
{
	gint pos, p;
	gboolean error;
	gchar sal[15];
	
	error = FALSE;
	pos = 0;
	p = 0;
	
	if (buffer != NULL && buffer[pos++] == '(') {
		if (g_ascii_isdigit(buffer[pos])) {
			while (g_ascii_isdigit(buffer[pos])) {
				sal[p] = buffer[pos];
				p++;
				pos++;
			}
			sal[p] = '\0';
			if (buffer[pos] == ')' && p >= 3) 
				return (gint) g_strtod(sal, NULL);
		}
	}
	
	return 0;
}

GtkWidget *
gconta_get_child(gpointer window)
{
	GtkNotebook *nb;
	GtkWidget *child;
	gint n;
	
	nb = g_object_get_data (window, "notebook");
	n = gtk_notebook_get_current_page (nb);
	child = gtk_notebook_get_nth_page (nb, n);
	
	return child;
}

gdouble
gconta_saldo(gint cuenta, gboolean recur, gchar *fecha)
{
	GdaCommand *cmd;
	GdaDataModel *data;
	GdaValue *v;
	gchar buffer[MAX_BUFFER];
	gint i, n;
	gdouble saldo;
	gchar *aux = NULL, *txt;

	saldo = 0.0;
	if (fecha == NULL) aux = "";
	
	if (cuenta >= 100) {
		// Calcular el Debe de la cuenta
		g_snprintf(buffer, MAX_BUFFER, "SELECT SUM(cuantia) FROM (DIARIO_DEBE%d AS DD INNER JOIN "
			"DIARIO%d AS D ON DD.asiento = D.asiento) WHERE DD.cuenta = %d %s", gconta_main.year,
			gconta_main.year, cuenta, aux);
		cmd = gda_command_new (buffer, GDA_COMMAND_TYPE_SQL, GDA_COMMAND_OPTION_STOP_ON_ERRORS);
		data = gda_connection_execute_single_command (gconta_main.conn, cmd, NULL);
		gda_command_free (cmd);
		if (data == NULL)
		{
			gconta_errores ();
			return 0.0;
		}
		v = (GdaValue *) gda_data_model_get_value_at(data, 0, 0);
		if (v != NULL && !gda_value_is_null(v)) {
			txt = gda_value_stringify(v);
			saldo -= g_ascii_strtod(txt, NULL);
			g_free(txt);
		}
		g_object_unref(G_OBJECT(data));
	
		// Calcular el Haber de la cuenta
		g_snprintf(buffer, MAX_BUFFER, "SELECT SUM(cuantia) FROM (DIARIO_HABER%d AS DH INNER JOIN "
			"DIARIO%d AS D ON DH.asiento = D.asiento) WHERE DH.cuenta = %d %s", gconta_main.year,
			gconta_main.year, cuenta, aux);
		cmd = gda_command_new (buffer, GDA_COMMAND_TYPE_SQL, GDA_COMMAND_OPTION_STOP_ON_ERRORS);
		data = gda_connection_execute_single_command (gconta_main.conn, cmd, NULL);
		gda_command_free (cmd);
		if (data == NULL)
		{
			gconta_errores ();
			return 0.0;
		}
		v = (GdaValue *) gda_data_model_get_value_at(data, 0, 0);
		if (v != NULL && !gda_value_is_null(v)) {
			txt = gda_value_stringify(v);
			saldo += g_ascii_strtod(txt, NULL);
			g_free(txt);
		}
		g_object_unref(G_OBJECT(data));
	
		// Calcular cual es el saldo total sumando los saldos de sus subcuentas
		if (recur) {
			g_snprintf(buffer, MAX_BUFFER, "SELECT cuenta FROM PGC%d WHERE padre = %d", gconta_main.year, cuenta);
			cmd = gda_command_new (buffer, GDA_COMMAND_TYPE_SQL, GDA_COMMAND_OPTION_STOP_ON_ERRORS);
			data = gda_connection_execute_single_command (gconta_main.conn, cmd, NULL);
			gda_command_free (cmd);
			if (data == NULL) {
				gconta_errores ();
				return 0.0;
			}
			for(i = 0; i < gda_data_model_get_n_rows(data); i++) {
				v = (GdaValue *) gda_data_model_get_value_at(data, 0, i);
				n = gda_value_get_integer(v);
				saldo += gconta_saldo(n, TRUE, fecha);
			}
	
		}
		
		// Si saldo < 0 --> deudor
		// Si saldo > 0 --> acreedor
	} else {
		// Saldo de un subgrup p.e. 43
		g_snprintf(buffer, MAX_BUFFER, "SELECT cuenta FROM PGC%d "
				"WHERE cuenta >= %d and cuenta < %d",
				gconta_main.year, cuenta * 10, (cuenta + 1) * 10);
		cmd = gda_command_new (buffer, GDA_COMMAND_TYPE_SQL, GDA_COMMAND_OPTION_STOP_ON_ERRORS);
		data = gda_connection_execute_single_command (gconta_main.conn, cmd, NULL);
		gda_command_free (cmd);
		if (data == NULL) {
			gconta_errores ();
			return 0.0;
		}
		for(i = 0; i < gda_data_model_get_n_rows(data); i++) {
			v = (GdaValue *) gda_data_model_get_value_at(data, 0, i);
			n = gda_value_get_integer(v);
			saldo += gconta_saldo(n, TRUE, fecha);
		}
	}
	
	
	
	
	
	
	
	return saldo;
}


void
gconta_seleccionar_fecha (GtkButton * b, gpointer entry)
{
	GtkWidget *window1;
	GtkWidget *calendar1;
	GDate *fecha;
	
	fecha = g_object_get_data (G_OBJECT (entry), "fecha");
	window1 = gtk_window_new (GTK_WINDOW_TOPLEVEL);
	gtk_window_set_title (GTK_WINDOW (window1),
			      _("Seleccione una fecha"));
	gtk_window_set_transient_for (GTK_WINDOW (window1),
				      GTK_WINDOW(gtk_widget_get_toplevel(GTK_WIDGET(entry))));
	gtk_window_set_modal (GTK_WINDOW (window1), TRUE);
	gtk_window_set_position (GTK_WINDOW (window1),
				 GTK_WIN_POS_CENTER_ON_PARENT);
	gtk_window_set_type_hint (GTK_WINDOW (window1),
				  GDK_WINDOW_TYPE_HINT_DIALOG);
	calendar1 = gtk_calendar_new ();
	gtk_calendar_select_month (GTK_CALENDAR (calendar1),
				   g_date_get_month (fecha) - 1,
				   g_date_get_year (fecha));
	gtk_calendar_select_day (GTK_CALENDAR (calendar1),
				 g_date_get_day (fecha));
	gtk_widget_show (calendar1);
	gtk_container_add (GTK_CONTAINER (window1), calendar1);
	gtk_calendar_display_options (GTK_CALENDAR (calendar1),
				      GTK_CALENDAR_SHOW_HEADING |
				      GTK_CALENDAR_SHOW_DAY_NAMES);
	gtk_widget_grab_focus (calendar1);
	g_signal_connect (window1, "key-press-event",
			  G_CALLBACK (gconta_seleccionar_fecha_tecla),
			  window1);
	g_signal_connect (calendar1, "day-selected",
			  G_CALLBACK (gconta_seleccionar_fecha_selec), entry);
	g_signal_connect (calendar1, "day-selected-double-click",
			  G_CALLBACK (gconta_seleccionar_fecha_salir),
			  window1);
	gtk_widget_show (window1);
}

void
gconta_seleccionar_fecha_selec (GtkCalendar * c, gpointer entry)
{
	guint d, m, y;
	gchar buffer[15];
	GDate *date;
	
	date = g_object_get_data (G_OBJECT (entry), "fecha");
	gtk_calendar_get_date (c, &y, &m, &d);
	g_snprintf (buffer, MAX_BUFFER, "%d-%d-%d", y, m + 1, d);
	g_date_set_parse (date, buffer);
	g_date_strftime (buffer, 11, "%d/%m/%y", date);
	gtk_entry_set_text (GTK_ENTRY(entry), buffer);
}

gboolean
gconta_seleccionar_fecha_tecla (GtkWidget * widget,
			       GdkEventKey * event, gpointer window)
{
	if (event->keyval == GDK_Escape)
	{
		gtk_widget_destroy (widget);
		return TRUE;
	}

	return FALSE;
}

void
gconta_seleccionar_fecha_salir (GtkWidget * cal, gpointer window1)
{
	gtk_widget_destroy (GTK_WIDGET (window1));
}


GDate *
gconta_date_today(GtkWidget *entry)
{
	GDate *date;
	gchar buffer[11];
	// Pillar la fecha actual
	
	date = g_date_new();
	g_date_set_time (date, time (NULL));
	g_date_strftime(buffer, 11, "%d/%m/%y", date);
	gtk_entry_set_text(GTK_ENTRY(entry), buffer);
	
	return date;
}

gchar *
gconta_uri(const gchar * file)
{
	gchar buffer[MAX_BUFFER];
	
	g_snprintf(buffer, MAX_BUFFER, "%s%d", gconta_main.alias, gconta_main.year);
	return g_build_filename(g_get_home_dir(), G_DIR_SEPARATOR_S, ".gconta",
			G_DIR_SEPARATOR_S, buffer, G_DIR_SEPARATOR_S, file, NULL);
}


void
gconta_barra_cerrar(gpointer window)
{
	gint i;
	GtkWidget *child;
	GtkWidget *bar;
	GtkWidget *image1;
	GtkNotebook *nb;
	gchar *file;

	nb = g_object_get_data(G_OBJECT(window), "notebook");
	
	i = gtk_notebook_get_current_page(GTK_NOTEBOOK(nb));
	child = gtk_notebook_get_nth_page(nb, i);
	bar = g_object_get_data(G_OBJECT(child), "barra");
	gtk_widget_unref(bar);
	
	if (gtk_notebook_get_n_pages(nb) == 1) {
		file = gconta_uri("logo.jpg");		
		image1 = gtk_image_new_from_file(file);
		g_free(file);		
		gtk_widget_show(image1);
		gtk_notebook_append_page(nb, image1, NULL);
		gtk_notebook_set_show_tabs(nb, FALSE);
	}
	
	gtk_notebook_remove_page(nb, i);
}

gint
gconta_nonquery(gchar *buffer, gchar *error_msg, GdaTransaction *trans)
{
	GtkWidget *dialog;
	GdaCommand *cmd;
	gint n;
	
	cmd = gda_command_new(buffer, GDA_COMMAND_TYPE_SQL, GDA_COMMAND_OPTION_STOP_ON_ERRORS);
	if (trans != NULL) gda_command_set_transaction (cmd, trans);
	n = gda_connection_execute_non_query(gconta_main.conn, cmd, NULL);
	gda_command_free(cmd);
	if (n == -1)
	{
		if (trans != NULL) {
			gda_connection_rollback_transaction (gconta_main.conn, trans);
			g_object_unref (trans);
		}
		gconta_errores ();
		dialog = create_dialog (error_msg, TRUE);
		gtk_dialog_run (GTK_DIALOG (dialog));
		gtk_widget_destroy (dialog);
	}
	return n;
}



gchar **
gconta_cortar_frase (GnomeFont *font, gdouble size, gchar *txt)
{
	GString *st;
	gchar **buffer;
	gint tam, i, i_blanco = 0;
	gboolean blanco;
	
	tam = 1;
	buffer = NULL;	
	for(i = 0; i < strlen(txt); i++) {
		st = g_string_new("");
		tam++;
		buffer = g_realloc(buffer, tam * sizeof(gchar *)) ;
		buffer[tam - 1] = NULL;
		blanco = FALSE;
		while(i < strlen(txt) && gnome_font_get_width_utf8(font, st->str) < size) {
			if (txt[i] == ' ') {
				i_blanco = i;
				blanco = TRUE;
			}
			st = g_string_append_c(st, txt[i]);
			i++;
		}
		if (blanco && i < strlen(txt)) {
			st = g_string_truncate(st, st->len - (i - i_blanco));
			i = i_blanco;
		} else i--;
		buffer[tam - 2] = g_strdup(st->str);
		g_string_free(st, TRUE);
	}
	
	return buffer;
}


gint
gconta_poner_texto(gconta_print *gp,
			GnomeFont *font,
			gdouble x,
			gdouble size,
			gint just,
			gchar *txt)
{
	gdouble xx, xf, y;
	gchar **texto;
	gint i;
	
	y = gp->y;
	i = 0;
	texto = gconta_cortar_frase(font, size, txt);
	while (texto[i] != NULL) {
		xf = gnome_font_get_width_utf8(font, texto[i]);
		switch (just) {
		case -1:
			xx = i ? x + 10: x;
			gnome_print_moveto(gp->gpc, xx, y);
			gnome_print_show(gp->gpc, texto[i]);
			break;
		case 0:
			xx = x + (size - xf) / 2;
			gnome_print_moveto(gp->gpc, xx, y);
			gnome_print_show(gp->gpc, texto[i]);
			break;
		case 1:
			xx = x + (size - xf);
			gnome_print_moveto(gp->gpc, xx, y);
			gnome_print_show(gp->gpc, texto[i]);
			break;
		}
		i++;
		y -= gnome_font_get_size(font);
	}
	g_strfreev(texto);
	
	return i;
}

void
gconta_cabecera_empresa(gconta_print *gp, gchar *document)
{
	GnomeFont *font;
	gdouble wf;
	gchar *txt;
	gchar **textos;
	gint i;
	
	font = gnome_font_find_closest ("Sans Bold", 20);
	wf = gnome_font_get_size(font);
	gnome_print_setfont (gp->gpc, font);
	txt = g_strdup_printf("%s", gconta_main.nombre_empresa);
	gnome_print_moveto (gp->gpc, gp->margen, gp->y - wf);
	gp->y -= wf + 10;
	gnome_print_show (gp->gpc, txt);
	g_free(txt);
	g_object_unref (G_OBJECT (font));
	
	font = gnome_font_find_closest ("Sans Regular", 12);
	wf = gnome_font_get_size(font);
	gnome_print_setfont (gp->gpc, font);
	textos = g_strsplit(gconta_main.descripcion, "\n", 0);
	i = 0;
	while(textos[i] != NULL) {
		gnome_print_moveto (gp->gpc, gp->margen, gp->y - wf);
		gp->y -= wf;
		gnome_print_show (gp->gpc, textos[i]);
		i++;
	}
	g_strfreev(textos);
	gp->y -= 4 * wf;
	g_object_unref (G_OBJECT (font));
	
	font = gnome_font_find_closest ("Sans Italic", 12);
	wf = gnome_font_get_size(font);
	gnome_print_setfont (gp->gpc, font);
	gp->y -= wf + wf * gconta_poner_texto(gp, font, gp->margen, gp->xsize - gp->margen * 2, 0, document);
	g_object_unref (G_OBJECT (font));
}

void
gconta_imprimir_dialog(GnomePrintJob *job, gchar *tittle)
{
	GtkWidget *dialog;
	
	dialog = gnome_print_dialog_new(job, tittle, 0);
	g_signal_connect(G_OBJECT(dialog), "response", G_CALLBACK (gconta_imprimir_response), job);
	gtk_widget_show(dialog);
}

void
gconta_imprimir_response (GtkWidget *dialog, int response, GnomePrintJob *job)
{
	GtkWidget *wp;
	
	switch (response)
	{
		case GNOME_PRINT_DIALOG_RESPONSE_PRINT:
			gnome_print_job_print(job);
			gtk_widget_destroy (dialog);
			g_object_unref(G_OBJECT(job));
			break;
			
		case GNOME_PRINT_DIALOG_RESPONSE_PREVIEW:
			gtk_widget_hide(dialog);
			wp = gnome_print_job_preview_new(job, "Informe");
			gtk_widget_show(wp);
			g_signal_connect(wp, "destroy", G_CALLBACK(gconta_imprimir_preview_exit), dialog);
			break;

		default:
			gtk_widget_destroy (dialog);
			g_object_unref(G_OBJECT(job));
			return;
	}
}

gboolean
gconta_imprimir_preview_exit(GtkWidget *wp, GtkWidget *dialog)
{
	gtk_widget_show(dialog);	
	return FALSE;
}

void
gconta_about_exit(GtkButton *b, GtkWidget *window)
{
	gtk_widget_destroy(window);
}

void
gconta_about (GtkMenuItem *i, gpointer window)
{
  GtkWidget *window1;
  GtkWidget *hbox1;
  GtkWidget *vbox1;
  GtkWidget *image1;
  GtkWidget *label1;
  GtkWidget *label2;
  GtkWidget *hbuttonbox1;
  GtkWidget *button1;

  window1 = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_container_set_border_width (GTK_CONTAINER (window1), 12);
  gtk_window_set_title (GTK_WINDOW (window1), _("Sobre gconta"));
  gtk_window_set_resizable (GTK_WINDOW (window1), FALSE);
  gtk_window_set_position (GTK_WINDOW(window1), GTK_WIN_POS_CENTER);
	
  hbox1 = gtk_hbox_new (FALSE, 12);
  gtk_widget_show (hbox1);
  gtk_container_add (GTK_CONTAINER (window1), hbox1);

  image1 = gtk_image_new_from_file (DATA_PREFIX "/sello.gif");
  gtk_widget_show (image1);
  gtk_box_pack_start (GTK_BOX (hbox1), image1, TRUE, TRUE, 0);

  vbox1 = gtk_vbox_new (FALSE, 12);
  gtk_widget_show (vbox1);
  gtk_box_pack_start (GTK_BOX (hbox1), vbox1, FALSE, FALSE, 0);

  label1 = gtk_label_new (_("<span size=\"xx-large\" weight=\"bold\">" PACKAGE_STRING "</span>"));
  gtk_widget_show (label1);
  gtk_box_pack_start (GTK_BOX (vbox1), label1, FALSE, FALSE, 0);
  gtk_label_set_use_markup (GTK_LABEL (label1), TRUE);

  label2 = gtk_label_new (_("gconta es un sistema gestor\nde informaci\303\263n contable\n\n<span size=\"small\">http://www.uhu.es/josel_alvarez\nProfesor: Jos\303\251 Luis \303\201lvarez Mac\303\255as\nAlumno: Bruno Orcha Garc\303\255a</span>"));
  gtk_widget_show (label2);
  gtk_box_pack_start (GTK_BOX (vbox1), label2, FALSE, FALSE, 0);
  gtk_label_set_use_markup (GTK_LABEL (label2), TRUE);
  gtk_label_set_justify (GTK_LABEL (label2), GTK_JUSTIFY_CENTER);

  hbuttonbox1 = gtk_hbutton_box_new ();
  gtk_widget_show (hbuttonbox1);
  gtk_box_pack_start (GTK_BOX (vbox1), hbuttonbox1, FALSE, TRUE, 0);
  gtk_button_box_set_layout (GTK_BUTTON_BOX (hbuttonbox1), GTK_BUTTONBOX_SPREAD);

  button1 = gtk_button_new_from_stock ("gtk-close");
  gtk_widget_show (button1);
  gtk_container_add (GTK_CONTAINER (hbuttonbox1), button1);
  GTK_WIDGET_SET_FLAGS (button1, GTK_CAN_DEFAULT);

  gtk_widget_show(window1);
  g_signal_connect(window1, "destroy", G_CALLBACK(gtk_widget_destroy), NULL);
  g_signal_connect(button1, "clicked", G_CALLBACK(gconta_about_exit), window1);
}
