/*
 * principal.h
 * This file is part of gconta
 *
 * Copyright (C) 2004 Bruno Orcha Garcia
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, 
 * Boston, MA 02111-1307, USA. 
 */

#ifndef _PRINCIPAL_H_
#define _PRINCIPAL_H_

#include <stdio.h>
#include <string.h>
#include <gtk/gtk.h>
#include <gdk/gdkkeysyms.h>
#include <libgda/libgda.h>
#include <glib/gprintf.h>
//#include <string.h>
#include <libgnomeprint/gnome-print.h>
#include <libgnomeprint/gnome-print-job.h>
#include <libgnomeprintui/gnome-print-dialog.h>
#include <libgnomeprintui/gnome-print-job-preview.h>


//#define _(string) string
#define MAX_BUFFER 1024
#define GOBJ_SDATA(component, widget, name) \
	g_object_set_data_full (G_OBJECT (component), name, \
   	gtk_widget_ref (widget), (GDestroyNotify) gtk_widget_unref)
#define GCONTA_nonquery(a, b, c) if (gconta_nonquery(a, b, c) == -1) return

typedef struct {
	GnomePrintContext *gpc;
	gdouble xsize;
	gdouble ysize;
	gdouble y;
	gdouble y1;
	gdouble y2;
	gdouble margen;
	gint page;
} gconta_print;

GtkWidget * crear_menu (GtkWidget *window);
GtkWidget * create_window1 (void);
void gconta_errores ();
gboolean gconta_conectar ();
gboolean gconta_conectado ();

GtkWidget* create_dialog (gchar *text, gboolean info);
gboolean gconta_busca_cuenta_boton (GtkWidget *widget, GdkEventButton *event, gpointer window);
gboolean gconta_busca_cuenta_tecla (GtkWidget *widget, GdkEventKey *event, gpointer user_data);
gboolean gconta_busca_cuenta_compara	(GtkTreeModel *model, GtkTreePath *path, GtkTreeIter *iter2, gpointer data);
void gconta_busca_cuenta_editado (GtkWidget *entry, gpointer window);
GtkWidget* gconta_busca_cuenta (GtkWindow *padre);
int gconta_analiza(gchar *buffer);
gdouble gconta_saldo(gint cuenta, gboolean recur, gchar *fecha);

GtkWidget * gconta_get_child(gpointer window);

void gconta_seleccionar_fecha (GtkButton * b, gpointer entry);
void gconta_seleccionar_fecha_selec (GtkCalendar * c, gpointer entry);
gboolean gconta_seleccionar_fecha_tecla (GtkWidget * widget,	GdkEventKey * event, gpointer window);
void gconta_seleccionar_fecha_salir (GtkWidget * cal, gpointer window1);

GDate * gconta_date_today(GtkWidget *entry);
gchar * gconta_uri(const gchar * file);
void gconta_barra_cerrar(gpointer window);

gint gconta_nonquery (gchar *buffer, gchar *error_msg, GdaTransaction *trans);

gchar ** gconta_cortar_frase (GnomeFont *font, gdouble size, gchar *txt);
gint gconta_poner_texto(gconta_print *gp,
			GnomeFont *font,
			gdouble x,
			gdouble size,
			gint just,
			gchar *txt);
void gconta_cabecera_empresa(gconta_print *gp, gchar *document);
void gconta_imprimir_dialog(GnomePrintJob *job, gchar *tittle);
void gconta_imprimir_response (GtkWidget *dialog, int response, GnomePrintJob *job);
gboolean gconta_imprimir_preview_exit(GtkWidget *wp, GtkWidget *dialog);
void gconta_about (GtkMenuItem *i, gpointer window);

struct {
	gchar * nombre_empresa;
	gchar * alias;
	gchar * gda_source;
	gchar * descripcion;
	GDate * ejercicio_ini;
	GDate * ejercicio_fin;
	gint year; // Año del ejercicio
	
	GtkWidget * error_dialog;
	GdaConnection * conn;
	GdaClient * cli;
	gboolean conectado;
} gconta_main;


#include "callbacks.h"
#endif
