/*
 * xml.h
 * This file is part of gconta
 *
 * Copyright (C) 2004 Bruno Orcha Garcia
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, 
 * Boston, MA 02111-1307, USA. 
 */

#ifndef _XML_H_
#define _XML_H_

#include <gtk/gtk.h>
#include <libxml/parser.h>
#include <libxml/xmlmemory.h>
#include <glib/gprintf.h>
#include <glib.h>
#include "pgc.h"
#include "diario.h"



xmlDocPtr xml_abrir(gchar *nombre);

void xml_pgc_modos(GtkListStore* store);
void xml_pgc_modos_cargar_nodos(GtkTreeStore *store, xmlNodePtr cur, GtkTreeIter *iter_parent);
void xml_pgc_modos_cargar(GtkTreeStore *store, gchar *nombre);

void xml_diario_predefinidos (GtkListStore* store);
void xml_diario_predefinidos_llenar(GList **ts, GList **tp, gchar *nombre);
void xml_diario_predefinidos_llenar_nodos(GList **ts, GList **tp, xmlNodePtr cur);
void xml_consultas_cuenta(gchar *cuenta, gchar **nombre, gchar **descripcion);

gchar * xml_empresa_nombre(const gchar *l);
gint xml_cargar_gconta_main(gchar *alias);
void xml_cargar_pgc(gint year);

void xml_informes (GtkListStore* store);
void xml_informes_llenar(GList **inf, gchar *nombre);
void xml_informes_llenar_nodos(GList **page, xmlNodePtr cur);

#endif
